SystemOrganization addCategory: #'Magma server-API'!
SystemOrganization addCategory: #'Magma server-Info'!
SystemOrganization addCategory: #'Magma server-Utilities'!
SystemOrganization addCategory: #'Magma server-private'!
SystemOrganization addCategory: #'Magma server-Recovery'!
SystemOrganization addCategory: #'Magma server-Preferences'!
SystemOrganization addCategory: #'Magma server-recovery'!
SystemOrganization addCategory: #'Magma server-Exceptions'!

!MaLargeArrayOfRecords methodsFor: '*magma server-recovery' stamp: 'cmm 6/5/2005 18:24'!
unapplyUsing: aMaApplyRecord

	broker unapplyUsing: aMaApplyRecord! !

!MagmaCollectionChanges methodsFor: '*magma server' stamp: 'cmm 3/16/2005 15:13'!
requiresServerRefresh

	^ super requiresServerRefresh
		or: [ self hasAddedIndexes 
		or: [ self hasRemovedIndexes ] ]! !

MaError subclass: #MaUnreadableRecoveryRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Exceptions'!

!MaVariableWordBuffer methodsFor: '*magma server' stamp: 'cmm 1/25/2005 14:07'!
appendGraphUsing: aMaReadStrategy into: aMaSerializedGraphBuffer currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	"Nothing to do for a variable-word object."! !

!MaVariableWordBuffer methodsFor: '*magma server' stamp: 'cmm 5/1/2005 23:05'!
graphDo: oneArgBlock using: aMaReadStrategy for: aMagmaFileTraverser inDefinition: aBoolean

	"nothing to do for a word-object buffer."! !

!MagmaCollection methodsFor: '*magma server' stamp: 'cmm 7/12/2005 12:52'!
implementationClass

	^ MaHashIndex! !

!MagmaCollection methodsFor: '*magma server' stamp: 'cmm 3/17/2005 21:31'!
newManagerUsing: aMaObjectRepository

	^ (MagmaCollectionManager
		collection: self
		repository: aMaObjectRepository)
			oidOfIndexesCollection: (aMaObjectRepository session oidFor: self indexes) ;
			yourself! !

!MaSerializedGraphBuffer methodsFor: '*magma server' stamp: 'cmm 8/13/2002 21:27'!
decreaseBufferSizeBy: anInteger

	self bufferSize: self bufferSize - anInteger
! !

MaObject subclass: #MagmaCompressionResult
	instanceVariableNames: 'unreferencedClasses unreferencedMagmaCollections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Utilities'!

!MagmaCompressionResult methodsFor: 'as yet unclassified' stamp: 'cmm 8/21/2002 21:44'!
unreferencedClasses

	^unreferencedClasses! !

!MagmaCompressionResult methodsFor: 'as yet unclassified' stamp: 'cmm 8/21/2002 21:45'!
unreferencedClasses: aCollection

	unreferencedClasses _ aCollection! !

!MagmaCompressionResult methodsFor: 'as yet unclassified' stamp: 'cmm 8/21/2002 21:45'!
unreferencedMagmaCollections

	^unreferencedMagmaCollections! !

!MagmaCompressionResult methodsFor: 'as yet unclassified' stamp: 'cmm 8/21/2002 21:45'!
unreferencedMagmaCollections: aCollection

	unreferencedMagmaCollections _ aCollection! !

MaObject subclass: #MagmaCompressor
	instanceVariableNames: 'inputController outputController referencedCollections referencedClasses classIdMap result sourceDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Utilities'!

!MagmaCompressor commentStamp: 'cmm 8/29/2002 22:35' prior: 0!
I garbage collect a Magma repository and output a smaller file by eliminating buffers no longer referenced from the root buffer.

I always create a new object file, but if you use compressAndRename, I'll rename the source files to 'old...' so you can get with using the compressed repository right away.

If you don't want me to rename, just use #compressTo:.

Oh, and I'm not meant to work while the files are on-line.  For that, use:

	yourRepositoryController garbageCollect

(Note:  a potential strategy for on-line GC would be to set a boolean flag indicating to the filer not to reuse buffers made available through grown objects, but rather to always add to the end.  During this time, a background thread can start reading from the root and build a new copy of the 'memory' map (the MaIntervalCollection).  Once it has accounted for every byte in the real memory map, we know the real one can be replaced with this new one.  Do a quick write of the new memory map and you're done!!)!

!MagmaCompressor class methodsFor: 'creation' stamp: 'cmm 9/24/2004 16:49'!
inputController: aMagmaRepositoryController
	"NOT YET SUPPORTED.  The premise of this is that you can compress a running repository, but it is not complete.  Do not use!!"
	^self new inputController: aMagmaRepositoryController! !

!MagmaCompressor class methodsFor: 'creation' stamp: 'cmm 9/24/2004 16:49'!
source: pathString

	^self new sourceDirectory: (FileDirectory on: pathString)! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 2/28/2005 15:38'!
buildClassIdMap
	"This should normally not be necessary.  But if Magma has been modified where an object is added to the repository definition, it's possible the initial class ids will not match.  This method builds a map of oldId->newId used when we write the new buffers."

	| inputClassMap outputClassMap |
	classIdMap _ Dictionary new.
	inputController requestCritical:
		[ inputClassMap _ inputController definition classDefinitions copy.
	outputClassMap _ outputController definition classDefinitions copy.
	inputClassMap keysAndValuesDo:
		[ : eachId : eachVersions |  | className |
		className _ (inputClassMap at: eachId) last className.
		"if output has consumed id for different class"
		((outputClassMap includesKey: eachId)
		and: [ (outputClassMap at: eachId) first className ~= eachVersions first className ])
			ifTrue:
				[ "try to find corresponding class-id in output, otherwise assign a new one."
				classIdMap
					at: eachId
					put:
						(outputClassMap
							maDetect: [ : eachDefinitions | eachDefinitions last className = className ]
							ifFound: [ : foundDefinitions | foundDefinitions last id ]
							ifNone: [ self nextAvailableClassId ]) ] ] ].
	classIdMap keysAndValuesDo:
		[ :eachOld :eachNew |
		MagmaNotification signal:
			'converting classId ', eachOld printString, 
			' to ', eachNew printString ]! !

!MagmaCompressor methodsFor: 'compress' stamp: 'cmm 2/28/2005 12:18'!
compressTo: outputDirectory

	| shouldCloseInput |
	shouldCloseInput _ inputController isNil.
	inputController ifNil: [ self openInput ].
	self
		createOutput: outputDirectory;
		openOutput: outputDirectory;
		ensureNoOidReuse ;
		buildClassIdMap;
		copyPrimitiveAttributes;
		writeGraphs ;
		copyMagmaCollections.
	outputController close.
	self removeUnreferencedCollectionsAndClasses: outputDirectory.
	shouldCloseInput ifTrue: [ inputController close ].
	^result
		unreferencedClasses: self unreferencedClasses;
		unreferencedMagmaCollections: self unreferencedMagmaCollections;
		yourself! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 6/14/2005 12:28'!
copyMagmaCollections

	inputController repository largeCollectionManagers do:
		[ : each |
		(referencedCollections includes: each collectionOid)
			ifTrue:
				[ each filenames do:
					[ : eachMcFilename |
					inputController directory
						maCopyFileNamed: eachMcFilename
						toDirectory: outputController directory ] ] ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 1/12/2005 21:13'!
copyPrimitiveAttributes

	| inputFiler outputFiler |
	inputFiler _ inputController repository filer.
	outputFiler _ outputController repository filer.
	inputController requestCritical:
		[ outputFiler
			signature: inputFiler signature ;
			"Even if this is a new version of Magma, the source buffers are still the old version."
			version: inputFiler version ;
			definitionOid: inputFiler definitionOid ;
			classDefinitionsOid: inputFiler classDefinitionsOid ;
			anchorOid: inputFiler anchorOid ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 9/24/2004 12:24'!
createOutput: aString

	MagmaRepositoryController create: aString! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 6/8/2005 20:06'!
ensureNoOidReuse
	"We can never allow an oid to be reused.  Once an object is created and persisted, its oid must be forever consumed.  Even if that object is later dereferenced, its oid will never be reused.  This is necessary to properly support universal-identity which is essential for MagmaForwardingProxys."

	| highestOid |
	"determine the next oid to be used in our inputController."
	highestOid _ (inputController repository filer getNextOid) - 1.
	"Force our output controller to allocate up to the current oid."
	outputController repository filer
		index: highestOid
		at: 0! !

!MagmaCompressor methodsFor: 'initialize-release' stamp: 'cmm 12/24/2002 15:51'!
initialize
	super initialize.
	referencedClasses := Set new.
	referencedCollections := Set new.
	result := MagmaCompressionResult new! !

!MagmaCompressor methodsFor: 'initialize-release' stamp: 'cmm 8/17/2002 15:25'!
inputController: aMagmaRepositoryController

	inputController _ aMagmaRepositoryController! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 5/2/2005 19:16'!
markClassReferenced: aMaObjectBuffer 
	| classIdManager |
	classIdManager := inputController session serializer classIdManager.
	(classIdManager 
		definitionForClassId: aMaObjectBuffer classId
		version: aMaObjectBuffer classVersion) 
		withAllSuperclassDefinitionsDo: 
			[ : eachClassDefinition | 
			referencedClasses add: (self newClassIdFor: eachClassDefinition id) ].
	"If a class-reference, be sure to get the referenced class itself."
	(aMaObjectBuffer classId = (classIdManager idForClass: MaClassReference))
		ifTrue:
			[ | indexOfId classReferenceDefinition |
			classReferenceDefinition _
				classIdManager
					definitionForClassId: aMaObjectBuffer classId
					version: aMaObjectBuffer classVersion.
			"Get the index of the 'id' variable."
			indexOfId _ classReferenceDefinition allInstVarNames indexOf: 'id'.
			indexOfId = 0 ifTrue: [ MagmaSoftwareError signal: 'Expected ''id'' variable.' ].
			(classIdManager 
				definitionForClassId:
					(inputController session
						objectWithOid: (aMaObjectBuffer maInstVarAt: indexOfId)
						ifAbsent: [ MagmaSoftwareError signal: 'Expected an to find an id' ])
				version: 1) 

				withAllSuperclassDefinitionsDo: 
					[ : eachClassDefinition | 
					referencedClasses add: (self newClassIdFor: eachClassDefinition id) ] ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 8/22/2002 21:09'!
markCollectionReferenced: oidInteger

	referencedCollections add: oidInteger! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 7/2/2004 00:07'!
newClassIdFor: sourceClassId

	^ classIdMap at: sourceClassId ifAbsent: [ sourceClassId ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 7/1/2004 17:22'!
nextAvailableClassId
	"Answer the lowest commonly-available classId between the input and outputController."

	^ inputController requestCritical:
		[ | inputClassMap outputClassMap |
		inputClassMap _ inputController definition classDefinitions.
		outputClassMap _ outputController definition classDefinitions.
		(inputClassMap keys max max: outputClassMap keys max) + 1 ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 9/24/2004 16:54'!
openInput

	inputController _ MagmaRepositoryController open: sourceDirectory pathName! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 8/14/2002 23:41'!
openOutput: aString

	outputController _ MagmaRepositoryController open: aString! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 2/23/2005 15:04'!
removeUnreferencedCollectionsAndClasses: outputDirectory

	| controller |
	controller _ outputController privateOpen: (FileDirectory on: outputDirectory).
	controller session commit:
		[ controller definition classDefinitions copy
			keysDo: 
				[ :eachId |
				(referencedClasses includes: eachId) ifFalse:
					[ controller definition removeClassWithId: eachId ] ].
		controller definition allLargeCollections copy do:
			[ :eachCollection |
			(referencedCollections includes: (controller session oidFor: eachCollection)) ifFalse:
				[ controller definition removeCollection: eachCollection ] ] ].
	controller close! !

!MagmaCompressor methodsFor: 'initialize-release' stamp: 'cmm 9/24/2004 16:50'!
sourceDirectory: aFileDirectory

	sourceDirectory _ aFileDirectory! !

!MagmaCompressor methodsFor: 'accessing' stamp: 'cmm 7/1/2004 23:35'!
unreferencedClasses

	^ outputController definition classDefinitions reject:
		[ : eachDefinitions |
		referencedClasses includes: eachDefinitions first id ]! !

!MagmaCompressor methodsFor: 'accessing' stamp: 'cmm 7/12/2005 12:58'!
unreferencedMagmaCollections

	| unreferenced |
	unreferenced _ inputController definition allLargeCollections reject: [ :each | referencedCollections includes: (inputController session oidFor: each) ].
	^ unreferenced collect: 
		[ : eachCollection | inputController repository collectionFilenameFor: eachCollection ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 7/13/2005 17:17'!
writeGraphs

	| inputTraverser |
	inputTraverser _ MagmaFileTraverser repositoryController: inputController.
	inputTraverser anchorGraphDo:
		[ : eachBuffer |
		self markClassReferenced: eachBuffer.
		inputTraverser inDefinition ifFalse:
			[ (inputTraverser isOidForLargeCollection: eachBuffer oid)
				ifTrue:
					[ self markCollectionReferenced: eachBuffer oid ] ].
		eachBuffer classId: (self newClassIdFor: eachBuffer classId).
		"If not in a buffer embedded in a MaStorageObjectBuffer..."
		(MaOidCalculator isOidForUserObject: eachBuffer oid)
			ifTrue:
				[ outputController requestCritical:
					[ outputController repository filer
						write: eachBuffer
						index: true ;
						filesDo: [ : eachFile : eachFileId | eachFile maCommit ] ] ] ]! !

MaObject subclass: #MagmaFileTraverser
	instanceVariableNames: 'repositoryController oidsVisited graphBuffer directory inDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Utilities'!

!MagmaFileTraverser commentStamp: 'cmm 8/5/2002 21:45' prior: 0!
I walk the object buffers of an open Magma file and execute a Block for each buffer.

I'm useful for the Magma garbage collection function, the compression function and for general purpose information gathering about what's in the repository.!

!MagmaFileTraverser class methodsFor: 'creation' stamp: 'cmm 9/24/2004 15:56'!
for: pathString

	^ self new 
		directory: (FileDirectory on: pathString) ;
		yourself! !

!MagmaFileTraverser class methodsFor: 'creation' stamp: 'cmm 8/15/2002 22:52'!
repositoryController: aMagmaRepositoryController

	^self new repositoryController: aMagmaRepositoryController! !

!MagmaFileTraverser methodsFor: 'actions' stamp: 'cmm 5/2/2005 10:37'!
anchorGraphDo: aBlock

	self
		graphFrom: (repositoryController requestCritical: [ self repository filer anchorOid ])
		do: aBlock! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 8/21/2002 00:24'!
close

	repositoryController ifNotNil:
		[ repositoryController requestCritical: [ repositoryController close ] ]! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 9/24/2004 16:15'!
deleteOidsVisited

	oidsVisited ifNotNil: [ oidsVisited close ].
	directory deleteFileNamed: self tempOidsVisitedFilename! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 6/14/2005 17:29'!
graphFromLargeCollection: oidInteger do: oneArgBlock using: aMaReadStrategy
	"aMaByteObjectBuffer is for a storageObject.  Therefore enumerate its buffers because its objects are part of the repository too."

	| fileIndex |
	fileIndex _ (repositoryController 
		requestCritical: 
			[ repositoryController repository collectionManagerFor: oidInteger ]) memberIndex.
	MagmaNotification signal: 'beginning enumeration of ', fileIndex size printString, ' objects in MagmaCollection ', oidInteger printString.
	fileIndex
		do: oneArgBlock
		for: self
		using: aMaReadStrategy.
	MagmaNotification signal: 'MagmaCollection enumeration complete:  ', oidInteger printString! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 5/2/2005 12:04'!
graphFromPointers: aMaObjectBuffer do: oneArgBlock using: aMaReadStrategy
	"aMaObjectBuffer isPointers must be true to get here."

	aMaObjectBuffer instVarsDoWithIndex:
		[ :eachOid :index |
		self
			graphFrom: eachOid
			do: oneArgBlock
			using: aMaReadStrategy ]! !

!MagmaFileTraverser methodsFor: 'actions' stamp: 'cmm 5/2/2005 10:37'!
graphFrom: oid do: aBlock
	"Value aBlock against every buffer in the receivers file."

	| readStrategy shouldClose |
	shouldClose _ false.
	repositoryController ifNil: [ shouldClose _ true. self open ].
	readStrategy _ MaBasicReadStrategy minimumDepth: 0.
	MagmaNotification signal: 'Beginning traversal of ', oid printString, ' of ', directory pathName.
	graphBuffer _ repositoryController session serializer graphBuffer copy resetBufferSize; yourself.  "sorry Demeter"
	[ self initializeOidsVisited.
	self
		graphFrom: oid
		do: aBlock
		using: readStrategy ]

		ensure:
			[ shouldClose ifTrue: [ self close ].
			self deleteOidsVisited ].
	MagmaNotification signal: 'Traversal of ', oid printString, ' of ', directory pathName, ' complete.'! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 5/2/2005 10:36'!
graphFrom: oidInteger do: oneArgBlock using: aMaReadStrategy

	| buffer indexPosition |
	(MaOidCalculator isOidForUserObject: oidInteger) ifFalse: [ ^self ].
	indexPosition _ MaOidCalculator indexPositionForOid: oidInteger.
	(oidsVisited at: indexPosition ifAbsent: [ 0 ]) = 0 ifFalse: [ ^self ].
	"Don't enumerate the MagmaCollections referenced from the definition, just the ones referenced from the root, that way we can properly calculate which MagmaCollections are still referenced and which are not."
	(inDefinition and: [ self isOidForLargeCollection: oidInteger ])
		ifFalse:
			[ oidsVisited
				at: indexPosition
				put: oidInteger ].
	repositoryController requestCritical:
		[ buffer _ self repository filer
			appendObject: oidInteger
			into: graphBuffer ].
	oneArgBlock value: buffer.
	(buffer oid = repositoryController repository filer definitionOid) 
		ifTrue: [ inDefinition _ true ].
	buffer
		graphDo: oneArgBlock
		using: aMaReadStrategy
		for: self
		inDefinition: inDefinition.
	buffer oid = repositoryController repository filer definitionOid
		ifTrue: [ inDefinition _ false ].
	graphBuffer decreaseBufferSizeBy: buffer physicalSize! !

!MagmaFileTraverser methodsFor: 'testing' stamp: 'cmm 2/28/2005 13:40'!
inDefinition
	"Answer whether I am currently traversing inside my input-controller's repository-definition."

	^ inDefinition! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 2/28/2005 13:40'!
initialize
	super initialize.
	inDefinition _ false! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 7/12/2005 23:43'!
initializeOidsVisited

	oidsVisited ifNotNil: [ self deleteOidsVisited ].
	oidsVisited _ 
		MaLargeArrayOfNumbers
			createNamed: self tempOidsVisitedFilename
			bitSize: MaObjectFiler maxDbSize! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 3/22/2005 17:55'!
isOidForLargeCollection: oidInteger

	^ self repository largeCollectionManagers includesKey: oidInteger! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 9/24/2004 15:52'!
open
	"Use if you created with just a path, or if you know the MagmaRepositoryController needs opened.."

	repositoryController _ MagmaRepositoryController open: directory pathName! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 8/13/2002 23:29'!
repository

	^repositoryController repository! !

!MagmaFileTraverser methodsFor: 'accessing' stamp: 'cmm 1/19/2005 21:36'!
repositoryController

	^ repositoryController! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 9/24/2004 15:54'!
repositoryController: aMagmaRepositoryController

	repositoryController _ aMagmaRepositoryController.
	directory _ aMagmaRepositoryController directory! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 9/26/2004 21:30'!
tempOidsVisitedFilename

	^ repositoryController directory fullNameFor: 'oidsVisited.tmp'! !

MaObject subclass: #MagmaRepositoryController
	instanceVariableNames: 'repository session serverSerializer requestInterruptGuard directory preferences'
	classVariableNames: 'OpenControllers'
	poolDictionaries: ''
	category: 'Magma server-API'!

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'cmm 9/24/2004 17:00'!
compress: sourcePath to: targetPath

	(MagmaCompressor source: sourcePath) compressTo: targetPath! !

!MagmaRepositoryController class methodsFor: 'accessing' stamp: 'kph 10/4/2006 14:40'!
controllerOpenedOn: location

	^ OpenControllers
		maDetect: [ : each | each directory pathName = location pathName ]
		ifFound: [ : foundController | foundController ensureOpen ]
		ifNone: [ nil ]! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'kph 10/4/2006 20:31'!
create: locationOrPath

	"Creates a repository with an initial root of nil.  I #assureExistence of the location."

	| aLocation |

	aLocation := MagmaLocalLocation path: locationOrPath. 	
	self validateCanCreateIn: aLocation.
	self new createRepositoryAt: aLocation! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'kph 10/4/2006 13:44'!
create: location root: anObject
	| session |
	self create: location.
	session _ MagmaSession openLocal: location.
	session
		connect: (MagmaUser id: 'system create:root:') ;
		commit: [ session root: anObject ] ;
		disconnect ;
		closeRepository! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'kph 10/4/2006 21:14'!
delete: location
	"Delete the just the files in fullyQualifiedPathString that are part of the Magma repository that resides there."
	| dir |

	dir := location directory.

	(location exists and: [ dir fileExists: MaObjectFiler objectsFilename ]) ifFalse:
		[ (MagmaNotification new messageText: dir pathName , ' does not exist, nothing to delete.') signal.
		^ self ].
	(self filesFor: location), { (MaRecoveryManager commitPackagesFilename) } do:
		[ : each |
			dir deleteFileNamed: each asString
			ifAbsent: [ MagmaNotification signal: 'Couldn''t find ' , each asString ] ]! !

!MagmaRepositoryController class methodsFor: 'private' stamp: 'cmm 7/15/2005 12:39'!
filesFor: directoryName

	| controller |
	controller _ self open: directoryName.
	^ [ controller filenames ] ensure: [ controller close ]! !

!MagmaRepositoryController class methodsFor: 'advanced' stamp: 'cmm 6/14/2006 22:07'!
generateKeysIndexIn: aFileDirectory for: sourceHashIndexFilename 
	"Create a -keys index in aFileDirectory using sourceHashIndexFilename as the source."
	| source target namePart targetName |
	source _ MaHashIndex openNamed: (aFileDirectory fullNameFor: sourceHashIndexFilename).
	[ namePart _ sourceHashIndexFilename 
		copyFrom: 1
		to: sourceHashIndexFilename size - 4.
	targetName _ namePart , '-keys.hdx'.
	target _ MaHashIndex 
		createNamed: (aFileDirectory fullNameFor: targetName)
		keySize: MaObjectBuffer oidSize
		valueSize: source keySize
		recordSize: source numberOfSlots.
	[ source 
		entriesFrom: 0
		do: 
			[ : eachRecord : bax : level | 
			target 
				add: (eachRecord keyAtByteArrayIndex: bax)
				at: (eachRecord valueAtByteArrayIndex: bax) ]
		until: [ : eachRecord : bax : level | false ] ] ensure: [ target close ] ] ensure: [ source close ]! !

!MagmaRepositoryController class methodsFor: 'advanced' stamp: 'cmm 6/14/2006 21:58'!
generateKeysIndices: dir 
	| hdxFiles |
	hdxFiles _ dir fileNamesMatching: '*.hdx'.
	hdxFiles do: 
		[ : each | 
		| namePart |
		namePart _ each 
			copyFrom: 1
			to: each size - 4.
		"is it an attribute index?"
		(namePart anySatisfy: [ : e | e isLetter ]) ifTrue: 
			[ 
			self 
				generateKeysIndexIn: dir
				for: each.
			dir 
				rename: each
				toBe: namePart , '-oids.hdx' ] ]! !

!MagmaRepositoryController class methodsFor: 'initializing' stamp: 'cmm 11/2/2004 14:38'!
initialize

	OpenControllers ifNotNil: [ OpenControllers do: [ : each | each close ] ].
	OpenControllers _ Set new.
	Smalltalk
		addToStartUpList: self;
		addToShutDownList: self! !

!MagmaRepositoryController class methodsFor: 'accessing' stamp: 'kph 8/24/2006 22:21'!
openControllers

^OpenControllers! !

!MagmaRepositoryController class methodsFor: 'accessing' stamp: 'kph 10/4/2006 13:16'!
openedOn: location

	| existingController  |
	^ (existingController := self controllerOpenedOn:  location)
		ifNil: [ self open: location ]
		ifNotNil: [ existingController ].! !

!MagmaRepositoryController class methodsFor: 'private' stamp: 'kph 10/4/2006 13:19'!
open: location

	^ self new open: location! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'kph 10/4/2006 13:30'!
repositoryExistsIn: location

	^ (location directoryEntryFor: MaObjectFiler objectsFilename) notNil! !

!MagmaRepositoryController class methodsFor: 'initializing' stamp: 'cmm 12/27/2004 23:16'!
shutDown: aboutToQuit

	super shutDown: aboutToQuit.
	MagmaSession shutDown: aboutToQuit.
	OpenControllers
		do:
			[ :each | 
			[ MagmaNotification signal: 'closing Magma repository ', each pathName asString, '.  Will reopen on next startup.' ]
				on: MagmaNotification
				do: [ : noti | Transcript cr; show: noti messageText. noti pass ].
			each primClose ]! !

!MagmaRepositoryController class methodsFor: 'initializing' stamp: 'cmm 3/11/2005 14:58'!
startUp: amResuming

	super startUp: amResuming.
	OpenControllers copy do: 
		[ :each | 
		[ [ each ensureOpen ]
			on: MagmaNotification
			do: [ : noti | Transcript cr; show: noti messageText. noti pass ] ]
				on: MagmaEnvironmentError
				do: 
					[ : error | "not present anymore, remove from OpenControllers and resignal."
					each close.
					error pass ] ].
	"Now that we're open, ensure any server-sockets that may need to restart can be."
	MaServerSocket startUp: amResuming! !

!MagmaRepositoryController class methodsFor: 'private' stamp: 'cmm 5/1/2003 00:24'!
systemSessionUserId

	^'__system'! !

!MagmaRepositoryController class methodsFor: 'advanced' stamp: 'cmm 6/14/2006 21:45'!
updateVersionIn: aFileDirectory from: currentVersion 
	"Force update the filers version from currentVersion.  currentVersion is required to help catch mistakes, since the version is very important for operation."
	| filer |
	filer _ MaObjectFiler open: aFileDirectory.
	[" filer version = currentVersion ifFalse: 
		[ MagmaUserError signal: 'This repository is not already version ' , currentVersion asString ]."
	filer version: currentVersion + 1 ] ensure: [ filer close ]! !

!MagmaRepositoryController class methodsFor: 'advanced' stamp: 'kph 10/4/2006 14:17'!
upgrade5To6: location 
	"Upgrade legacy repository's from #magmaVersion 5 to 6.  It is always good advice to back up before running any conversion utility."
	| dir |

	dir := (MagmaLocalLocation path: location) directory. 
	self 
		updateVersionIn: dir from: 5 ;
		generateKeysIndices: dir directory! !

!MagmaRepositoryController class methodsFor: 'validation' stamp: 'kph 10/4/2006 14:40'!
validateCanCreateIn: location
	"Magma databases do not share the same directory.  Not only would it be hard to identify which files go with which repository, some of the filenames are based on oids, which would not always be unique across repositories."

	(location exists and: [ self repositoryExistsIn: location ])
		ifTrue:
			[ MagmaUserError signal: location pathName, ' already has a Magma repository in it.  A directory may contain only one Magma repository.' ]
! !

!MagmaRepositoryController methodsFor: 'statistics' stamp: 'cmm 4/21/2003 16:28'!
averageObjectSize

	^repository objectFileSize // self objectCount! !

!MagmaRepositoryController methodsFor: 'utilities' stamp: 'cmm 5/24/2006 22:36'!
backupTo: aFileDirectory 
	"Backup the repository to aFileDirectory while the repository is open.  Make sure you have enough space.  All database requests will wait patiently until all files are backed up and then resume automatically."
	aFileDirectory assureExistence.
	self requestCritical: 
		[ repository commitCritical: 
			[ repository dbFilesDo: 
				[ : eachTransactionalFileStream : eachFileNumber | 
				eachTransactionalFileStream copyToDirectory: aFileDirectory ] ] ]! !

!MagmaRepositoryController methodsFor: 'preferences' stamp: 'cmm 6/6/2005 13:35'!
beReadOnly

	self requestCritical: [ preferences beReadOnly ]! !

!MagmaRepositoryController methodsFor: 'preferences' stamp: 'cmm 6/6/2005 13:35'!
beReadWrite

	self requestCritical: [ preferences beReadWrite ]! !

!MagmaRepositoryController methodsFor: 'preferences' stamp: 'cmm 7/5/2005 20:16'!
cacheFlushFrequency

	^ preferences cacheFlushFrequency! !

!MagmaRepositoryController methodsFor: 'preferences' stamp: 'cmm 7/5/2005 20:17'!
cacheFlushFrequency: aBoolean

	^ self requestCritical: [ preferences cacheFlushFrequency: aBoolean ]! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 10/24/2004 23:14'!
close

	OpenControllers remove: self ifAbsent: [ "do nothing" ].
	self primClose! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 10/26/2004 21:54'!
codeBaseByteArray

	^Array
		with: repository classDefinitionsByteArray
		with: (serverSerializer serializeGraph: self definition codeBase) trimmedByteArray! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 1/16/2005 21:54'!
connect

	session connect: (MagmaUser id: self class systemSessionUserId).
	repository initializeSpecialOidsList! !

!MagmaRepositoryController methodsFor: 'unsupported' stamp: 'cmm 6/23/2002 10:48'!
connections
	"Used for monitoring server status via some console gui."

	self maMarked: 'dev'.! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'kph 10/4/2006 13:46'!
createRepositoryAt: location

	| anchor |
	directory _ location directory.
	self
		repository: (
			MaObjectRepository
				create: directory
				controller: self);
		connect;
		forceWrite:
			(anchor _ MaRootAnchor new
				definition: self definition ;
				yourself).
	repository filer
		anchorOid: (self session oidFor: anchor);
		classDefinitionsOid: (self session oidFor: self definition classDefinitions);
		definitionOid: (self session oidFor: self definition).
	self close! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 5/2/2004 20:40'!
definition
	"Answers a MagmaRepositoryDefinition"

	^ session definition! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 9/24/2004 15:55'!
directory
	"Answer the directory in which my files reside."
	"Note, this is the same FileDirectory that MaObjectFiler has.  It was necessary to duplicate this here to support the auto-reopen feature upon image restart."
	^ directory! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 2/20/2005 16:31'!
ensureOpen

	self isOpen ifFalse: [ self open ]! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 6/9/2005 16:01'!
filenames

	^ { MaObjectFiler objectsFilename.  MaObjectFiler objectPointersFilename },
	(repository largeCollectionManagers 
		inject: OrderedCollection new
		into:
			[ : coll : each |
			coll
				addAll: each filenames ;
				yourself ]),
	(directory fileNames select: [ : each | each endsWith: '.images' ])! !

!MagmaRepositoryController methodsFor: 'preferences' stamp: 'cmm 7/7/2005 23:21'!
flushAggressively

	^ preferences flushAggressively! !

!MagmaRepositoryController methodsFor: 'preferences' stamp: 'cmm 7/5/2005 12:51'!
flushAggressively: aBoolean

	^ self requestCritical: [ preferences flushAggressively: aBoolean ]! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 5/30/2005 21:59'!
forceWrite: anObject
	"This is somewhat of a hacking method to enable us to write objects needed
	for the repository to operate (i.e., commit transactions) during initial creation."

	| commitPackage |
	session begin.  "Begin a tran to allow the submitAll:for:.."
	commitPackage _ MaCommitPackage new.
	session serializer
		serializeGraph: anObject
		do: [ :eachObject | commitPackage addObject: eachObject ].
	commitPackage copy serializeObjectsUsing: session.
	commitPackage serializeObjectsUsing: session.
	session
		refreshViewUsing: (
			repository
				submitAll: commitPackage
				for: session id
				beginAnother: false) ;
		decrementTransactionLevel! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 4/3/2003 23:00'!
getDefinition

	^session materializeObject: repository definitionByteArray! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 6/12/2006 13:01'!
initialize
	super initialize.
	self initializeSession.
	session initializeDefinition.
	session definition addMinimumClassesForOdbmsUsing: self serverSerializer.
	requestInterruptGuard _ Monitor new.
	preferences _ MagmaServerPreferences new! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 3/27/2002 22:00'!
initializeServerSerializer
	"Why is this separate, 'serverSerializer' needed?  Because the session serializer requires a different traversalStrategy.  The serverSerializer needs to be able to fully serialize, to the ends of the graphs, the 'response' objects of various requests."

	serverSerializer _ self session serializer copyWithNewBuffer initializeTraversalStrategy
! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 1/16/2005 18:45'!
initializeSession

	session _ MagmaSession repositoryController: self.
	self initializeServerSerializer! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 9/1/2003 19:40'!
initializeSystemReadStrategy

	repository initializeSystemReadStrategyUsing: self serverSerializer classIdManager! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 4/30/2003 22:07'!
isOpen

	^repository isOpen! !

!MagmaRepositoryController methodsFor: 'preferences' stamp: 'cmm 6/6/2005 13:38'!
isReadOnly

	^ preferences isReadOnly! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 1/14/2005 16:05'!
magmaId

	^ self definition magmaId! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/10/2005 10:59'!
materializeClassDefinitions
	"This is needed because, when opening the repository, the default classes do not include MagmaRepositoryDefinition, which is delivered as part of any session-connection.  When the system-session attempts to connect, it tries to read the repository-definition but can't because it can't get a proper read-strategy for it."

	[ session loadClassDefinitionsFrom: repository classDefinitionsByteArray ]
		on: Error
		do:
			[ : err | MagmaCorruptionError signal: err messageText ]! !

!MagmaRepositoryController methodsFor: 'unsupported' stamp: 'cmm 5/2/2004 20:40'!
maximumNumberOfChallengers: anInteger 
	self session 
		commit: [ self definition maximumNumberOfChallengers: anInteger ]! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 5/14/2005 18:14'!
newSessionFor: userIdString

	^ self repository
		newSessionFor: userIdString
		numberOfChallengers: MagmaRepositoryDefinition defaultMaximumNumberOfChallengers! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/6/2005 13:21'!
newTransactionFor: sessionId

	preferences isReadOnly ifTrue:
		[ MagmaUserError signal: 'This repository is set to read-only, commits are prohibited.' ].
	^ repository newTransactionFor: sessionId! !

!MagmaRepositoryController methodsFor: 'statistics' stamp: 'cmm 5/2/2003 14:56'!
numberOfConnectedClients

	^repository sessions size - 1! !

!MagmaRepositoryController methodsFor: 'statistics' stamp: 'cmm 4/21/2003 15:55'!
objectCount
	"Answers how many objects have been committed to this repository.  Does not account for objects that have since been garbage colellected."

	^repository objectCount! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 7/16/2005 16:57'!
open
	"This is called when restarting controllers during image restart."

	| didRetry |
	didRetry _ false.
	[ self privateOpen: directory ]
		on: MagmaCorruptionError
		do: 
			[ : err |
			didRetry
				ifTrue: [ self error: 'serious problem' ]
				ifFalse:
					[ MagmaWarning signal: 'Outage occurred while writing system-definitions!!  Will now attempt to repair.'.
					repository primitiveRecover.
					err retry ] ].
	self openLargeCollections.
	"Two-stage recovery.."
	repository recoverIfNecessary.  "rollback"
	repository recoverIfNecessary  "re-apply after-images."! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 5/2/2004 20:40'!
openLargeCollections
	"Open all indexes for all large collections."

	self definition allLargeCollections 
		do: [ :each | self openLargeCollection: each ]! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 3/16/2005 12:46'!
openLargeCollection: aMagmaLargeCollection

	repository openLargeCollectionIfNecessary: aMagmaLargeCollection
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'kph 10/4/2006 13:21'!
open: location

	directory _ location directory.
	self open.
	OpenControllers add: self. "<- we only do this for intentional opens, not image restarts"! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 9/24/2004 15:13'!
pathName

	^ directory pathName! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/1/2005 16:11'!
primClose

	self requestCritical:
		[ session ifNotNil: [ session disconnect ].
		repository close ]! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 2/20/2005 16:27'!
privateOpen: aFileDirectory

	MagmaNotification signal: 'opening Magma repository ', self pathName.
	self
		initializeSession;
		repository: (
			MaObjectRepository
				open: aFileDirectory
				controller: self) ;
		initializeSystemReadStrategy ;
		materializeClassDefinitions ;
		connect ;
		refreshView "so more classes will be pulled from unusedDepths of the SystemReadStrategy"! !

!MagmaRepositoryController methodsFor: 'client/server required methods' stamp: 'cmm 6/12/2006 13:01'!
processRequest: aMaRepositoryRequest 
	aMaRepositoryRequest repositoryController: self.
	^ [ self requestCritical: [ aMaRepositoryRequest process ] ] 
		on: MaError
		do: 
			[ : anError | 
			(MagmaPreferences debug and: 
				[ ({  MagmaCommitError. MagmaSessionLost  } includes: anError maOriginalClass) not and: [ anError isUserError not ] ]) ifTrue: [ self halt: anError messageText ].
			anError ]! !

!MagmaRepositoryController methodsFor: 'client/server required methods' stamp: 'cmm 8/6/2006 23:19'!
protocol
	"This is the protocol needed to talk to a magma server."
	^ { 
	"core"
		LargePositiveInteger. MaSerializedGraphBuffer }, 
		MaObjectBuffer allSubclasses asArray,
	"various requests"
		MagmaRepositoryRequest allSubclasses asArray,
	"extra objects for some requests."
		{ MaCommitPackage.  MaBasicReadStrategy.  MaReadStrategy },
	"various results"
		MagmaServerResult allSubclasses asArray,
	"extra objects for results"
		{ MagmaId. UUID. MaFailedCommitResult. MagmaClientConnection. MagmaCommitConflict. Fraction }, 
	"query expressions"
		MaTerm allSubclasses asArray, { MaQueryTrunk },
	"MagmaCollections"
		MagmaCollection withAllSubclasses asArray, { IdentityDictionary },
	"indexes"
		MagmaCollectionIndex allSubclasses asArray, 
	"large-collection changes"
		MagmaLargeCollectionChanges allSubclasses asArray,
	{ "parts of MagmaCollectionChanges"
		Association.  MaChangedKeySpecification },
	"exceptions"
		MaError allSubclasses asArray,
	"for MaDateAndTimeIndex"
		{ DateAndTime. Duration }! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 9/1/2003 19:21'!
refreshView

	self session abort.
	repository systemReadStrategy makeReadyForUseUsing: session serializer classIdManager! !

!MagmaRepositoryController methodsFor: 'private' stamp: ''!
repository

	^repository
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/31/2002 12:54'!
repository: aMaObjectRepository

	repository _ aMaObjectRepository.
	aMaObjectRepository repositoryController: self! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/27/2002 15:55'!
requestCritical: aBlock
	"Coordinate access to all server elements."

	^requestInterruptGuard critical: aBlock! !

!MagmaRepositoryController methodsFor: 'private' stamp: ''!
serverSerializer
	"The serverSerializer is used for processing client requests.  It is also
	used during administration and possibly needed during initial creation of a
	repository."

	^serverSerializer
! !

!MagmaRepositoryController methodsFor: 'private' stamp: ''!
session
	"The server-side session is needed for largeCollection updates to be
	processed correctly.  When a client makes a change to a largeCollection, such
	as adding or removing an index, the systemRoot change is reflected upon
	the servers session refreshing its view of the database."

	^session
! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 4/3/2003 22:59'!
sessionId

	^session id
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 10/22/2002 23:18'!
signalRequestGuard

	requestInterruptGuard signal! !

!MagmaRepositoryController methodsFor: 'client/server required methods' stamp: 'cmm 9/19/2004 22:08'!
value: aMagmaRepositoryRequest

	^ self processRequest: aMagmaRepositoryRequest! !

!MagmaRepositoryController methodsFor: 'statistics' stamp: 'cmm 4/21/2003 16:02'!
version

	^repository version! !

MaObject subclass: #MagmaServerPreferences
	instanceVariableNames: 'attributes'
	classVariableNames: 'DebugRecovery'
	poolDictionaries: ''
	category: 'Magma server-Preferences'!

!MagmaServerPreferences class methodsFor: 'debugging' stamp: 'cmm 6/9/2005 21:42'!
debugRecovery

	^ DebugRecovery! !

!MagmaServerPreferences class methodsFor: 'debugging' stamp: 'cmm 6/9/2005 21:42'!
debugRecovery: aBoolean

	DebugRecovery _ aBoolean! !

!MagmaServerPreferences class methodsFor: 'debugging' stamp: 'cmm 6/9/2005 22:06'!
initialize

	self debugRecovery: false! !

!MagmaServerPreferences methodsFor: 'security' stamp: 'cmm 6/6/2005 13:35'!
beReadOnly

	self 
		setAttribute: #isReadOnly
		to: true! !

!MagmaServerPreferences methodsFor: 'security' stamp: 'cmm 6/6/2005 13:35'!
beReadWrite

	self 
		setAttribute: #isReadOnly
		to: false! !

!MagmaServerPreferences methodsFor: 'recovery' stamp: 'cmm 7/18/2005 12:48'!
cacheFlushFrequency

	^ self
		valueOfAttribute: #cacheFlushFrequency
		ifAbsent: [ 5 "seconds" ]! !

!MagmaServerPreferences methodsFor: 'recovery' stamp: 'cmm 7/5/2005 20:18'!
cacheFlushFrequency: anInteger

	self
		setAttribute: #cacheFlushFrequency
		to: anInteger! !

!MagmaServerPreferences methodsFor: 'recovery' stamp: 'cmm 7/7/2005 23:21'!
flushAggressively

	^ self 
		valueOfAttribute: #flushAggressively
		ifAbsent: [ false ]! !

!MagmaServerPreferences methodsFor: 'recovery' stamp: 'cmm 7/12/2005 13:10'!
flushAggressively: aBoolean

	self
		setAttribute: #flushAggressively
		to: aBoolean! !

!MagmaServerPreferences methodsFor: 'initialize' stamp: 'cmm 6/6/2005 13:05'!
initialize
	super initialize.
	attributes _ Dictionary new! !

!MagmaServerPreferences methodsFor: 'security' stamp: 'cmm 6/6/2005 13:44'!
isReadOnly

	^ self 
		valueOfAttribute: #isReadOnly
		ifAbsent: [ false ]! !

!MagmaServerPreferences methodsFor: 'private' stamp: 'cmm 6/6/2005 13:07'!
setAttribute: attributeSymbol to: value

	attributes
		at: attributeSymbol
		put: value! !

!MagmaServerPreferences methodsFor: 'private' stamp: 'cmm 6/6/2005 13:09'!
valueOfAttribute: attributeSymbol ifAbsent: aBlock
	^ attributes 
		at: attributeSymbol
		ifAbsent: aBlock! !

MaObject subclass: #MagmaServerStatistics
	instanceVariableNames: 'startTime stopTime socketsQueuedStat requestsQueuedStat requestSizeStat requestProcessingTimeStat responseSizeStat stopwatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-API'!

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 21:49'!
decrementRequestsQueued

	requestsQueuedStat last: requestsQueuedStat last - 1! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 21:50'!
decrementSocketsQueued

	socketsQueuedStat last: socketsQueuedStat last - 1! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 21:47'!
incrementRequestsQueued

	requestsQueuedStat addValue: 1 + requestsQueuedStat last! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 21:47'!
incrementSocketsQueued

	socketsQueuedStat addValue: socketsQueuedStat last + 1! !

!MagmaServerStatistics methodsFor: 'initializing' stamp: 'cmm 11/16/2004 21:50'!
initialize
	super initialize.
	stopwatch _ MaStopwatch new.
	socketsQueuedStat _ MaStat new last: 0.
	requestsQueuedStat _ MaStat new last: 0.
	requestSizeStat _ MaStat new last: 0.
	requestProcessingTimeStat _ MaStat new last: 0.
	responseSizeStat _ MaStat new last: 0! !

!MagmaServerStatistics methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:29'!
printOn: aStream

	super printOn: aStream.
	aStream
		cr; tab;
		nextPutAll: 'sockets queued: ';
		maPrintAbbreviated: socketsQueuedStat;
		cr; tab;
		nextPutAll: 'requests queued:  ';
		maPrintAbbreviated: requestsQueuedStat;
		cr; tab;
		nextPutAll: 'request sizes:  ';
		maPrintAbbreviated: requestSizeStat;
		cr; tab;
		nextPutAll: 'request processing time:  ';
		maPrintAbbreviated: requestProcessingTimeStat;
		cr; tab;
		nextPutAll: 'response sizes:  ';
		maPrintAbbreviated: responseSizeStat! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 10:51'!
recordRequestSize: anInteger

	requestSizeStat addValue: anInteger! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 10:51'!
recordResponseSize: anInteger

	responseSizeStat addValue: anInteger! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
requestProcessingTimeStat

	^requestProcessingTimeStat! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
requestSizeStat

	^requestSizeStat! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
requestsQueuedStat

	^requestsQueuedStat! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
responseSizeStat

	^responseSizeStat! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
socketsQueuedStat

	^socketsQueuedStat! !

!MagmaServerStatistics methodsFor: 'actions' stamp: 'cmm 1/5/2003 22:57'!
startRequestTimer

	stopwatch reset; start! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 7/1/2004 00:34'!
startTime

	^ startTime! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 10/6/2002 23:23'!
startTime: aMaCalendarTime

	startTime _ aMaCalendarTime! !

!MagmaServerStatistics methodsFor: 'actions' stamp: 'cmm 11/16/2004 10:52'!
stopRequestTimer

	stopwatch stop.
	requestProcessingTimeStat addValue: stopwatch time! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 7/1/2004 00:34'!
stopTime

	^ stopTime! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 10/7/2002 00:33'!
stopTime: aMaCalendarTime

	stopTime _ aMaCalendarTime! !

MaObject subclass: #MaLargeCollectionManager
	instanceVariableNames: 'collection memberIndex repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaLargeCollectionManager commentStamp: 'cmm 3/16/2005 12:48' prior: 0!
I perform server-side operations for MagmaLargeCollections.  Adding, removing and accessing.!

MaLargeCollectionManager subclass: #MagmaArrayManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MagmaArrayManager methodsFor: 'overriding' stamp: 'cmm 7/12/2005 12:59'!
createNewLargeCollection
	| fullFilename |
	fullFilename _ repository collectionFilenameFor: collection.
	memberIndex _
		MaLargeArrayOfNumbers
			create: (MaTransactionalFileStream fileNamed: fullFilename)
			bitSize: MaObjectFiler maxDbSize! !

!MagmaArrayManager methodsFor: 'initializing' stamp: 'cmm 7/8/2005 10:47'!
openIndex: filenameString

	^ MaLargeArrayOfNumbers open:
		(MaTransactionalFileStream fileNamed: filenameString)! !

!MagmaArrayManager methodsFor: 'private' stamp: 'cmm 5/14/2005 19:05'!
processAddsIn: aMagmaArrayChanges using: aMaCommitResult

	aMagmaArrayChanges additionsDo:
		[ : eachIndex : eachOid |  | addedObjectOid |
		addedObjectOid :=
			(MaOidCalculator isOidForNewObject: eachOid)
				ifTrue: [ aMaCommitResult permanentOids at: eachOid ]
				ifFalse: [ eachOid ].
		memberIndex
			at: eachIndex
			put: addedObjectOid ]! !

!MagmaArrayManager methodsFor: 'actions' stamp: 'cmm 3/18/2005 10:55'!
process: aMaCollectionChanges recordResultsIn: aMaCommitResult

	self
		processAddsIn: aMaCollectionChanges
		using: aMaCommitResult.! !

!MagmaArrayManager methodsFor: 'overriding' stamp: 'cmm 3/20/2005 21:29'!
recordConflictsBetween: aMagmaArrayChanges and: challengingCommitLogEntry in: myCommitLogEntry
	"For MagmaArray's, different sessions may update the Array as long as they update different indexes."

	(challengingCommitLogEntry hasChangesToMagmaArray: aMagmaArrayChanges collectionOid)
		ifTrue:
			[ | foreignChanges |
			foreignChanges _ challengingCommitLogEntry magmaArrayAdditionsAt: aMagmaArrayChanges collectionOid.
			aMagmaArrayChanges additionsDo:
				[ : eachIndex : eachOid |
				((foreignChanges includesKey: eachIndex)
				and: [ (foreignChanges at: eachIndex) ~= eachOid ])
					ifTrue:
						[ "this user tried to put a different oid at the same index, conflict!!"
						myCommitLogEntry
							failResultWith: challengingCommitLogEntry connection
							on: aMagmaArrayChanges collectionOid ] ] ]! !

!MagmaArrayManager methodsFor: 'overriding' stamp: 'cmm 3/18/2005 13:33'!
recordGeneralConflictsWith: aMagmaLargeCollectionChanges in: aMaCommitLogEntry

	"no general conflicts for MagmaArray's."! !

!MagmaArrayManager methodsFor: 'overriding' stamp: 'cmm 6/5/2006 23:35'!
upTo: anInteger inSegmentFromIndex: lowIndex

	| oids |
	oids _ 
		memberIndex
			upTo: anInteger
			startingAt: lowIndex.
	^ MagmaCollectionSegment new
		lastKnownSize: memberIndex size ;
		startIndex: lowIndex ;
		objects: oids ;
		yourself! !

MaLargeCollectionManager subclass: #MagmaCollectionManager
	instanceVariableNames: 'oidOfIndexesCollection lockedBy keyIndexesByAttribute oidIndexesByAttribute keyIndexes oidIndexes shouldStopLoading loadProcess loadExecutor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 7/4/2006 15:43'!
addMember: addedObjectOid atHashes: eachHashIndexArrays 
	memberIndex 
		add: self dummyValue
		at: addedObjectOid.
	eachHashIndexArrays withIndexDo: 
		[ : eachHashValues : x | 
		eachHashValues do: 
			[ : eachHashValue | 
			(oidIndexes at: x) 
				add: addedObjectOid
				at: eachHashValue.
			(keyIndexes at: x) 
				add: eachHashValue
				at: addedObjectOid ] ]! !

!MagmaCollectionManager methodsFor: 'initialize-release' stamp: 'cmm 4/13/2006 13:42'!
addNewIndex: aMaIndexDefinition 
	oidIndexes add: 
		(oidIndexesByAttribute 
			at: aMaIndexDefinition attribute
			put: 
				(MaHashIndex 
					create: 
						(MaTransactionalFileStream fileNamed: (self 
							fullFileNameStringFor: 'oids'
							of: aMaIndexDefinition))
					keySize: aMaIndexDefinition keySize
					valueSize: MaObjectBuffer oidSize
					recordSize: aMaIndexDefinition recordSize)).
	keyIndexes add: 
		(keyIndexesByAttribute 
			at: aMaIndexDefinition attribute
			put: 
				(MaHashIndex 
					create: 
						(MaTransactionalFileStream fileNamed: (self 
							fullFileNameStringFor: 'keys'
							of: aMaIndexDefinition))
					keySize: MaObjectBuffer oidSize
					valueSize: aMaIndexDefinition keySize
					recordSize: aMaIndexDefinition recordSize))! !

!MagmaCollectionManager methodsFor: 'locking' stamp: 'cmm 3/16/2005 14:13'!
beLockedBy: aMagmaClientConnection

	lockedBy _ aMagmaClientConnection! !

!MagmaCollectionManager methodsFor: 'initialize-release' stamp: 'cmm 4/13/2006 14:30'!
close
	super close.
	oidIndexes do: [ : each | each close ].
	keyIndexes do: [ : each | each close ]! !

!MagmaCollectionManager methodsFor: 'overriding' stamp: 'cmm 8/17/2005 21:03'!
createNewLargeCollection
	| fullFilename |
	fullFilename := repository collectionFilenameFor: collection.
	memberIndex :=
		MaHashIndex
			create: (MaTransactionalFileStream fileNamed: fullFilename)
			keySize: MaObjectBuffer oidSize
			valueSize: 8
			recordSize: 8! !

!MagmaCollectionManager methodsFor: 'actions' stamp: 'cmm 7/12/2005 11:20'!
createSupplementaryIndexes
	| position |
	position _ 0.
	collection indexesDo:
		[ : eachIndexDefinition |
		self
			ensureIndex: eachIndexDefinition
			at: (position _ position + 1) ]! !

!MagmaCollectionManager methodsFor: 'actions' stamp: 'cmm 6/13/2006 00:26'!
delete
	self filesDo: 
		[ : eachFile : eachFileId | 
		eachFile close.
		repository directory deleteFileNamed: eachFile filename ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 7/2/2006 21:22'!
dummyValue
	"For the memberIndex, we only use the keys, answer a dummy value for the values."
	^ 0! !

!MagmaCollectionManager methodsFor: 'initialize-release' stamp: 'cmm 4/13/2006 13:39'!
ensureIndexesOpen
	collection indexesDo: 
		[ : each | 
		(self hasIndexFor: each attribute) ifFalse: 
			[ oidIndexes add: 
				(oidIndexesByAttribute 
					at: each attribute
					put: 
						(self openIndex: 
							(self 
								fullFileNameStringFor: 'oids'
								of: each))).
			keyIndexes add: 
				(keyIndexesByAttribute 
					at: each attribute
					put: 
						(self openIndex: 
							(self 
								fullFileNameStringFor: 'keys'
								of: each))) ] ]! !

!MagmaCollectionManager methodsFor: 'initialize-release' stamp: 'cmm 4/13/2006 10:05'!
ensureIndex: aMaIndexDefinition at: indexPosition 
	oidIndexes size < indexPosition ifTrue: [ self addNewIndex: aMaIndexDefinition ]! !

!MagmaCollectionManager methodsFor: 'actions' stamp: 'cmm 3/17/2005 17:22'!
ensureOpen

	super ensureOpen.
	self ensureIndexesOpen! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 7/11/2006 21:38'!
fileIdForOids: aBoolean index: anInteger
	"To support recovery, we must populate MaBeforeImageRecords with a fileId identifying which file it is a before-image of.  We have eight bytes available for this.  The high-order 48-bits are my collectionOid, the low-order 15 bits indicate which index of the collection it is.  0 is the memberIndex.  For the other indexes (where lower-order 15 bits > 0), bit 16 is 1 for keys, 0 for oids."
	| isKeysBit indexId |
	isKeysBit _ 16.
	(anInteger maIsBitSet: isKeysBit) ifTrue: 
		[ MagmaSoftwareError signal: 'Cannot have more than ' , ((0 maBitSet: isKeysBit) - 1) printString , ' indexes for a single collection.' ].
	indexId _ aBoolean 
		ifTrue: [ anInteger ]
		ifFalse: [ anInteger maBitSet: isKeysBit ].
	^ (self collectionOid bitShift: 16) + indexId! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 3/16/2005 21:28'!
filenameComponentFor: aMaIndexDefinition

	^ self collectionOid printString , aMaIndexDefinition uniqueFileIdentifier
! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 4/13/2006 13:36'!
filenameFor: keysOrOids of: aMaIndexDefinition
	^ (String streamContents:
		[ : stream |
		stream
			nextPutAll: (self filenameComponentFor: aMaIndexDefinition) ;
			nextPut: $- ;
			nextPutAll: keysOrOids ;
			nextPut: $. ;
			nextPutAll: MaHashIndex suggestedFileExtension ])! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 4/13/2006 12:48'!
filenames
	^ super filenames , 
	(oidIndexes, keyIndexes collect: [ : each | repository directory localNameFor: each filename ])! !

!MagmaCollectionManager methodsFor: 'recovery' stamp: 'cmm 4/14/2006 12:41'!
filesDo: twoArgBlock 
	super filesDo: twoArgBlock.
	oidIndexes withIndexDo: 
		[ : each : x | 
		each filesDo: 
			[ : eachIndexFile | 
			twoArgBlock 
				value: eachIndexFile
				value: 
					(self 
						fileIdForOids: true
						index: x) ] ].
	keyIndexes withIndexDo: 
		[ : each : x | 
		each filesDo: 
			[ : eachIndexFile | 
			twoArgBlock 
				value: eachIndexFile
				value: 
					(self 
						fileIdForOids: false
						index: x) ] ]! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 7/26/2006 17:53'!
fractionLoaded
	self isLoading 
		ifTrue: 
			[ loadExecutor 
				ifNil: [ 0 ]
				ifNotNil: [ loadExecutor progress ] ]
		ifFalse: [ 1 ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 4/13/2006 13:32'!
fullFileNameStringFor: keysOrOids of: aMaIndexDefinition 
	^ repository directory fullNameFor: 
		(self 
			filenameFor: keysOrOids
			of: aMaIndexDefinition)! !

!MagmaCollectionManager methodsFor: 'testing' stamp: 'cmm 4/13/2006 10:05'!
hasIndexFor: attributeSymbol 
	^ oidIndexesByAttribute includesKey: attributeSymbol! !

!MagmaCollectionManager methodsFor: 'recovery' stamp: 'cmm 7/16/2006 22:41'!
indexForFileId: anInteger 
	"To support recovery of LargeCollections, we must replace the applied records to their prior-state, which is contained inside MaBeforeImageRecords."
	| indexId |
	indexId _ 2r111111111111111 bitAnd: anInteger.	"15-bit index #"
	^ indexId = 0 
		ifTrue: [ memberIndex ]
		ifFalse: 
			[ (anInteger maIsBitSet: 16) 
				ifTrue: [ keyIndexes at: indexId ]
				ifFalse: [ oidIndexes at: indexId ] ]! !

!MagmaCollectionManager methodsFor: 'initialize-release' stamp: 'cmm 7/4/2006 18:36'!
initialize
	super initialize.
	"we need them mapped to the correct attribute."
	oidIndexesByAttribute _ Dictionary new.
	keyIndexesByAttribute _ Dictionary new.
	"and we must know the correct order, as well"
	oidIndexes _ OrderedCollection new.
	keyIndexes _ OrderedCollection new.
	shouldStopLoading _ false! !

!MagmaCollectionManager methodsFor: 'testing' stamp: 'cmm 7/4/2006 18:34'!
isLoading
	^ loadProcess notNil and: [ loadProcess isTerminated not ]! !

!MagmaCollectionManager methodsFor: 'testing' stamp: 'cmm 3/16/2005 14:22'!
isLocked

	^lockedBy ~= nil! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 4/13/2006 17:12'!
keysIndexForAttribute: aSymbol
	aSymbol isNil ifTrue: [ ^ self memberIndex ].
	^ keyIndexesByAttribute 
		at: aSymbol
		ifAbsent: 
			[ MagmaSoftwareError signal: 'The keys index for ' , aSymbol , ' was not found. ' ]! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 7/26/2006 17:39'!
loadExecutor
	^loadExecutor! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 7/26/2006 17:39'!
loadExecutor: aMaQueryExecutor
	loadExecutor := aMaQueryExecutor! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 7/4/2006 18:33'!
loadProcess
	^loadProcess! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 7/4/2006 18:33'!
loadProcess: aProcess
	loadProcess := aProcess! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 7/26/2006 20:26'!
loadProgress
	^ self isLoading 
		ifTrue: 
			[ loadExecutor 
				ifNil: [ 0 ]
				ifNotNil: [ loadExecutor fractionComplete ] ]
		ifFalse: [ 1 ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 8/6/2006 21:21'!
load: aMagmaCollectionReaderSegment upTo: anInteger where: aMaExpression withObjects: aBoolean except: removedOids
	(MaQueryExecutor 
		collectionManager: self
		expression: aMaExpression) 
		load: aMagmaCollectionReaderSegment
		upTo: anInteger
		withObjects: aBoolean
		except: removedOids.
	^ aMagmaCollectionReaderSegment! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:22'!
lockedBy
	"Answers a MagmaClientConnection."

	^lockedBy! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:13'!
oidOfIndexesCollection: anInteger

	oidOfIndexesCollection := anInteger
! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 4/13/2006 17:12'!
oidsIndexForAttribute: aSymbol
	aSymbol isNil ifTrue: [ ^ self memberIndex ].
	^ oidIndexesByAttribute 
		at: aSymbol
		ifAbsent: 
			[ MagmaSoftwareError signal: 'The oids index for ' , aSymbol , ' was not found. ' ]! !

!MagmaCollectionManager methodsFor: 'overriding' stamp: 'cmm 7/7/2005 15:19'!
openIndex: aString

	^ MaHashIndex open: (MaTransactionalFileStream fileNamed: aString)! !

!MagmaCollectionManager methodsFor: 'accessing' stamp: 'cmm 7/4/2006 18:36'!
pleaseStopLoading
	shouldStopLoading _ true! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 4/13/2006 17:34'!
processAddNewIndexValuesIn: aMagmaCollectionChanges 
	"Serialize the new values for an index that is being built."
	aMagmaCollectionChanges hasNewIndexValues ifFalse: [ ^ self ].
	aMagmaCollectionChanges newIndexValues keysAndValuesDo: 
		[ : eachAttribute : eachValues | 
		| oidsIndex keysIndex |
		oidsIndex _ self oidsIndexForAttribute: eachAttribute.
		keysIndex _ self keysIndexForAttribute: eachAttribute.
		eachValues do: 
			[ : eachAssociation | 
			eachAssociation key do: 
				[ : eachKey | 
				oidsIndex 
					add: eachAssociation value
					at: eachKey.
				keysIndex
					add: eachKey
					at: eachAssociation value ] ] ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 6/11/2006 20:35'!
processAddsIn: aMaCollectionChanges using: aMaCommitResult 
	aMaCollectionChanges additionsDo: 
		[ : eachOid : eachHashIndexArrays | 
		| addedObjectOid |
		addedObjectOid _ (MaOidCalculator isOidForNewObject: eachOid) 
			ifTrue: [ aMaCommitResult permanentOids at: eachOid ]
			ifFalse: [ eachOid ].
		self 
			addMember: addedObjectOid
			atHashes: eachHashIndexArrays ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 4/13/2006 17:29'!
processChangedIndexValuesIn: aMaCollectionChanges 
	aMaCollectionChanges changedKeySpecificationsDo: 
		[ : each | 
		| oidsIndex keysIndex |
		oidsIndex _ self oidsIndexForAttribute: each attribute.
		keysIndex _ self keysIndexForAttribute: each attribute.
		(memberIndex includesKey: each object) ifTrue: 
			[ each oldHashValues do: 
				[ : eachHashKeyValue | 
				oidsIndex 
					remove: each oid
					at: eachHashKeyValue.
				keysIndex
					remove: eachHashKeyValue 
					at: each oid ].
			each newHashValues do: 
				[ : eachHashKeyValue | 
				oidsIndex 
					add: each oid
					at: eachHashKeyValue.
				keysIndex
					add: eachHashKeyValue 
					at: each oid ] ] ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 3/16/2005 22:58'!
processLockIn: aMaCollectionChanges using: aMagmaConnection

	aMaCollectionChanges hasLockSpecified
		ifTrue:
			[ aMaCollectionChanges isLocked
				ifTrue: [ self beLockedBy: aMagmaConnection ]
				ifFalse: [ self beLockedBy: nil ] ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 4/13/2006 17:19'!
processRemovedIndexesIn: aMaCollectionChanges 
	aMaCollectionChanges removedIndexesDo: 
		[ : eachAttribute | 
		{ (self oidsIndexForAttribute: eachAttribute).
		(self keysIndexForAttribute: eachAttribute) } 
			do: [ : eachHashIndex | self removeIndex: eachHashIndex ] ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 7/12/2006 23:29'!
processRemovesIn: aMaLargeCollectionChanges 
	aMaLargeCollectionChanges removedDo: 
		[ : eachOid : eachHashIndexValuesArray | 
		| didRemove |
		didRemove _ memberIndex 
			remove: self dummyValue
			at: eachOid.
		didRemove ifTrue: 
			[ eachHashIndexValuesArray withIndexDo: 
				[ : eachArray : x | 
				eachArray do: 
					[ : eachKeyValue | 
					(oidIndexes at: x) 
						remove: eachOid
						at: eachKeyValue.
					(keyIndexes at: x) 
						remove: eachKeyValue
						at: eachOid ] ] ] ]! !

!MagmaCollectionManager methodsFor: 'overriding' stamp: 'cmm 3/16/2005 22:57'!
process: aMaCollectionChanges recordResultsIn: aMaCommitResult

	self
		processLockIn: aMaCollectionChanges
		using: aMaCommitResult connection.
	self processRemovedIndexesIn: aMaCollectionChanges.
	self
		processAddsIn: aMaCollectionChanges
		using: aMaCommitResult.
	self
		processRemovesIn: aMaCollectionChanges;
		processChangedIndexValuesIn: aMaCollectionChanges;
		processAddNewIndexValuesIn: aMaCollectionChanges! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 3/16/2005 21:20'!
recordConflictsBetween: aMagmaCollectionChanges and: challengingCommitLogEntry in: myCommitLogEntry

	"Fail my result if any indexes have been added or removed since my last transaction boundary."
	(challengingCommitLogEntry hasCommitted: oidOfIndexesCollection)
		ifTrue:
			[ myCommitLogEntry
				failResultWith: challengingCommitLogEntry connection
				on: oidOfIndexesCollection ].
	"Fail my result if any objects being added or removed have been changed by any other session."
	aMagmaCollectionChanges additionsDo:
		[ : eachOid : eachHashIndexValues |
		(challengingCommitLogEntry hasCommitted: eachOid)
			ifTrue:
				[ myCommitLogEntry
					failResultWith: challengingCommitLogEntry connection
					on: eachOid ] ].
	aMagmaCollectionChanges removedDo:
		[ : eachOid : eachHashIndexValues |
		(challengingCommitLogEntry hasCommitted: eachOid)
			ifTrue:
				[ myCommitLogEntry
					failResultWith: challengingCommitLogEntry connection
					on: eachOid ] ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 3/16/2005 21:09'!
recordGeneralConflictsWith: aMagmaLargeCollectionChanges in: aMaCommitLogEntry

	"If its locked by someone else, no changes are allowed."
	(self isLocked
	and: [ aMaCommitLogEntry connection ~= lockedBy ])
		ifTrue:
			[ aMaCommitLogEntry
				failResultWith: self lockedBy
				on: aMagmaLargeCollectionChanges collectionOid ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 6/6/2005 12:32'!
removeIndex: aMaHashIndex

	aMaHashIndex close.
	repository queueForDelete: aMaHashIndex filename! !

!MagmaCollectionManager methodsFor: 'testing' stamp: 'cmm 7/4/2006 18:32'!
shouldStopLoading
	^ shouldStopLoading or: [ repository wantsToClose ]! !

!MagmaCollectionManager methodsFor: 'private' stamp: 'cmm 6/5/2006 23:34'!
upTo: anInteger inSegmentFromIndex: lowIndex

	| keysAndValues |
	keysAndValues _  
		memberIndex
			upTo: anInteger
			keysAndValuesFromIndex: lowIndex.
	^ MagmaCollectionSegment new
		lastKnownSize: memberIndex size ;
		startIndex: lowIndex ;
		objects: keysAndValues first  "there are no 'values' in the member-index, the keys are the objects." ;
		yourself! !

!MaLargeCollectionManager class methodsFor: 'creation' stamp: 'cmm 7/18/2005 13:22'!
collection: aMagmaCollection repository: aMaObjectRepository

	^self new
		collection: aMagmaCollection ;
		repository: aMaObjectRepository ;
		yourself! !

!MaLargeCollectionManager methodsFor: 'initializing' stamp: 'cmm 3/16/2005 14:24'!
close

	memberIndex ifNotNil: [ memberIndex close.  memberIndex _ nil ]! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: 'cmm 6/11/2006 21:57'!
collection
	^ collection! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 12/2/2004 13:22'!
collectionOid

	^ repository session oidFor: collection! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 3/17/2005 22:23'!
collection: aMagmaLargeCollection

	collection := aMagmaLargeCollection
! !

!MaLargeCollectionManager methodsFor: 'override' stamp: 'cmm 7/12/2005 11:02'!
createNewLargeCollection
	self subclassResponsibility! !

!MaLargeCollectionManager methodsFor: 'actions' stamp: 'cmm 7/12/2005 11:18'!
createSupplementaryIndexes
	"Nothing to do by default."! !

!MaLargeCollectionManager methodsFor: 'initializing' stamp: 'cmm 7/12/2005 12:57'!
ensureMemberIndexOpen

	memberIndex ifNil:
		[ memberIndex _ self openIndex: (repository collectionFilenameFor: collection) asString ]! !

!MaLargeCollectionManager methodsFor: 'actions' stamp: 'cmm 3/17/2005 17:22'!
ensureOpen

	^ self 
		ensureMemberIndexOpen ;
		yourself! !

!MaLargeCollectionManager methodsFor: 'recovery' stamp: 'cmm 7/9/2006 17:25'!
fileIdForIndex: anInteger
	"To support recovery, we must populate MaBeforeImageRecords with a fileId, which identifies which file it is a before-image of.  We have eight bytes available for this.  The high-order 6 bytes are my collectionOid, the low-order two bytes indicate which index of the collection it is.  0 is the memberIndex."
	^ (self collectionOid bitShift: 16) + anInteger! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: 'cmm 8/22/2002 19:25'!
filename

	^memberIndex filename! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: 'cmm 6/8/2005 15:13'!
filenames

	^ { repository directory localNameFor: self filename }! !

!MaLargeCollectionManager methodsFor: 'recovery' stamp: 'cmm 7/5/2005 23:43'!
filesDo: twoArgBlock

	memberIndex filesDo: 
		[ : each |
		twoArgBlock
			value: each
			value: (self fileIdForIndex: 0) ]! !

!MaLargeCollectionManager methodsFor: 'recovery' stamp: 'cmm 5/30/2005 21:25'!
indexForFileId: anInteger
	"To support recovery of LargeCollections, we must replace the applied records to their prior-state, which is contained inside MaBeforeImageRecords."

	^ memberIndex "the only possibility"! !

!MaLargeCollectionManager methodsFor: 'testing' stamp: 'cmm 7/9/2006 17:42'!
isLoading
	"Answer whether this collection is being loaded from another collection.  This happens only for MagmaCollections when the client requests they be sorted, it never happens for MagmaArrays."
	^ false! !

!MaLargeCollectionManager methodsFor: 'testing' stamp: 'cmm 2/25/2003 10:19'!
isOpen

	^memberIndex ~= nil! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: ''!
memberIndex

	^memberIndex
! !

!MaLargeCollectionManager methodsFor: 'override' stamp: 'cmm 3/17/2005 23:14'!
openIndex: filenameString

	self subclassResponsibility! !

!MaLargeCollectionManager methodsFor: 'override' stamp: 'cmm 3/16/2005 14:17'!
processAddsIn: aMaCollectionChanges using: aMaCommitResult

	self subclassResponsibility! !

!MaLargeCollectionManager methodsFor: 'override' stamp: 'cmm 3/16/2005 22:57'!
process: aMaCollectionChanges recordResultsIn: aMaCommitResult

	self subclassResponsibility! !

!MaLargeCollectionManager methodsFor: 'override' stamp: 'cmm 3/16/2005 21:24'!
recordConflictsBetween: aMagmaCollectionChanges and: challengingCommitLogEntry in: myCommitLogEntry
	"If there are any conflicts, record them in myCommitLogEntry."

	self subclassResponsibility! !

!MaLargeCollectionManager methodsFor: 'override' stamp: 'cmm 3/16/2005 21:24'!
recordGeneralConflictsWith: aMagmaLargeCollectionChanges in: aMaCommitLogEntry

	self subclassResponsibility! !

!MaLargeCollectionManager methodsFor: 'private' stamp: ''!
repository: aMaObjectRepository

	repository := aMaObjectRepository
! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: ''!
size

	^memberIndex size
! !

!MaLargeCollectionManager methodsFor: 'override' stamp: 'cmm 4/30/2005 11:16'!
upTo: anInteger inSegmentFromIndex: lowIndex

	self subclassResponsibility! !

MaObject subclass: #MaObjectFiler
	instanceVariableNames: 'directory file preMadeObjectBuffer filePositionIndex usedByteArrays primitiveAttributeAddressesMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaObjectFiler commentStamp: 'cmm 5/25/2005 14:24' prior: 0!
I am used to cache values committed in the server.  When a value is cached, we must remember from which commitPackage it came from in case the same object is updated again by a subsequent commitPackage, in which case we would not want to uncache the value when the first commitPackage is applied.!

!MaObjectFiler class methodsFor: 'creation' stamp: 'cmm 9/24/2004 12:52'!
create: aFileDirectory

	^ self new create: aFileDirectory! !

!MaObjectFiler class methodsFor: 'accessing' stamp: 'cmm 4/28/2005 11:36'!
maxDbSize
	"Answers the maximum size of a Magma database as a power of 2.  Hmm, wow, 281 Terabytes huh..  This seems to be beyond any practical limits for a single repository; at least in year 2005, so we'll go with this for now."

	^ 48! !

!MaObjectFiler class methodsFor: 'accessing' stamp: 'cmm 5/10/2005 19:04'!
objectPointersFilename

	^ 'objects.idx'! !

!MaObjectFiler class methodsFor: 'accessing' stamp: 'cmm 5/10/2005 19:04'!
objectsFilename

	^ 'objects'! !

!MaObjectFiler class methodsFor: 'creation' stamp: 'cmm 7/18/2005 13:23'!
open: aFileDirectory

	^ self new
		directory: aFileDirectory ;
		open ;
		yourself! !

!MaObjectFiler class methodsFor: 'accessing' stamp: ''!
sizeOfEmptyRepository
	"Answer in bytes."

	^1024
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:38'!
anchorOid

	^ self primitiveAttributeAt: 'anchorOid'! !

!MaObjectFiler methodsFor: 'building' stamp: 'cmm 12/2/2004 13:38'!
anchorOid: anInteger

	^ self
		primitiveAttributeAt: 'anchorOid'
		put: anInteger! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 1/25/2005 14:10'!
appendObject: oidInteger into: aMaSerializedGraphBuffer
	"Read a single object into aMaSerializedGraphBuffer and adjust its bufferSize accordingly."

	| buffer |
	preMadeObjectBuffer
		byteArray: aMaSerializedGraphBuffer byteArray;
		startPos: aMaSerializedGraphBuffer bufferSize.
	self
		append: preMadeObjectBuffer
		to: aMaSerializedGraphBuffer
		withDataAt: (self filePointerForOid: oidInteger).
	buffer _ preMadeObjectBuffer asSentientBuffer.
	"Set oid only after append because that is where the need for growth is checked."
	buffer oid: oidInteger.
	^buffer
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 11/24/2004 15:33'!
append: aMaObjectBuffer to: aMaSerializedGraphBuffer withDataAt: filePositionInteger

	| startPos |

	startPos _ aMaSerializedGraphBuffer bufferSize.
	self
		ensureByteArrayIn: aMaObjectBuffer
		and: aMaSerializedGraphBuffer
		canAccomodate: self trackSize + aMaObjectBuffer bufferPositionOfBytesToStore
		bytesFrom: startPos + 1.
	aMaSerializedGraphBuffer increaseBufferSizeBy:
		(self
			read: self trackSize
			bytesInto: aMaObjectBuffer
			and: aMaSerializedGraphBuffer
			startingAt: startPos
			filePosition: filePositionInteger)! !

!MaObjectFiler methodsFor: 'debugging' stamp: 'cmm 5/3/2005 14:26'!
bufferFor: oidInteger

	| buffer |
	buffer _ MaSerializedGraphBuffer new: 1000.
	self
		appendObject: oidInteger
		into: buffer.
	^ buffer rootBuffer! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:40'!
classDefinitionsOid

	^self primitiveAttributeAt: 'classDefinitionsOid'
! !

!MaObjectFiler methodsFor: 'building' stamp: 'cmm 12/2/2004 13:40'!
classDefinitionsOid: anInteger

	self
		primitiveAttributeAt: 'classDefinitionsOid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 9/24/2004 13:22'!
close

	file ifNotNil:
		[ file closed ifFalse: [ file close ].
		file _ nil ].
	filePositionIndex ifNotNil:
		[ filePositionIndex close.
		filePositionIndex _ nil ]! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 7/7/2005 22:19'!
createDataFile

	(directory fileExists: self class objectsFilename)
		ifTrue:
			[ MagmaEnvironmentError signal: self dataFileName, ' already exists.' ].
	self openObjectsFile.
	file
		maWrite: self class sizeOfEmptyRepository
		bytesFromPosition: 1
		of: (ByteArray new: self class sizeOfEmptyRepository)
		atFilePosition: 0.
	self
		classDefinitionsOid: MaOidCalculator oidForNil;
		definitionOid: MaOidCalculator oidForNil;
		signature: MaObjectRepository recognitionSignature;
		version: MagmaSession magmaVersion! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 7/11/2005 23:21'!
createFilePositionIndex

	filePositionIndex _ 
		MaLargeArrayOfNumbers
			create: (MaTransactionalFileStream fileStream: (FileStream fileNamed: self filePositionIndexFileName))
			bitSize: self class maxDbSize! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 9/24/2004 16:42'!
create: aFileDirectory

	self
		directory: aFileDirectory assureExistence ;
		createDataFile ;
		createFilePositionIndex.
	^ self! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 9/24/2004 13:02'!
dataFileName

	^ directory fullNameFor: self class objectsFilename! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:42'!
definitionOid

	^ self primitiveAttributeAt: 'definitionOid'! !

!MaObjectFiler methodsFor: 'building' stamp: 'cmm 12/2/2004 13:42'!
definitionOid: anInteger

	^self
		primitiveAttributeAt: 'definitionOid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 9/26/2004 20:25'!
directory
	^ directory! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 9/24/2004 12:55'!
directory: aFileDirectory

	directory _ aFileDirectory! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 12/30/2002 17:28'!
ensureByteArrayIn: aMaObjectBuffer and: aMaSerializedGraphBuffer canAccomodate: anInteger bytesFrom: startPos

	(startPos + anInteger) > aMaObjectBuffer byteArray size
		ifTrue:
			[ | bigByteArray beforeSize afterSize |
			beforeSize _ aMaObjectBuffer byteArray size.
			afterSize _ (aMaObjectBuffer byteArray size * 2) max: startPos + anInteger.
			bigByteArray _ ByteArray new: afterSize.
			bigByteArray
				replaceFrom: 1
				to: beforeSize
				with: aMaSerializedGraphBuffer byteArray
				startingAt: 1.
			aMaObjectBuffer byteArray: bigByteArray.
			aMaSerializedGraphBuffer byteArray: bigByteArray ]! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 6/1/2005 23:57'!
ensureFilesOpen

	file ifNotNil: [ file closed ifTrue: [ self openObjectsFile ] ].
	filePositionIndex ifNil: [ self openFilePositionIndex ]! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 3/1/2005 17:36'!
filePointerForOid: oidInteger

	| answer |
	answer _ filePositionIndex 
		at: (MaOidCalculator indexPositionForOid: oidInteger)
		ifAbsent: [ MagmaInvalidOid signal: oidInteger printString, ' is not a valid oid.' ].
	answer = 0 ifTrue: [ MagmaInvalidOid signal: oidInteger printString, ' is not a valid oid.' ].
	^ answer! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 9/24/2004 13:07'!
filePositionIndexFileName

	^ directory fullNameFor: self class objectPointersFilename! !

!MaObjectFiler methodsFor: 'recovery' stamp: 'cmm 7/5/2005 23:39'!
filesDo: twoArgBlock

	twoArgBlock
		value: file 
		value: MaApplyRecord objectsFileId.
	filePositionIndex filesDo:
		[ : each |
		twoArgBlock
			value: each
			value: MaApplyRecord filePositionsFileId ]! !

!MaObjectFiler methodsFor: 'actions' stamp: ''!
finalize

	self close
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:32'!
getNextOid

	^MaOidCalculator oidForFilePositionIndexPosition: filePositionIndex size + 1! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:45'!
index: oidInteger at: filePositionInteger

	^filePositionIndex
		at: (MaOidCalculator indexPositionForOid: oidInteger)
		put: filePositionInteger! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 10/21/2004 12:53'!
initialize

	super initialize.
	preMadeObjectBuffer _ MaObjectBuffer new.
	usedByteArrays _ (1 to: 8) collect: [ :each | ByteArray new: each ].
	self initializePrimitiveAttributeAddressesMap! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 12/29/2004 00:22'!
initializePrimitiveAttributeAddressesMap

	primitiveAttributeAddressesMap _ Dictionary new
		at: 'signature' put: (Association key: 0 value: 64);
		at: 0 put: 'signature';

		at: 'version' put: (Association key: 8 value: 16);
		at: 2 put: 'version';

		at: 'booleanFlags' put: (Association key: 10 value: 8);
		at: 10 put: 'booleanFlags';

		at: 'definitionOid' put: (Association key: 11 value: 64);
		at: 11 put: 'definitionOid';

		"gap 19-26"
		at: 'classDefinitionsOid' put: (Association key: 27 value: 64);
		at: 27 put: 'classDefinitionsOid';

		at: 'anchorOid' put: (Association key: 43 value: 64);
		at: 43 put: 'anchorOid';

		yourself! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 5/1/2003 17:37'!
isOpen

	^file notNil and: [ file closed not ]! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 4/21/2003 16:29'!
objectFileSize

	^file size! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 6/14/2006 21:40'!
open
	(directory exists and: [ directory fileExists: self class objectsFilename ]) ifFalse: [ MagmaEnvironmentError signal: self dataFileName , ' not found.' ].
	self openObjectsFile.
	[ self validateSignature ] ifCurtailed: 
		[ self close.
		^ self ].
	self openFilePositionIndex! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 7/8/2005 10:11'!
openFilePositionIndex

	filePositionIndex _
		[ MaLargeArrayOfNumbers open:
			(MaTransactionalFileStream fileNamed: self filePositionIndexFileName) ] ifCurtailed: [ self close ]! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 7/7/2005 22:08'!
openFile: unqualifiedName

	| answer |
	answer _ MaTransactionalFileStream fileStream: (directory fileNamed: unqualifiedName).
	answer
		ifNil: [ MagmaEnvironmentError signal: 'Could not open files in ', directory pathName ]
		ifNotNil: [ answer binary ].
	^ answer! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 5/10/2005 19:08'!
openObjectsFile

	file _ self openFile: self class objectsFilename! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 7/15/2005 12:35'!
physicalSizeOfObjectAt: filePointer
	"Answers the size of the buffer currently residing at filePointer."

	preMadeObjectBuffer startPos: 0.
	file
		maRead: MaObjectBuffer headerSize - preMadeObjectBuffer bufferPositionOfBytesToStore + 1
		bytesFromPosition: preMadeObjectBuffer bufferPositionOfBytesToStore
		of: preMadeObjectBuffer byteArray
		atFilePosition: filePointer.
	^ preMadeObjectBuffer physicalSize! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 12/30/2002 21:15'!
primitiveAttributeAddressesMap

	^primitiveAttributeAddressesMap! !

!MaObjectFiler methodsFor: 'accessing' stamp: ''!
primitiveAttributeAt: aString

	| assoc |

	^self
		uint: (assoc _ self primitiveAttributeAddressesMap at: aString) value
		at: assoc key
! !

!MaObjectFiler methodsFor: 'private' stamp: ''!
primitiveAttributeAt: aString put: anInteger

	| assoc |

	self
		uint: (assoc _ self primitiveAttributeAddressesMap at: aString) value
		at: assoc key
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 6/16/2005 10:23'!
read: numberOfBytes bytesInto: aMaObjectBuffer and: aMaSerializedGraphBuffer startingAt: startPos filePosition: anInteger
	"startPos is 0-based, answer the physicalSize of the buffer read."

	| physicalSize numberOfBytesRead numberOfBytesStored |
	numberOfBytesRead _
		file
			maRead: numberOfBytes
			bytesFromPosition: startPos + aMaObjectBuffer bufferPositionOfBytesToStore
			of: aMaObjectBuffer byteArray
			atFilePosition: anInteger.
	"See if we have read enough, if not read the rest of the buffer."
	numberOfBytesStored _ aMaObjectBuffer numberOfBytesToStore.
	physicalSize _ aMaObjectBuffer physicalSize.
	numberOfBytesStored > numberOfBytesRead
		ifTrue:
			[ | resumePosition |
			resumePosition _ startPos + numberOfBytesRead + aMaObjectBuffer bufferPositionOfBytesToStore.
			self
				ensureByteArrayIn: aMaObjectBuffer
				and: aMaSerializedGraphBuffer
				canAccomodate: physicalSize
				bytesFrom: resumePosition.
			file
				next: numberOfBytesStored - numberOfBytesRead
				into: aMaSerializedGraphBuffer byteArray
				startingAt: resumePosition ].
	^ physicalSize! !

!MaObjectFiler methodsFor: 'accessing' stamp: ''!
signature

	^self primitiveAttributeAt: 'signature'
! !

!MaObjectFiler methodsFor: 'private' stamp: ''!
signature: anInteger

	self
		primitiveAttributeAt: 'signature'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 8/12/2002 23:48'!
trackSize
	"This is the minimum number of bytes to read from disk for any object.
	This particular value allows up to 32 instVars to be read at once."

	"^MaAbstractObjectBuffer addressSize * 32 + MaNormalObjectBuffer headerSize"
	^280 "same as above, but faster.."! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 9/24/2004 13:22'!
uint: bits at: anInteger

	| address bytes |

	address _ self usedByteArray: (bytes _ bits / 8).
	file
		maRead: bytes
		bytesFromPosition: 1
		of: address
		atFilePosition: anInteger.
	^address
		maUint: bits
		at: 0
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 6/14/2005 16:19'!
uint: bits at: filePointer put: anInteger

	| ba bytes |

	ba _ self usedByteArray: (bytes _ bits / 8).
	ba
		maUint: bits
		at: 0
		put: anInteger.
	file
		maWrite: bytes
		bytesFromPosition: 1
		of: ba
		atFilePosition: filePointer.
	file maCommit! !

!MaObjectFiler methodsFor: 'recovery' stamp: 'cmm 6/5/2005 18:24'!
unapplyFilePositionsFileUsing: aMaApplyRecord

	filePositionIndex unapplyUsing: aMaApplyRecord! !

!MaObjectFiler methodsFor: 'recovery' stamp: 'cmm 7/12/2005 22:46'!
unapplyObjectsFileUsing: aMaApplyRecord

	aMaApplyRecord unapplySelf: file physicalStream! !

!MaObjectFiler methodsFor: 'recovery' stamp: 'cmm 6/13/2005 21:50'!
unapplyUsing: aMaApplyRecord
	"Reapply the contents of aMaBeforeImageRecord to the file it came from."

	aMaApplyRecord fileId
		caseOf:
			{ [ MaApplyRecord objectsFileId ] -> [ self unapplyObjectsFileUsing: aMaApplyRecord ].
			[ MaApplyRecord filePositionsFileId ] -> [ self unapplyFilePositionsFileUsing: aMaApplyRecord ] }
		otherwise:
			[ MagmaSoftwareError signal: 'unknown fileId' ]! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 7/16/2002 00:08'!
usedByteArray: size

	^usedByteArrays at: size
! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 7/16/2002 00:01'!
validateSignature

	self signature = MaObjectRepository recognitionSignature
		ifFalse:
			[ MagmaUserError signal: 'This does not appear to be a Magma database.' ]
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 7/16/2002 21:53'!
version

	^self primitiveAttributeAt: 'version'! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 7/16/2002 21:53'!
version: anInteger

	self
		primitiveAttributeAt: 'version'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 1/19/2005 15:40'!
write: aMaObjectBuffer at: filePosition
	"Note that the oid is stored in the filePositionsIndex, so there is no need to store it in the data file too.  The oid is the first 8-bytes of the buffer."

	file
		maWrite: aMaObjectBuffer numberOfBytesToStore
		bytesFromPosition:
			aMaObjectBuffer startPos + aMaObjectBuffer bufferPositionOfBytesToStore
		of: aMaObjectBuffer byteArray
		atFilePosition: filePosition! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:45'!
write: aMaObjectBuffer index: aBoolean
	"write a single object encapsulated by aMaObjectBuffer."

	| filePosition |
	filePosition _
		aBoolean
			ifTrue:
				[ self
					index: aMaObjectBuffer oid
					at: file size ]
			ifFalse:
				[ | pos |
				pos _ self filePointerForOid: aMaObjectBuffer oid.
				(self physicalSizeOfObjectAt: pos) < aMaObjectBuffer physicalSize
					ifTrue: [ self index: aMaObjectBuffer oid at: file size ]
					ifFalse: [ pos ] ].
	self
		write: aMaObjectBuffer
		at: filePosition! !

MaObject subclass: #MaObjectRepository
	instanceVariableNames: 'transactionLog sessions filer repositoryController largeCollectionManagers systemReadStrategy nextOid recoveryManager commitGuard applyProcess wantsToClose'
	classVariableNames: 'RunningTestCases SimulateOutage'
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaObjectRepository class methodsFor: 'creation' stamp: 'cmm 9/24/2004 12:50'!
create: aFileDirectory controller: aMaRepositoryController

	^ (self new repositoryController: aMaRepositoryController) create: aFileDirectory! !

!MaObjectRepository class methodsFor: 'class initialization' stamp: 'cmm 7/13/2005 17:31'!
initialize
	super initialize.
	SimulateOutage _ false.
	RunningTestCases _ false! !

!MaObjectRepository class methodsFor: 'creation' stamp: 'cmm 7/18/2005 13:23'!
open: aFileDirectory controller: aMaRepositoryController

	^self new
		repositoryController: aMaRepositoryController ;
		open: aFileDirectory ;
		yourself! !

!MaObjectRepository class methodsFor: 'accessing' stamp: ''!
recognitionSignature

	^5191969
! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 1/18/2005 22:39'!
abortTransactionFor: sessionId

	^ transactionLog 
		abortTransactionEntryFor: sessionId
		repository: self! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 7/8/2005 15:58'!
applyToCache: aMaCommitLogEntry

	| newObjects |
	newObjects _ aMaCommitLogEntry result newObjectBuffers.
	aMaCommitLogEntry commitPackage objectsDo:
		[ : eachBuffer |
		filer
			write: eachBuffer
			index: (newObjects includesKey: eachBuffer oid) ].
	"If writing regular objects caused any new LargeCollections we need to refresh my sessions view of the repository so I know about those collections because I'm about to update them."
	(aMaCommitLogEntry commitPackage shouldServerRefresh or: [ aMaCommitLogEntry shouldServerRefresh ])
		ifTrue:
			[ repositoryController refreshView ].
	self
		updateLargeCollectionsIn: aMaCommitLogEntry commitPackage
		recordResultsIn: aMaCommitLogEntry result! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 3/19/2005 10:59'!
byteArrayAt: oidInteger using: aMaReadStrategy

	^ (MaOidCalculator isOidForUserObject: oidInteger)
		ifTrue:
			[ (self
				graphBufferAt: oidInteger
				using: aMaReadStrategy) trimmedByteArray ]
		ifFalse:
			[ "When could this happen?  (Sigh), when they put an atomic in a MagmaLargeCollection."
			(self session serializer serializeGraph:
				(MaOidCalculator
					objectWithOid: oidInteger
					ifNone: [ MagmaSoftwareError signal: 'unknown oid' ])) trimmedByteArray ]! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 7/8/2005 14:21'!
captureBeforeImages
	"Capture a current description of the actual files in the places where we intend to change them.  We capture whether a file is new, whether it will be extended in length, and what file positions will be overwritten and what contents are there presently."

	self dbFilesDo:
		[ : eachTransactionalFile : eachFileId |
		recoveryManager 
			writeRollbackRecordsFor: eachTransactionalFile
			fileId: eachFileId ].
	recoveryManager flush! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:41'!
classDefinitionsByteArray
	"When initially creating the repository, before even the system root is
	written, the classDefinitionsOid will be a new-object oid."

	| loid |

	^MaOidCalculator oidForNil = (loid _ filer classDefinitionsOid)
		ifTrue:
			[ (self serverSerializer serializeGraph: repositoryController definition classDefinitions) trimmedByteArray ]
		ifFalse:
			[ self
				byteArrayAt: loid
				using: MaBasicReadStrategy deep "we need it all" ]! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 7/9/2006 17:43'!
close
	self isOpen ifFalse: [ ^ self ].
	wantsToClose _ true.
	[ applyProcess notNil and: [ applyProcess isTerminated not ] ] whileTrue: [ (Delay forSeconds: 1) wait ].
	[ largeCollectionManagers anySatisfy: [ : each | each isLoading ] ] whileTrue: [ (Delay forMilliseconds: 500) wait ].
	self commitCritical: [ self isOpen ifTrue: [ self flushCache	"just to be sure" ] ].
	filer ifNotNil: [ filer close ].
	largeCollectionManagers do: [ : each | each close ].
	recoveryManager ifNotNil: [ recoveryManager close ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 7/12/2005 12:57'!
collectionFilenameFor: aMaLargeCollection

	^ self directory fullNameFor:
		(String streamContents:
			[ : stream |
			stream
				print: (self session oidFor: aMaLargeCollection) ;
				nextPut: $. ;
				nextPutAll: aMaLargeCollection implementationClass suggestedFileExtension ])! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 7/12/2005 13:00'!
collectionFilenameFor: oidInteger extension: aString
self maMarked: 'delete'.
	^ self directory fullNameFor:
		(String streamContents:
			[ : stream |
			stream
				print: oidInteger ;
				nextPut: $. ;
				nextPutAll: aString ])! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 6/16/2005 10:53'!
collectionManagerFor: oidInteger

	^ self
		collectionManagerFor: oidInteger
		ifAbsent:
			[ MagmaSoftwareError signal:
				'MagmaCollection ' , oidInteger printString ,
					' not found.  MaObjectRepository>>collectionManagerFor:' ]! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 6/16/2005 10:52'!
collectionManagerFor: oidInteger ifAbsent: aBlock

	^ largeCollectionManagers
		at: oidInteger
		ifAbsent: aBlock! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 7/5/2005 12:36'!
commitCritical: aBlock

	^ commitGuard critical: aBlock! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 5/30/2005 22:28'!
create: aFileDirectory

	filer _ MaObjectFiler create: aFileDirectory.
	nextOid _ filer getNextOid.
	recoveryManager _ MaRecoveryManager open: self directory.
	^ self! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 7/8/2005 14:07'!
dbFilesDo: twoArgBlock
	"Value twoArgBlock with each database file and its fileId."

	filer filesDo: twoArgBlock.
	largeCollectionManagers do: [ : each | each filesDo: twoArgBlock ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:43'!
definitionByteArray

	| oid |
	^MaOidCalculator oidForNil = (oid _ filer definitionOid)
		ifTrue:
			[ (self serverSerializer serializeGraph: repositoryController definition) trimmedByteArray ]
		ifFalse:
			[ self
				byteArrayAt: oid
				using: MaBasicReadStrategy deep "we need it all" ]! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 6/7/2005 10:13'!
deleteApplyFile

	self directory
		rename: recoveryManager class applyFilename
		toBe: 
			(self directory
				nextNameFor: recoveryManager beforeImagesBaseFilename
				extension: recoveryManager imagesExtension)! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 9/24/2004 15:42'!
directory

	^ filer directory! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 6/11/2006 21:30'!
ensureManagerCreatedFor: aMagmaLargeCollection 
	^ largeCollectionManagers 
		at: (self session oidFor: aMagmaLargeCollection)
		ifAbsentPut: [ aMagmaLargeCollection newManagerUsing: self ]! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 5/14/2005 18:08'!
ensureReadStrategy: aMaReadStrategy forSession: sessionId

	| strategy |
	^(strategy _
		self
			renewCurrentReadStrategy: aMaReadStrategy
			for: sessionId)

				ifNil: [ self systemReadStrategy ] 
				ifNotNil: [ strategy ]! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 6/16/2005 11:04'!
fileManagerFor: aMaApplyRecord ifPresent: oneArgBlock ifAbsent: aBlock

	| fileManager |
	fileManager _ aMaApplyRecord fileId
		caseOf:
			{ [ MaApplyRecord objectsFileId ] -> [ filer ].
			[ MaApplyRecord filePositionsFileId ] -> [ filer ] }
		otherwise:
			[ (self 
				collectionManagerFor: aMaApplyRecord collectionOid
				ifAbsent: [ ^ aBlock value ]) indexForFileId: aMaApplyRecord fileId ].
	^ oneArgBlock value: fileManager! !

!MaObjectRepository methodsFor: 'accessing' stamp: ''!
filer

	^filer
! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 7/8/2005 14:20'!
flushCache
	"Flush all caches as an uncorruptible unit-of-work.  If this forked code completes all files are flushed.  Should a power outage occur somewhere in the middle, the recovery will reverse what had been written so far."

	recoveryManager beginApply.
	self 
		captureBeforeImages ;
		flushIndividualCaches.
	SimulateOutage ifTrue: [ self simulateOutage ].
	recoveryManager endApply! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 7/11/2005 10:06'!
flushCacheSoon
	"Flushing is horribly expensive, but essential to ensure we can survive a power-outage without corruption.  To balance these opposing forces, we apply and flush only at certain interval, and only in the background.  This method ensures an apply will occur soon."

	applyProcess ifNil:
		[ applyProcess _
			[ (Delay forSeconds: repositoryController cacheFlushFrequency) wait.
			self commitCritical:
				[ self flushCache.
				applyProcess _ nil ] ] fork.
		applyProcess name: 'flush Magma cache' ]! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 7/8/2005 14:11'!
flushIndividualCaches

	self dbFilesDo: [ : eachFile : eachFileId | eachFile maCommit: true ]! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 7/26/2006 17:54'!
fractionLoaded: collectionOid
	^ (self collectionManagerFor: collectionOid) loadProgress! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/2/2004 13:25'!
getNextOid

	^nextOid _ nextOid + 1! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 8/6/2006 18:32'!
getTrunkFor: collectionOid expression: aMaTerm 
	| executor |
	executor _ MaQueryExecutor 
		collectionManager: (self collectionManagerFor: collectionOid)
		expression: aMaTerm.
	^ executor trunk! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 1/25/2005 14:04'!
graphBufferAt: oidInteger using: aMaReadStrategy
	"Answers a MaSerializedGraphBuffer."

	| answer rootBuffer |
	answer _ MaSerializedGraphBuffer new: 400.
	rootBuffer _ 
		filer
			appendObject: oidInteger
			into: answer.
	rootBuffer
		appendGraphUsing: aMaReadStrategy
		into: answer
		currentDepth: 1
		minDepth: aMaReadStrategy minimumDepth
		with: Set new
		filer: filer.
	^ answer! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 7/19/2006 18:16'!
hashKeysReferencing: eachOid inIndexesOf: sourceManager using: aMagmaCollectionManager 
	| hashesByIndex |
	hashesByIndex _ OrderedCollection new.
	"Normally there will be just one index at this time (building a sort result), but be generic anyway.."
	aMagmaCollectionManager collection indexesDo: 
		[ : eachIndex | 
		| eachKeysHdx eachHashes |
		eachHashes _ OrderedCollection new.
		eachKeysHdx _ sourceManager keysIndexForAttribute: eachIndex attribute.
		eachKeysHdx 
			keysAndValuesFrom: eachOid
			startingAt: 1
			do: [ : eachOidAgain : eachKeyLocation | eachHashes add: eachKeyLocation ]
			until: [ : eachOidAgain : eachKeyLocation | eachOidAgain > eachOid ].
		hashesByIndex add: eachHashes ].
	^ hashesByIndex! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 6/12/2006 13:02'!
initialize
	super initialize.
	transactionLog _ MaTransactionLog new.
	largeCollectionManagers _ Dictionary new.
	sessions _ Dictionary new.
	commitGuard _ Monitor new! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 2/1/2005 22:45'!
initializeClassDefinitionsSpecialOids
	"This collection of special oids can grow.  When it does, clients need to know about it."

	repositoryController definition classDefinitions do:
		[ : each |
		(repositoryController session isPersistent: each)
			ifTrue:
				[ transactionLog
					onChangeOf: (repositoryController session oidFor: each "OrderedCollection of definitions")
					clientsShould: #refreshClassVersions ] ]! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 2/1/2005 22:47'!
initializeSpecialOidsList
	"See MagmaSession>>#handleSpecialOidNotifications:"

	| classDefinitions session |
	classDefinitions _ repositoryController definition classDefinitions.
	session _ repositoryController session.
	(session isPersistent: classDefinitions)
		ifTrue:
			[ transactionLog
				onChangeOf: (repositoryController session oidFor: repositoryController definition classDefinitions)
				clientsShould: #refreshClassDefinitions ].
	self initializeClassDefinitionsSpecialOids! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 2/9/2005 10:26'!
initializeSystemReadStrategyUsing: aMaClassIdManager

	"The object and its immediate variables"
self maMarked: 'dev'.  "Should minimumDepth be 0?  If not, then perhaps we don't need to extend any Collection 1-level further, since the point for it was to merely get its immediately referenced objects...??"
	systemReadStrategy _ MaReadStrategy minimumDepth: 1.
	systemReadStrategy makeReadyForUseUsing: aMaClassIdManager! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 11/1/2004 10:23'!
isOpen

	^ filer notNil and: [ filer isOpen ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: ''!
largeCollectionManagers

	^largeCollectionManagers! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 7/26/2006 17:39'!
loadMemberIndexOf: aMagmaCollectionManager using: aMaTerm from: oidInteger distinct: wantsDistinct 
	"Load memberIndex from the results expression aMaTerm."
	| executor sourceManager |
	sourceManager _ self collectionManagerFor: oidInteger.
	executor _ MaQueryExecutor 
		collectionManager: sourceManager
		expression: aMaTerm.
	aMagmaCollectionManager loadExecutor: executor.
	executor 
		trunkFrom: 1
		do: 
			[ : eachKey : eachOid | 
			| canPossiblyAdd |
			canPossiblyAdd _ (wantsDistinct and: [ aMagmaCollectionManager memberIndex includesKey: eachOid ]) not.
			(canPossiblyAdd and: 
				[ aMaTerm 
					shouldInclude: eachOid
					using: sourceManager ]) ifTrue: 
				[ | hashesByIndex |
				hashesByIndex _ self 
					hashKeysReferencing: eachOid
					inIndexesOf: sourceManager
					using: aMagmaCollectionManager.
				"rare, but possible that it would be made persistent and the commit changes to while sorting and then accessed, therefore critical.."
				self commitCritical: 
					[ aMagmaCollectionManager 
						addMember: eachOid
						atHashes: hashesByIndex.
					self flushCacheSoon ] ] ]
		until: [ aMagmaCollectionManager shouldStopLoading ]! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 7/26/2006 17:22'!
load: aMagmaCollection using: aMaTerm from: oidInteger forSession: sessionId distinct: aBoolean 
	| permanentOid result cm newManager |
	permanentOid _ self getNextOid.
	(self sessionWithId: sessionId) addTransientMagmaCollection: permanentOid.
	result _ (MaReducedReaderResult new)
		collectionOid: permanentOid ;
		yourself.
	self session serializer 
		oidOf: aMagmaCollection
		is: permanentOid.
	newManager _ (self ensureManagerCreatedFor: aMagmaCollection) createNewLargeCollection.
	(cm _ self collectionManagerFor: permanentOid) createSupplementaryIndexes.
	newManager loadProcess: (
		[ self 
			loadMemberIndexOf: cm
			using: aMaTerm
			from: oidInteger
			distinct: aBoolean ] forkAt: Processor userBackgroundPriority).
	newManager loadProcess name: 'loading ', permanentOid printString.
	^ result! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 6/7/2004 15:20'!
newSessionFor: userIdString numberOfChallengers: anInteger
	"Answer an Association whose key is the session id, value is the classMap
	array for that session."

	| connection |
	connection _
		transactionLog
			newSessionFor: userIdString
			numberOfChallengers: anInteger.
	sessions at: connection sessionId put: connection.
	^(Array new: 3)
		at: 1
			put: connection sessionId;
		at: 2
			put: self classDefinitionsByteArray ;
		at: 3
			put: self definitionByteArray;
		yourself! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 1/28/2005 00:04'!
newTransactionFor: sessionIdInteger

	(transactionLog entryFor: sessionIdInteger) isCommitEntry
		ifTrue:
			[ MagmaSoftwareError signal: 'Already in a transaction.' ].
	^ transactionLog
		newTransactionFor: sessionIdInteger
		repository: self! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 4/13/2006 17:11'!
numberOfEntriesFrom: lowKeyInteger to: highKeyInteger inLargeCollection: collectionOid on: attributeSymbol 
	| index |
	index _ (self collectionManagerFor: collectionOid) 
		oidsIndexForAttribute: attributeSymbol.
	^ index 
		numberOfEntriesFrom: lowKeyInteger
		to: highKeyInteger! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:26'!
objectCount

	^nextOid - MaOidCalculator firstUserObjectOid! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 4/21/2003 16:29'!
objectFileSize

	^filer objectFileSize! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 3/16/2005 23:06'!
openLargeCollectionIfNecessary: aMagmaLargeCollection

	(self ensureManagerCreatedFor: aMagmaLargeCollection) ensureOpen! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 7/4/2006 16:18'!
open: aFileDirectory 
	filer _ MaObjectFiler open: aFileDirectory.
	[ self validateVersion ] ifCurtailed: [ filer close ].
	nextOid _ filer getNextOid.
	recoveryManager _ MaRecoveryManager open: aFileDirectory.
	wantsToClose _ false! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 6/1/2005 23:56'!
primitiveRecover
	"This is needed in very rare, dire circumstances where the server was actually writing its own system-definition when an outage occurred.  In that case the repository will not even be able to open normally to get to the normal recovery.  That condition is trapped for any Error and sent here to try opening all files in the directory and then doing a normal unapply (rollback).  Theoretically, that should work."

	filer ensureFilesOpen.
	recoveryManager primitiveRecoverUsing: self! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 6/6/2005 12:42'!
queueForDelete: filename
	"When removing indexees, we actually remove the supporting file.  However, we don't want to do that until the commit actually succeeds.  Therefore, we a queue the files to deleted until the commit succeeds, then we delete it."

	recoveryManager queueForDelete: (self directory fullNameFor: filename)! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 5/14/2005 18:27'!
readAnchorFor: sessionId using: aMaReadStrategy

	| anchorOid |
	^ MaOidCalculator oidForNil = (anchorOid _ filer anchorOid)
		ifTrue:
			[ (self serverSerializer serializeGraph: MaRootAnchor new) trimmedByteArray ]
		ifFalse:
			[ self
				read: anchorOid
				for: sessionId
				using: aMaReadStrategy ]! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 5/14/2005 18:11'!
read: oidInteger for: sessionId using: aMaReadStrategy

	| result |
	result _ MaReadResult byteArray:
		(self
			byteArrayAt: oidInteger
			using:
				(self 
					ensureReadStrategy: aMaReadStrategy
					forSession: sessionId)).
	self
		renewServerNotificationsIn: result
		for: sessionId.
	^ result! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 7/16/2005 16:56'!
recoverIfNecessary

	^ recoveryManager isRollbackNeeded
		ifTrue:
			[ RunningTestCases ifFalse: [ MagmaRecoveryNeeded signal: 'A partially flushed cache has been detected!!  This repository will now be recovered.' ].
			recoveryManager rollbackUsing: self. "NOTE:  This replaces me in my repositoryController, that's why we return from this method after the rollback, to unwind this now-stale instance and re-call in the new instance."
			true ]
		ifFalse:
			[ recoveryManager
				reapplyCommitPackagesUsing: self ;
				resetFiles.
			false ]! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 8/6/2006 21:22'!
refreshSegmentIn: aMaRefreshSegmentRequest 
	(self collectionManagerFor: aMaRefreshSegmentRequest collectionOid) 
		load: aMaRefreshSegmentRequest segment
		upTo: aMaRefreshSegmentRequest quantity
		where: aMaRefreshSegmentRequest expression
		withObjects: aMaRefreshSegmentRequest loadObjects
		except: aMaRefreshSegmentRequest exceptions.
	aMaRefreshSegmentRequest segment 
		collectBuffers: aMaRefreshSegmentRequest sessionId
		from: self
		using: aMaRefreshSegmentRequest readStrategy.
	self 
		renewServerNotificationsIn: aMaRefreshSegmentRequest segment
		for: aMaRefreshSegmentRequest sessionId.
	^ aMaRefreshSegmentRequest segment! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 6/13/2006 00:01'!
removeManager: collectionOid 
	largeCollectionManagers 
		removeKey: collectionOid
		ifAbsent: 
			[ "no foul no harm"
			 ]! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 7/4/2006 18:56'!
removeSessionFor: sessionId 
	self removeTransientMagmaCollectionsFor: sessionId.
	sessions 
		removeKey: sessionId
		ifAbsent: [ MagmaUserError signal: 'session not connected.' ].
	transactionLog 
		removeEntryForSessionId: sessionId
		ifAbsent: [ MagmaUserError signal: 'session not connected.' ]! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 8/2/2006 21:34'!
removeTransientMagmaCollectionsFor: sessionId 
	"any sort operations that had required building of a transient MagmaCollection that never actually got committed to the db should have their files cleaned up."
	(self sessionWithId: sessionId) ifNotNilDo: 
		[ : aMagmaClientConnection | 
		aMagmaClientConnection transientMagmaCollectionOidsDo: 
			[ : each | 
			| cm |
			cm _ self 
				collectionManagerFor: each
				ifAbsent: 
					[ "seems like this shouldn't happen, but we probably shouldn't complain if it does"
					nil ].
			cm pleaseStopLoading.
			[ cm isLoading ] whileTrue: [ (Delay forMilliseconds: 250) wait ].
			self
				commitCritical: [ cm delete ] ;
				removeManager: each ] ]! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 4/28/2003 23:51'!
renewCurrentReadStrategy: aMaReadStrategy for: sessionId

	| session |
	session _ self sessionWithId: sessionId.
	aMaReadStrategy ifNotNil: [ session currentReadStrategy: aMaReadStrategy ].
	^session currentReadStrategy! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 12/16/2002 23:52'!
renewRefreshFlagFor: sessionId

	^(transactionLog entryFor: sessionId) renewRefreshFlag! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 1/25/2005 17:03'!
renewServerNotificationsIn: aMagmaServerResult for: sessionId

	self
		renewServerNotificationsIn: aMagmaServerResult
		for: sessionId
		from: (transactionLog entryFor: sessionId)! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 1/25/2005 17:02'!
renewServerNotificationsIn: aMagmaServerResult for: sessionId from: aMaTransactionLogEntry

	aMagmaServerResult
		serverNotifications: aMaTransactionLogEntry renewServerNotifications ;
		shouldRefresh: (self renewRefreshFlagFor: sessionId).
	aMagmaServerResult serverNotifications keysAndValuesDo:
		[ : eachKey : eachSet |
		aMagmaServerResult serverNotifications
			at: eachKey
			put: (eachSet collect: [ : eachOid | self byteArrayAt: eachOid using: MaReadStrategy deep ]) ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 7/8/2005 17:16'!
repositoryController
	^ repositoryController! !

!MaObjectRepository methodsFor: 'building' stamp: ''!
repositoryController: aMaRepositoryController

	repositoryController _ aMaRepositoryController.
	aMaRepositoryController repository == self ifFalse: [ aMaRepositoryController repository: self ]
! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/31/2002 12:56'!
serverSerializer

	^repositoryController serverSerializer! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/31/2002 12:55'!
session

	^repositoryController session! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 5/2/2003 15:05'!
sessions

	^sessions! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 6/9/2005 14:40'!
sessionWithId: anInteger

	^sessions 
		at: anInteger
		ifAbsent: [ MagmaSessionLost signal ]! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 6/14/2005 17:30'!
sizeOfLargeCollection: oidInteger

	^ (self collectionManagerFor: oidInteger) size! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 7/8/2005 15:39'!
submitAll: aMaCommitPackage for: sessionId beginAnother: aBoolean
	"Save all of the serialized objects in aMaCommitPackage to the repository.
	If any of the objects in aMaCommitPackage have been changed by other transactions
	signal a commit failure."

	| entry |
	entry _ 
		transactionLog
			renewEntryFor: sessionId
			beginAnother: aBoolean
			for: self.
	entry isCommitEntry ifFalse: [ MagmaUserError signal: 'No transaction to commit.' ].
	entry
		determineResultFor: aMaCommitPackage
		using: largeCollectionManagers.
	entry result hasConflicts
		ifTrue:
			[ MagmaCommitError new
				result: entry result;
				signal ]
		ifFalse:
			[ entry commitPackage: aMaCommitPackage.
			self write: entry ].
	"Make sure system session doesn't exceed maximumNumberOfChallengers"
	self maMarked: 'performance'.  "the repositoryController session never enters a transaction, so it should be sensitive to the maximumNumberOfChallengers built-in mechanism for suggesting an abort.  Let's test that.."
	(sessionId ~= repositoryController sessionId
		and: [ transactionLog isFirstEntryFor: repositoryController sessionId ])
			ifTrue: [ repositoryController refreshView ].
	^entry result! !

!MaObjectRepository methodsFor: 'read strategies' stamp: 'cmm 9/1/2003 19:11'!
systemReadStrategy

	^systemReadStrategy! !

!MaObjectRepository methodsFor: 'recovery' stamp: 'cmm 6/16/2005 11:12'!
unapply: aMaApplyRecord
	"Reapply the contents of aMaApplyRecord to the file it came from."

	self 
		fileManagerFor: aMaApplyRecord
		ifPresent: [ : fileManager | fileManager unapplyUsing: aMaApplyRecord ]
		ifAbsent: 
			[ "This could happen if a new file was created (i.e., a new large-collection) but the system crashed before the writes of the definition occurred; in which case the largeCollectionManager would not be able to be opened."
			aMaApplyRecord "should be a MaNewFileRecord" 
				unapplySelf:
					(self directory fileNamed: aMaApplyRecord filename) ]! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 7/12/2005 11:25'!
updateLargeCollectionsIn: aMaCommitPackage recordResultsIn: aMaCommitResult
	"The repositoryControllers sessions view of the repository must be completely refreshed, it must know about all new collections."

	aMaCommitPackage allLargeCollectionChangesDo:
		[ : each |
		each isNewCollection
			ifTrue:
				[ | permanentOid mc |
				permanentOid _ aMaCommitResult permanentOids at: each collectionOid ifAbsent: [ MagmaSoftwareError signal: 'expected to find permanent oid for new collection ', each collectionOid printString ].
				each collectionOid: permanentOid.
				mc _ 
					self session 
						objectWithOid: each collectionOid 
						ifAbsent:
							[ MagmaSoftwareError signal: 'expected to know about MagmaCollection ', each collectionOid, ' here.' ].
				(self ensureManagerCreatedFor: mc) 	createNewLargeCollection ].
		each hasAddedIndexes 
			ifTrue:
				[ (self collectionManagerFor: each collectionOid) createSupplementaryIndexes ] ].
	aMaCommitPackage allLargeCollectionChangesDo:
		[ :each |
		(self collectionManagerFor: each collectionOid)
			process: each
			recordResultsIn: aMaCommitResult ]! !

!MaObjectRepository methodsFor: 'client-requests' stamp: 'cmm 4/12/2006 21:14'!
upTo: anInteger oidsFromIndex: startIndex inLargeCollection: collectionOid using: aMaReadStrategy forSession: sessionId 
	| segmentResult |
	segmentResult _ (self collectionManagerFor: collectionOid) 
		upTo: anInteger
		inSegmentFromIndex: (startIndex max: 1).
	segmentResult 
		collectBuffers: sessionId
		from: self
		using: aMaReadStrategy.
	self 
		renewServerNotificationsIn: segmentResult
		for: sessionId.
	^ segmentResult! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 6/14/2006 21:43'!
validateVersion
	filer version = MagmaSession magmaVersion
		ifFalse:
			[ MagmaUserError signal: 'This database requires code version ', self version printString, '.  You are running version ', MagmaSession magmaVersion printString ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 4/21/2003 16:02'!
version

	^filer version! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 7/4/2006 16:20'!
wantsToClose
	^ wantsToClose ! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 7/17/2005 00:29'!
write: aMaCommitLogEntry

	aMaCommitLogEntry
		registerUsing: self ;
		link ;
		record.
	aMaCommitLogEntry hasAnyCommitted
		ifTrue:
			[ transactionLog challengeEntriesWith: aMaCommitLogEntry ].
	aMaCommitLogEntry didCommitSpecialOid
		ifTrue:
			[ self initializeClassDefinitionsSpecialOids ].
	self commitCritical:
		[ | trimmedEntry |
		trimmedEntry _ aMaCommitLogEntry trimmedCopy.
		self applyToCache: trimmedEntry "because the trimmedEntry must work on recovery!!".
		recoveryManager 
			log: trimmedEntry
			flush: repositoryController flushAggressively.
		self flushCacheSoon ]! !

MaObject subclass: #MaQueryExecutor
	instanceVariableNames: 'expression collectionManager trunk trunkPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaQueryExecutor class methodsFor: 'create' stamp: 'cmm 6/11/2006 20:06'!
collectionManager: aMagmaCollectionManager expression: aMaExpression 
	^ self new 
		setCollectionManager: aMagmaCollectionManager
		expression: aMaExpression! !

!MaQueryExecutor methodsFor: 'accessing' stamp: 'cmm 7/26/2006 17:53'!
fractionComplete
	^ trunkPosition 
		ifNil: [ 0 ]
		ifNotNil: 
			[ | trunkSize |
			trunkSize _ self trunk trunkSize.
			trunkSize = 0 
				ifTrue: [ 1 ]
				ifFalse: [ trunkPosition / self trunk trunkSize ] ]! !

!MaQueryExecutor methodsFor: 'private' stamp: 'cmm 8/31/2006 19:03'!
load: aMagmaCollectionSegment upTo: anInteger withObjects: aBoolean except: removedSet 
	"Load my segment with up to anInteger oids.  Since we load segments in succession, only capture the answer oids for the page that surrounds targetIndexInteger."
	| trunkEndPosition hitCount highestKey endIndex |
	highestKey _ hitCount _ 0.
	trunkEndPosition _ self 
		trunkFrom: aMagmaCollectionSegment trunkStart
		do: 
			[ : eachKey : eachOid | 
			(expression 
				shouldInclude: eachOid
				using: collectionManager) ifTrue: 
				[ highestKey _ eachKey max: highestKey.
				(removedSet includes: eachOid) ifFalse: 
					[ hitCount _ hitCount + 1.
					aBoolean ifTrue: [ aMagmaCollectionSegment addObject: eachOid ] ] ] ]
		until: [ hitCount = anInteger ].
	endIndex _ aMagmaCollectionSegment startIndex + hitCount - 1.
	aMagmaCollectionSegment
		trunk: self trunk ;
		highestKey: highestKey ;
		trunkEnd: trunkEndPosition.
	aMagmaCollectionSegment endIndex: endIndex.
	self 
		recordLastKnownSizeOn: aMagmaCollectionSegment
		to: endIndex
		ifBeyond: trunkEndPosition! !

!MaQueryExecutor methodsFor: 'private' stamp: 'cmm 7/28/2006 14:57'!
recordLastKnownSizeOn: aMagmaCollectionReaderSegment to: endIndex ifBeyond: trunkEndPosition 
	trunk trunkSize = 0 
		ifTrue: 
			[ "empty, no possible results"
			aMagmaCollectionReaderSegment lastKnownSize: 0 ]
		ifFalse: 
			[ trunkEndPosition ifNotNil: 
				[ aMagmaCollectionReaderSegment lastKnownSize: (trunkEndPosition >= trunk trunkSize ifTrue: [ endIndex ]) ] ]! !

!MaQueryExecutor methodsFor: 'initializing' stamp: 'cmm 6/11/2006 20:06'!
setCollectionManager: aMagmaCollectionManager expression: aMaExpression 
	collectionManager _ aMagmaCollectionManager.
	expression _ aMaExpression! !

!MaQueryExecutor methodsFor: 'private' stamp: 'cmm 6/13/2006 13:27'!
trunk
	^ trunk ifNil: 
		[ trunk _ MaQueryTrunk new.
		expression 
			addMinimumEnumerationsTo: trunk
			using: collectionManager.
		trunk ]! !

!MaQueryExecutor methodsFor: 'private' stamp: 'cmm 7/26/2006 17:36'!
trunkFrom: startPosition do: twoArgBlock until:  conditionBlock
	"Enumerate my query-trunk from a particular starting point."
	| trunkSearchPosition |
	trunkSearchPosition _ 1.
	trunkPosition _ nil.
	self trunk trunkDo: 
		[ : eachTrunkClause | 
		| hdx rangeSize |
		hdx _ collectionManager oidsIndexForAttribute: eachTrunkClause attribute.
		rangeSize _ hdx 
			numberOfEntriesFrom: eachTrunkClause lowKey
			to: eachTrunkClause highKey.
		eachTrunkClause lastKnownSize: rangeSize.
		"is this NOT the trunk-clause which will contain trunk-position startPosition?"
		trunkSearchPosition + rangeSize - 1 < startPosition 
			ifTrue: [ trunkSearchPosition _ trunkSearchPosition + rangeSize ]
			ifFalse: 
				[ "trunkSearchPosition is only set to position of the beginning of this clause of the trunk, trunkPosition keeps the actual trunkPosition."
				trunkPosition ifNil: [ trunkPosition _ startPosition - 1 "start one-back since we pre-increment (because post-increment leaves it advanced one too far)" ].
				conditionBlock value ifFalse:
					[ hdx 
						keysAndValuesFrom: eachTrunkClause lowKey
						startingAt: (startPosition - trunkSearchPosition + 1 max: 1)
						do: 
							[ : eachKey : eachOid | 
							trunkPosition _ trunkPosition + 1.
							twoArgBlock value: eachKey value: eachOid  ]
						until: 
							[ : eachKey : eachOid | 
							conditionBlock value 
							or: [ eachKey > eachTrunkClause highKey ] ].
					trunkSearchPosition _ trunkPosition ] ]. 
].
	^ trunkPosition! !

MaObject subclass: #MaQueryTrunk
	instanceVariableNames: 'clauses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaQueryTrunk commentStamp: '<historical>' prior: 0!
My ranges represent the shortest path through the query.!

!MaQueryTrunk methodsFor: 'initializing' stamp: 'cmm 5/31/2006 20:19'!
addClause: aMaQueryTrunkClause 
	^ clauses add: aMaQueryTrunkClause! !

!MaQueryTrunk methodsFor: 'initializing' stamp: 'cmm 5/31/2006 20:36'!
initialize
	super initialize.
	clauses _ OrderedCollection new! !

!MaQueryTrunk methodsFor: 'accessing' stamp: 'cmm 7/2/2006 21:12'!
sortAttribute
	"My clauses are reduced to just the ones that must be enumerated to find the result.  If that reduction was down to one then the order will be per that indexed attribute."
	^ clauses size = 1 ifTrue: [ clauses first attribute ]! !

!MaQueryTrunk methodsFor: 'enumerating' stamp: 'cmm 5/31/2006 21:58'!
trunkDo: aBlock
	clauses do: aBlock! !

!MaQueryTrunk methodsFor: 'accessing' stamp: 'cmm 5/31/2006 20:11'!
trunkSize
	^ clauses inject: 0 into: [ : sum : each | sum + each lastKnownSize ]! !

MaObject subclass: #MaRecoveryManager
	instanceVariableNames: 'applyFile commitPackagesFile serializer preMadeRecords groupId filesToDelete'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaRecoveryManager commentStamp: 'cmm 7/4/2005 23:07' prior: 0!
I am responsible for recovery behaviors.

Commit-packages received into the server are prepared, serialized and flushed, wrapped in MaRecoveryRecord, to a commitPackages file.  A separate process runs repeatedly, Delaying five seconds and then forking an atomicApply.

An atomicApply enumerates all of the MaTransactionalFileWriters and captures before-images of the portions of the files about to be overwritten, flushes them to the before-images file.  Then flushes all of the MaTransactionalFileWriters to their respective files.  Finally, an endApply record is flushed to the before-images file and the commitPackages filePointer is reset.

Reads can be interleaved with the atomicWrite but not commits.  We want to be sure to only apply to the files *between* commits.  So we could use a commitCritical: method to MaObjectRepository and also each MaTransactionalFileStream would need to have a read guard.

Recovery

If an outage occurs, we have, in the worst case:

	1) some data partially applied
	2) some data written to commitPackages, but not yet applied

Recovery addresses these in order.

Read the apply-file and look for an incomplete group, a set of RecoveryRecords that have no EndApplyRecord.  If this condition is discovered, the server was in the middle of an atomicApply when failure occurred.  A partial apply occurred and we must write all of the before-images back to the various files.  Do that.

Now we know we do not have corrupt files, however we next need to apply all of the commitPackages that were written to the commitPackages file but not yet applied.

*If* we had an incomplete group of recovery records in step 1, the entire commitPackages file will need reapplied.  Otherwise, we just apply the commitPackages whose groupId is greater than the groupId of the group in the applyFile, which will be all or none of them.


The CommitPackages File

When the server receives a commit-package, it contains a bunch of MaObjectBuffers of the changes that client applied.  Some of these buffers are for new (uncomitted) objects (which can be identified by their oid being in the reserved range for new-objects).  Before writing, the server will examine the commit-package to determine whether its application will result in any commit-conflicts (and signal an exception if necessary).  Next, it must assign permanent-oids for all of the new objects and update references to them in the other buffers.

Now the commit-package is flushed to the commits file.  Hopefully what was just written will never need to be read.!

!MaRecoveryManager class methodsFor: 'accessing' stamp: 'cmm 6/9/2005 15:55'!
applyFilename
	^ 'applied.images'! !

!MaRecoveryManager class methodsFor: 'accessing' stamp: 'cmm 7/7/2005 22:28'!
commitPackagesFilename
	^ 'commitPackages'! !

!MaRecoveryManager class methodsFor: 'create' stamp: 'cmm 5/30/2005 22:28'!
open: aFileDirectory

	^ self new
		open: aFileDirectory ;
		yourself! !

!MaRecoveryManager methodsFor: 'debugging' stamp: 'cmm 7/16/2005 17:58'!
applyRecords

	| answer |
	answer _ OrderedCollection new.
	[ self applyRecordsDo:
		[ : each |
		answer add: each independentCopy ] ]

		on: MaUnreadableRecoveryRecord
		do: [ : err | answer add: err messageText ].
	^ answer! !

!MaRecoveryManager methodsFor: 'recover' stamp: 'cmm 7/15/2005 16:25'!
applyRecordsDo: aBlock
	"Enumerate the block of RecoveryRecords for a single groupId in my applyFile."

	| currentPosition selectedRecord |
	currentPosition _ 0.
	[ selectedRecord _ 
		self 
			readRecoveryFile: applyFile
			at: currentPosition.
	selectedRecord isBeginApply
		ifTrue: [ groupId _ selectedRecord groupId ]
		ifFalse: 
			[ selectedRecord groupId = groupId
				ifFalse:
					[ MaUnreadableRecoveryRecord signal: 'expected groupId ', groupId printString, ' but encountered record with ', selectedRecord groupId printString. ] ].
	aBlock value: selectedRecord.
	selectedRecord isEndApply ]
		whileFalse:
			[ currentPosition _ currentPosition + selectedRecord physicalSize ]! !

!MaRecoveryManager methodsFor: 'access' stamp: 'cmm 6/2/2005 22:51'!
beforeImagesBaseFilename
	^ 'recovered'! !

!MaRecoveryManager methodsFor: 'record' stamp: 'cmm 7/12/2005 14:28'!
beginApply

	self preMadeBeginApplyRecord
		groupId: self getNextGroupId ;
		writeTo: applyFile  "no need to flush until the first ApplyRecord is written."! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 7/4/2005 23:19'!
close

	applyFile close.
	commitPackagesFile close! !

!MaRecoveryManager methodsFor: 'debugging' stamp: 'cmm 7/16/2005 18:19'!
commitPackageRecords

	| answer |
	answer _ OrderedCollection new.
	[ self commitPackageRecordsDo:
		[ : each |
		answer add: each independentCopy ] ]

		on: MaUnreadableRecoveryRecord
		do: [ : err | answer add: err messageText ].
	^ answer! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 7/10/2005 23:37'!
commitPackageRecordsDo: aBlock
	"Because the file is truncated after every successful open, we know the only possible well-formed records starting from the beginning are the ones that need to be reapplied."

	| currentPosition selectedRecord |
	currentPosition _ 0.
	[ selectedRecord _ 
		self 
			readRecoveryFile: commitPackagesFile
			at: currentPosition.
	aBlock value: selectedRecord.
	commitPackagesFile atEnd ]
		whileFalse:
			[ currentPosition _ currentPosition + selectedRecord physicalSize ]! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 6/13/2005 17:25'!
deleteFilesQueuedForDelete

	filesToDelete do:
		[ : each |  | fd |
		(fd _ FileDirectory on: each) deleteFileNamed: (fd localNameFor: each) ].
	self initializeFilesToDelete! !

!MaRecoveryManager methodsFor: 'record' stamp: 'cmm 7/25/2005 17:06'!
endApply

	self preMadeEndApplyRecord
		groupId: groupId ;
		writeTo: applyFile.
	applyFile flush.
	self deleteFilesQueuedForDelete.
	"Ok, this group is a wrap.  We can now start back at the beginning."
	applyFile position: 0.
	commitPackagesFile position: 0.
	serializer resetOidManager! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 5/31/2005 17:36'!
ensureByteArray: aByteArray canHold: anInteger

	| newAnswer |
	^aByteArray size < anInteger
		ifTrue:
			[ newAnswer _ ByteArray new: anInteger.
			newAnswer
				replaceFrom: 1
				to: aByteArray size
				with: aByteArray
				startingAt: 1.
			newAnswer ]
		ifFalse: [ aByteArray ]! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 6/7/2005 22:58'!
flush
	applyFile flush! !

!MaRecoveryManager methodsFor: 'record' stamp: 'cmm 6/5/2005 21:40'!
getNextGroupId 

	^ groupId _ groupId + 1! !

!MaRecoveryManager methodsFor: 'access' stamp: 'cmm 6/2/2005 22:49'!
imagesExtension

	^ 'images'! !

!MaRecoveryManager methodsFor: 'initialize' stamp: 'cmm 7/16/2005 22:07'!
initialize
	super initialize.
	groupId _ 0.
	self 
		initializePreMadeRecords ;
		initializeFilesToDelete ;
		initializeSerializer! !

!MaRecoveryManager methodsFor: 'initialize' stamp: 'cmm 6/6/2005 12:37'!
initializeFilesToDelete

	filesToDelete _ OrderedCollection new! !

!MaRecoveryManager methodsFor: 'initialize' stamp: 'cmm 7/8/2005 11:07'!
initializePreMadeRecords

	preMadeRecords _ 
		{ MaBeginApplyRecord new.
		MaBeforeImageRecord new.
		MaFileGrowthRecord new.
		MaNewFileRecord new.
		MaEndApplyRecord new.
		MaCommitPackageRecord new }! !

!MaRecoveryManager methodsFor: 'initialize' stamp: 'cmm 8/17/2005 19:12'!
initializeSerializer

	| allClasses |
	serializer := MaObjectSerializer new.
	allClasses := OrderedCollection new.
	allClasses addAll: 
		{ MaCommitLogEntry.  MaCommitPackage.  IdentityDictionary.  MaCommitResult.  MaSerializedGraphBuffer. MaChangedKeySpecification }.
	MaObjectBuffer withAllSubclassesDo: [ : each | allClasses add: each ].
	MagmaLargeCollectionChanges allSubclassesDo: [ : each | allClasses add: each ].
	MagmaCollectionIndex allSubclassesDo: [ : each | allClasses add: each ].
	allClasses do: [ : each | serializer classIdManager addNewClass: each ]! !

!MaRecoveryManager methodsFor: 'recover' stamp: 'cmm 7/15/2005 16:25'!
isRollbackNeeded

	| hasRecords hasValidEndApplyIndicator |
	hasRecords _ false.
	hasValidEndApplyIndicator _ false.
	[ self applyRecordsDo:
		[ : each |
		each isBeginApply ifTrue: [ hasRecords _ true ].
		each isEndApply
			ifTrue:
				[ hasValidEndApplyIndicator _ true ] ] ]
		on: MaUnreadableRecoveryRecord
		do: 
			[ : error |
			"An incomplete set of records for a single transactionId was found."
			MagmaNotification signal: error messageText.
			error return ].
	^ hasRecords and: [ hasValidEndApplyIndicator not ]! !

!MaRecoveryManager methodsFor: 'commit-packages' stamp: 'cmm 7/16/2005 22:09'!
log: aMaCommitLogEntry flush: aBoolean

	self preMadeCommitPackageRecord
		record: (serializer serializeGraph: aMaCommitLogEntry) trimmedByteArray ;
		groupId: self getNextGroupId ;
		writeTo: commitPackagesFile.
	aBoolean ifTrue: [ commitPackagesFile flush ]! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 7/7/2005 15:09'!
openApplyFile: aFileDirectory

	applyFile _ aFileDirectory fileNamed: self class applyFilename.
	applyFile
		binary ;
		position: 0! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 7/7/2005 22:32'!
openCommitPackagesFile: aFileDirectory

	commitPackagesFile _ aFileDirectory fileNamed: self class commitPackagesFilename.
	commitPackagesFile
		binary ;
		position: 0! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 7/4/2005 23:25'!
open: aFileDirectory

	self
		openApplyFile: aFileDirectory ;
		openCommitPackagesFile: aFileDirectory! !

!MaRecoveryManager methodsFor: 'preMadeRecords' stamp: 'cmm 6/5/2005 16:40'!
preMadeBeforeImageRecord
	^ preMadeRecords at: MaBeforeImageRecord assignedRecordType! !

!MaRecoveryManager methodsFor: 'preMadeRecords' stamp: 'cmm 6/5/2005 16:41'!
preMadeBeginApplyRecord 
	^ preMadeRecords at: MaBeginApplyRecord assignedRecordType! !

!MaRecoveryManager methodsFor: 'preMadeRecords' stamp: 'cmm 7/8/2005 11:06'!
preMadeCommitPackageRecord 
	^ preMadeRecords at: MaCommitPackageRecord assignedRecordType! !

!MaRecoveryManager methodsFor: 'preMadeRecords' stamp: 'cmm 6/5/2005 16:41'!
preMadeEndApplyRecord 
	^ preMadeRecords at: MaEndApplyRecord assignedRecordType! !

!MaRecoveryManager methodsFor: 'preMadeRecords' stamp: 'cmm 6/5/2005 16:41'!
preMadeFileGrowthRecord
	^ preMadeRecords at: MaFileGrowthRecord assignedRecordType! !

!MaRecoveryManager methodsFor: 'preMadeRecords' stamp: 'cmm 6/5/2005 16:41'!
preMadeNewFileRecord
	^ preMadeRecords at: MaNewFileRecord assignedRecordType! !

!MaRecoveryManager methodsFor: 'recover' stamp: 'cmm 7/15/2005 16:25'!
primitiveRecoverUsing: aMaObjectRepository
	"This recovery only happens if there was an outage exactly at the moment where the system was writing its own definition.  In that case, it would not even be able to open properly to perform a normal recovery; therefore we do this initial recovyer which should then *allow* it to materialize its definition so that it can then perform a normal recovery which will get the large-collections.  Whew!!"

	MagmaRecoveryNotification signal: 'System recovery needed!!'.
	[ self applyRecordsDo: 
		[ : eachRecoveryRecord | 
		(eachRecoveryRecord isApply and: [ eachRecoveryRecord isForObjectsFile or: [ eachRecoveryRecord isForFilePositionsFile ] ])
			ifTrue:
				[ aMaObjectRepository unapply: eachRecoveryRecord ] ] ]

		on: MaUnreadableRecoveryRecord
		do: 
			[ : error | 
			MagmaRecoveryNotification signal: error messageText, '.  System recovery complete.' ].
	^ true! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 6/6/2005 12:40'!
queueForDelete: filename

	filesToDelete add: filename! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 5/31/2006 19:13'!
readRecoveryFile: aStandardFileStream at: filePosition

	| messagePrefix bytesRead inputRecord |
	messagePrefix _ 'Ungraceful end of commit-group:  '.
	inputRecord _ MaRecoveryRecord new: self reasonableRecordSize.
	bytesRead _ aStandardFileStream
		maRead: self reasonableRecordSize
		bytesFromPosition: 1
		of: inputRecord byteArray
		atFilePosition: filePosition.
	(bytesRead between: 1 and: MaRecoveryRecord sizeOfPhysicalSizeField) ifTrue: [ MaUnreadableRecoveryRecord signal: messagePrefix, 'physicalSize field truncated' ].
	inputRecord physicalSize = 0 ifTrue: [ MaUnreadableRecoveryRecord signal: messagePrefix, 'physicalSize 0 found.' ].
	inputRecord physicalSize > self unreasonablePhysicalSize
		ifTrue: [ MaUnreadableRecoveryRecord signal: messagePrefix, 'unreasonable physicalSize found' ].
	"check physicalSize to see if we've read enough."
	inputRecord physicalSize > bytesRead 
		ifTrue:
			[ "We haven't read enough, read the rest, ensuring we get as much as we should."
			inputRecord byteArray:
				(self
					ensureByteArray: inputRecord byteArray
					canHold: inputRecord physicalSize).
			bytesRead _ aStandardFileStream
				maRead: inputRecord physicalSize - self reasonableRecordSize
				bytesFromPosition: self reasonableRecordSize + 1
				of: inputRecord byteArray
				atFilePosition: filePosition + self reasonableRecordSize.
			bytesRead = (inputRecord physicalSize - self reasonableRecordSize) ifFalse: [ MaUnreadableRecoveryRecord signal: messagePrefix, 'end of file' ] ].
	inputRecord hasValidCheckSum 
		ifFalse:
			[ MaUnreadableRecoveryRecord signal: 'record could not validate its checkSum.' ].
	^ self selectPreMadeRecord: inputRecord! !

!MaRecoveryManager methodsFor: 'recover' stamp: 'cmm 7/17/2005 12:13'!
reapplyCommitPackagesUsing: aMaObjectRepository
	"Note, we just performed step 1 of the recovery which should have properly set my groupId."

	| count |
	count _ 0.
	groupId = 0 "we didn't get a valid beginApply record!!" ifTrue: [ ^ self ].
	[ self commitPackageRecordsDo: 
		[ : each |  | eachCommitLogEntry |
		each groupId > groupId
			ifTrue:
				[ (MagmaServerPreferences debugRecovery and: [ count = 0 ]) ifTrue: [ self halt: 'about to reapply' ].
				count _ count + 1.
				eachCommitLogEntry _ serializer materializeGraph: each record.
				aMaObjectRepository applyToCache: eachCommitLogEntry ] ] ]
		on: MaUnreadableRecoveryRecord
		do: 
			[ : error | 
			MagmaRecoveryNotification signal: error messageText, '.  ', count printString, ' reapply''s completed.' ].
	count > 0 ifTrue: [ aMaObjectRepository flushCache ]! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 7/11/2005 09:28'!
reasonableRecordSize

	^ 100! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 7/11/2005 09:33'!
resetFiles
	"Done with a recovery, now we should truncate both files so that future sessions have no chance to encounter the data in these files and think recovery operations are needed from them (very remote chance, but possible on the commitPackages file.."

	commitPackagesFile truncate; close; open.
	applyFile truncate; close; open! !

!MaRecoveryManager methodsFor: 'recover' stamp: 'cmm 7/15/2005 16:25'!
rollbackUsing: aMaObjectRepository
	"If a beginApply record with a valid checkSum is found, then we must find a corresponding endApply record also with a valid checkSum.  If we don't, then we must reverse the entire transaction by starting back at the beginning and applying all of the beforeImage records with valid checkSums back to their files."

	MagmaServerPreferences debugRecovery ifTrue: [ self halt: 'about to rollback' ].
	[ self applyRecordsDo: 
		[ : each | each isApply ifTrue: [ aMaObjectRepository unapply: each ] ] ]

		on: MaUnreadableRecoveryRecord
		do: 
			[ : error | 
			MagmaRecoveryNotification signal: error messageText, '.  Rollback complete.' ].
	aMaObjectRepository repositoryController close "because class-definitions or largeCollections may have even needed rolled-back; refreshView will not refresh them.".
	aMaObjectRepository deleteApplyFile.  "so we don't try to recover again on the next open.."
	aMaObjectRepository repositoryController open! !

!MaRecoveryManager methodsFor: 'file' stamp: 'cmm 7/15/2005 16:25'!
selectPreMadeRecord: aMaApplyRecord

	^ (preMadeRecords 
		at: aMaApplyRecord recordType
		ifAbsent:
			[ MaUnreadableRecoveryRecord signal: 'Ungraceful end of commit-group:  invalid recordType found (', aMaApplyRecord recordType printString, ').' ])
		byteArray: aMaApplyRecord byteArray copy ;
		yourself! !

!MaRecoveryManager methodsFor: 'error handling' stamp: 'cmm 5/31/2005 21:48'!
unreasonablePhysicalSize
	"No commit record should ever be more than 10-meg.  Due to the nature of disaster-recovery, it is possible we are reading a partially-written file.  It could potentially have even shot-craps in the middle of writing the physicalSize portion of the record.  Therefore, we cannot trust even that not to have bytes in it that cause the computer to attempt to allocate gigs of resources.."

	^ 10000000! !

!MaRecoveryManager methodsFor: 'record' stamp: 'cmm 7/13/2005 15:03'!
writeBeforeImageRecordsFrom: aMaTransactionalFileStream fileId: fileId

	| hasWrittenFileGrowth |
	hasWrittenFileGrowth _ false.
	aMaTransactionalFileStream writersDo:
		[ : each |
		each willCauseGrowth
			ifTrue:
				[ hasWrittenFileGrowth "Only need to write one of these."
					ifFalse:
						[ self preMadeFileGrowthRecord
							originalSize: aMaTransactionalFileStream committedSize ;
							fileId: fileId ;
							groupId: groupId ;
							writeTo: applyFile.
						hasWrittenFileGrowth _ true ] ]
			ifFalse:
				[ self preMadeBeforeImageRecord
					location: each filePos ;
					record: each currentRecord ;
					fileId: fileId ;
					groupId: groupId ;
					writeTo: applyFile ] ]! !

!MaRecoveryManager methodsFor: 'record' stamp: 'cmm 7/7/2005 13:03'!
writeFileGrowthRecordFrom: aMaTransactionalFileStream fileId: fileId

	self preMadeFileGrowthRecord
		originalSize: aMaTransactionalFileStream committedSize ;
		fileId: fileId ;
		groupId: groupId ;
		writeTo: applyFile! !

!MaRecoveryManager methodsFor: 'record' stamp: 'cmm 5/24/2006 22:21'!
writeNewFileRecordFrom: aMaTransactionalFileStream fileId: fileId

	self preMadeNewFileRecord
		filename: aMaTransactionalFileStream filename ;
		fileId: fileId ;
		groupId: groupId ;
		writeTo: applyFile! !

!MaRecoveryManager methodsFor: 'record' stamp: 'cmm 7/16/2005 18:03'!
writeRollbackRecordsFor: aMaTransactionalFileStream fileId: fileId

	aMaTransactionalFileStream isNew
		ifTrue:
			[ self 
				writeNewFileRecordFrom: aMaTransactionalFileStream
				fileId: fileId ]
		ifFalse: 
			[ self
				writeBeforeImageRecordsFrom: aMaTransactionalFileStream
				fileId: fileId ]! !

MaObject subclass: #MaRecoveryRecord
	instanceVariableNames: 'byteArray'
	classVariableNames: 'ReusableSha'
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaRecoveryRecord commentStamp: 'cmm 7/11/2006 20:33' prior: 0!
My instances are records that faciliate the automatic recovery of Magma files when the server was interrupted by an external event such as a power-outage or sysadmin killing of my VM, and files could be partially applied and in an inconsistent state.

There are four types of changes that can occur to a file that must be tracked:

	- the file was just created new (MaNewFileRecord), when recover we delete it.
	- updating bytes within an existing file (MaBeforeImageRecord).  When we recover we put those bytes back.
	- extending the length of a file with new bytes (MaFileGrowthRecord).  When we recover we truncate the file back to its original length.
	- an existing file is deleted.  To handle this we simply don't delete the file until the entire apply has completed and flushed successfully.

There are also two records which indicate the begin and end of the group of records for a single commit (by transactionId).  My transactionId associates me with all of my other records for this transaction.

Every record also has a hash-checkSum calculated so that the recovery process can ensure the record was written wholly and correctly.

All of this is contained completely within my own ByteArray with the following format (0-based positions):

	0 : physicalSize (3-bytes)
	3 : record type (1-byte)
	4 : group-id (4-bytes)
	8 to: n-21 : ... other fields implemented by my subclasses ...
	n-20 - checkSum (SHA1)!

MaRecoveryRecord subclass: #MaApplyRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaApplyRecord commentStamp: 'cmm 6/5/2005 14:21' prior: 0!
I am an abstract class for the types of records that, on recovery, require rollback of some particular file.  My fileId identifies which file it is.

	... see superclass ...
	8 - file-id (8-bytes), identifies which file this record describes
	... subclasses may add more fields ...
	... see superclass ...!

!MaApplyRecord class methodsFor: 'as yet unclassified' stamp: 'cmm 6/3/2005 17:16'!
filePositionsFileId
	^ 2! !

!MaApplyRecord class methodsFor: 'as yet unclassified' stamp: 'cmm 6/3/2005 17:16'!
objectsFileId
	^ 1! !

!MaApplyRecord methodsFor: 'accessing' stamp: 'cmm 6/3/2005 15:47'!
bufferPositionOfFileId
	"This field is 8-bytes to make it easy for Magma.  6-bytes for the oid, 2-bytes for the index #."

	^ 8! !

!MaApplyRecord methodsFor: 'accessing' stamp: 'cmm 6/6/2005 10:29'!
collectionOid
	"for Magma, the fileId is stored in two parts, the high-order 6 bytes represent the oid of the collection.  The low-order 2 bytes represent the index # for that collection or 0 if it is the memberIndex.  This method answers the oid."

	^ self fileId bitShift: -16! !

!MaApplyRecord methodsFor: 'accessing' stamp: 'cmm 6/3/2005 14:44'!
fileId

	^ byteArray
		maUint: 64
		at: self bufferPositionOfFileId! !

!MaApplyRecord methodsFor: 'accessing' stamp: 'cmm 6/3/2005 14:44'!
fileId: anInteger

	byteArray
		maUint: 64
		at: self bufferPositionOfFileId 
		put: anInteger! !

!MaApplyRecord methodsFor: 'accessing' stamp: 'cmm 6/5/2005 15:50'!
headerSize

	^ 16! !

!MaApplyRecord methodsFor: 'testing' stamp: 'cmm 6/5/2005 18:13'!
isApply
	^ true! !

!MaApplyRecord methodsFor: 'printing' stamp: 'cmm 6/5/2005 17:08'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttributes: #(fileId)
		on: aStream! !

!MaApplyRecord methodsFor: 'recovery' stamp: 'cmm 6/5/2005 18:35'!
unapplySelf: aStandardFileStream

	self subclassResponsibility! !

MaApplyRecord subclass: #MaBeforeImageRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaBeforeImageRecord commentStamp: 'cmm 6/5/2005 14:21' prior: 0!
This type of RecoveryRecord is used to restore any bytes in any file to their state prior to the beginning of the interrupted commit.

My #fileId identifies the file that was updated.

My #location provides information necessary to know *where* in the file I came from.

	... see superclass ...
	16 - file-position
	22 - the record
	... see superclass ...

I should not be created for updates to new files or for writes beyond the end of the file.!

!MaBeforeImageRecord class methodsFor: 'accessing' stamp: 'cmm 6/5/2005 16:38'!
assignedRecordType
	^ 2! !

!MaBeforeImageRecord class methodsFor: 'private' stamp: 'cmm 7/4/2005 22:37'!
record: aByteArray
self maMarked: 'delete'.
	^ self new 
		record: aByteArray size: aByteArray size startingAt: 1 ;
		yourself! !

!MaBeforeImageRecord methodsFor: 'debugging' stamp: 'cmm 6/2/2005 13:05'!
asMaObjectBuffer

	self fileId = 1 ifFalse: [ self error: 'not a before-image of a MaObjectBuffer.' ].
	^ (MaObjectBuffer
		byteArray: (ByteArray new: MaObjectBuffer oidSize/8), self record
		startPos: 0) asSentientBuffer! !

!MaBeforeImageRecord methodsFor: 'initializing' stamp: 'cmm 6/3/2005 16:18'!
bodySize
	^ 1000  "variable length"! !

!MaBeforeImageRecord methodsFor: 'private' stamp: 'cmm 6/5/2005 14:21'!
bufferPositionOfLocation
	"this field is 6 bytes"

	^ 16! !

!MaBeforeImageRecord methodsFor: 'private' stamp: 'cmm 6/5/2005 14:21'!
bufferPositionOfRecord
	"this field is variable in size, and ends up determining how large the entire record is."

	^ 22! !

!MaBeforeImageRecord methodsFor: 'private' stamp: 'cmm 6/5/2005 22:45'!
headerSize
	^ 22! !

!MaBeforeImageRecord methodsFor: 'testing' stamp: 'cmm 6/3/2005 15:53'!
isFixed
	^ false! !

!MaBeforeImageRecord methodsFor: 'testing' stamp: 'cmm 6/2/2005 16:54'!
isForFilePositionsFile
	^ self fileId = self class filePositionsFileId! !

!MaBeforeImageRecord methodsFor: 'testing' stamp: 'cmm 6/1/2005 23:51'!
isForLargeCollection
	^ self fileId = 0 "member index"
	or: [ self fileId > 1000 "it would be much larger than this but..." ]! !

!MaBeforeImageRecord methodsFor: 'testing' stamp: 'cmm 6/2/2005 16:54'!
isForObjectsFile
	^ self fileId = self class objectsFileId! !

!MaBeforeImageRecord methodsFor: 'accessing' stamp: 'cmm 6/1/2005 13:18'!
location

	^ byteArray
		maUint: 48
		at: self bufferPositionOfLocation! !

!MaBeforeImageRecord methodsFor: 'initializing' stamp: 'cmm 6/1/2005 13:18'!
location: anInteger

	byteArray
		maUint: 48
		at: self bufferPositionOfLocation
		put: anInteger! !

!MaBeforeImageRecord methodsFor: 'printing' stamp: 'cmm 6/5/2005 17:09'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttributes: #(location recordSize)
		on: aStream! !

!MaBeforeImageRecord methodsFor: 'recovery' stamp: 'cmm 6/5/2005 18:27'!
unapplySelf: aStandardFileStream

	aStandardFileStream
		maWrite: self recordSize
		bytesFromPosition: 1
		of: self record
		atFilePosition: self location! !

MaApplyRecord subclass: #MaFileGrowthRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaFileGrowthRecord commentStamp: 'cmm 6/5/2005 15:40' prior: 0!
I am used to track files that grow in size while applying a commit.  I record the #originalSize such that, during recovery, the file can be truncated: back to its original size.

I should not be created for new files.

	... see superclass ...
	16 - originalSize (6 bytes)
	... see superclass ...!

!MaFileGrowthRecord class methodsFor: 'accessing' stamp: 'cmm 6/5/2005 16:39'!
assignedRecordType
	^ 3! !

!MaFileGrowthRecord methodsFor: 'private' stamp: 'cmm 6/3/2005 16:00'!
bodySize  "in bytes"
	^ self sizeOfOriginalSizeField / 8! !

!MaFileGrowthRecord methodsFor: 'printing' stamp: 'cmm 6/5/2005 17:09'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttributes: #(originalSize)
		on: aStream! !

!MaFileGrowthRecord methodsFor: 'access' stamp: 'cmm 6/3/2005 16:01'!
originalSize
	^ byteArray
		maUint: self sizeOfOriginalSizeField 
		at: self headerSize! !

!MaFileGrowthRecord methodsFor: 'access' stamp: 'cmm 6/3/2005 16:01'!
originalSize: anInteger
	^ byteArray
		maUint: self sizeOfOriginalSizeField 
		at: self headerSize
		put: anInteger! !

!MaFileGrowthRecord methodsFor: 'private' stamp: 'cmm 6/3/2005 15:59'!
sizeOfOriginalSizeField

	^ 48 "bits"! !

!MaFileGrowthRecord methodsFor: 'recovery' stamp: 'cmm 6/6/2005 10:34'!
unapplySelf: aStandardFileStream

	aStandardFileStream
		truncate: self originalSize ;
		"close and open to get around bug; see http://lists.squeakfoundation.org/pipermail/squeak-dev/2005-June/092041.html"
		close ;
		open! !

MaApplyRecord subclass: #MaNewFileRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaNewFileRecord commentStamp: 'cmm 6/5/2005 15:40' prior: 0!
Sometimes new files are created during a commit.  If a disaster happens before that commit finishes then, upon recovery, those files should be deleted.

I record the #filename of the file that should be deleted.

	... see superclass ...
	16 - filename (variable length)
	... see superclass ...!

!MaNewFileRecord class methodsFor: 'accessing' stamp: 'cmm 6/5/2005 16:39'!
assignedRecordType
	^ 4! !

!MaNewFileRecord methodsFor: 'accessing' stamp: 'cmm 6/3/2005 16:18'!
bodySize

	^ 300  "variable length"! !

!MaNewFileRecord methodsFor: 'accessing' stamp: 'cmm 9/21/2005 09:54'!
filename
	^ (byteArray
		copyFrom: self headerSize+1
		to: self checkSumPosition-1) asString! !

!MaNewFileRecord methodsFor: 'accessing' stamp: 'cmm 7/4/2005 22:54'!
filename: aString

	self record: aString! !

!MaNewFileRecord methodsFor: 'accessing' stamp: 'cmm 6/3/2005 15:53'!
isFixed
	^ false! !

!MaNewFileRecord methodsFor: 'printing' stamp: 'cmm 6/5/2005 17:10'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttributes: #(filename)
		on: aStream! !

!MaNewFileRecord methodsFor: 'recovery' stamp: 'cmm 6/5/2005 18:36'!
unapplySelf: aStandardFileStream

	aStandardFileStream close.
	aStandardFileStream directory deleteFileNamed: (aStandardFileStream directory localNameFor: aStandardFileStream name)! !

MaRecoveryRecord subclass: #MaBeginApplyRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaBeginApplyRecord commentStamp: 'cmm 6/3/2005 15:15' prior: 0!
I am the first record of a group of RecoveryRecords for the same transactionId.  If a disaster happens in the middle of a commit and, during recovery, a valid BeginApply record is found in the apply file *without* a valid EndApply record, then we know the commit did not finish and all of the records must be unapplied.!

!MaBeginApplyRecord class methodsFor: 'accessing' stamp: 'cmm 6/5/2005 16:39'!
assignedRecordType
	^ 1! !

!MaBeginApplyRecord methodsFor: 'private' stamp: 'cmm 6/3/2005 16:20'!
bodySize

	^ 0! !

!MaBeginApplyRecord methodsFor: 'testing' stamp: 'cmm 6/3/2005 16:57'!
isBeginApply
	^ true! !

!MaBeginApplyRecord methodsFor: 'printing' stamp: 'cmm 6/5/2005 17:10'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttributes: #(isBeginApply)
		on: aStream! !

MaRecoveryRecord subclass: #MaCommitPackageRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaCommitPackageRecord commentStamp: '<historical>' prior: 0!
These are the "after-images" which are written to the commitPackages file.!

!MaCommitPackageRecord class methodsFor: 'accessing' stamp: 'cmm 7/8/2005 11:05'!
assignedRecordType
	^ 6! !

MaRecoveryRecord subclass: #MaEndApplyRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaEndApplyRecord commentStamp: 'cmm 6/3/2005 15:17' prior: 0!
I am the last record of a group of RecoveryRecords for the same transactionId.  If a disaster happens then, during recovery, I am looked for in the applyFile with the same transactionId as my BeginApply counterpart.  If I'm found, then no were no commits happening at the time of the failure and, thus, no recovery is necessary.!

!MaEndApplyRecord class methodsFor: 'accessing' stamp: 'cmm 6/5/2005 16:39'!
assignedRecordType
	^ 5! !

!MaEndApplyRecord methodsFor: 'private' stamp: 'cmm 6/3/2005 16:20'!
bodySize

	^ 0! !

!MaEndApplyRecord methodsFor: 'testing' stamp: 'cmm 6/3/2005 16:57'!
isEndApply
	^ true! !

!MaEndApplyRecord methodsFor: 'printing' stamp: 'cmm 6/5/2005 17:10'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttributes: #(isEndApply)
		on: aStream! !

!MaRecoveryRecord class methodsFor: 'accessing' stamp: 'cmm 6/5/2005 16:54'!
assignedRecordType
	^ 0! !

!MaRecoveryRecord class methodsFor: 'create' stamp: 'cmm 6/5/2005 16:46'!
byteArray: aByteArray
	^ self new
		byteArray: aByteArray ;
		yourself! !

!MaRecoveryRecord class methodsFor: 'class initialization' stamp: 'cmm 6/5/2005 13:38'!
initialize
	super initialize.
	self initializeReusableSha ! !

!MaRecoveryRecord class methodsFor: 'class initialization' stamp: 'cmm 6/3/2005 14:41'!
initializeReusableSha

	ReusableSha _ SecureHashAlgorithm new! !

!MaRecoveryRecord class methodsFor: 'create' stamp: 'cmm 6/5/2005 16:46'!
new: anInteger
	^ self byteArray: (ByteArray new: anInteger)! !

!MaRecoveryRecord class methodsFor: 'accessing' stamp: 'cmm 6/3/2005 16:35'!
sizeOfPhysicalSizeField
	"this field, in particular, has its size defined this way because of the potential dual-read required should the initial default read not be large enough."

	^ 3! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 6/5/2005 16:47'!
bodySize
	"Subclasses override"

	^ 0! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 6/5/2005 21:34'!
bufferPositionOfGroupId
	"this fields is 4-bytes."

	^ 4! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 6/3/2005 14:21'!
bufferPositionOfPhysicalSize
	"This field is 3-bytes."

	^ 0! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 6/5/2005 17:34'!
bufferPositionOfRecordType
	^ 3! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 6/3/2005 14:22'!
bufferSize
	^ byteArray size! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 6/3/2005 14:21'!
byteArray
	^ byteArray! !

!MaRecoveryRecord methodsFor: 'initialize-release' stamp: 'cmm 6/3/2005 14:21'!
byteArray: aByteArray

	byteArray _ aByteArray! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 9/21/2005 09:53'!
calculatedCheckSum

	^ ReusableSha 
		maHashMessage: byteArray
		from: 1
		to: self physicalSize - self checkSumSize! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 9/21/2005 09:54'!
checkSum

	^ byteArray
		maUint: 160
		at: self checkSumPosition-1 "-1 to convert to 0-based"! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 9/21/2005 09:53'!
checkSumPosition
	^ self physicalSize - self checkSumSize + 1! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 9/21/2005 09:53'!
checkSumSize
	^ 20 "bytes"! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 9/21/2005 09:53'!
checkSum: anInteger

	^ byteArray
		maUint: 160
		at: self physicalSize - self checkSumSize
		put: anInteger! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 9/21/2005 09:53'!
ensureCanHold: numberOfBytes

	byteArray size >= (self headerSize + numberOfBytes + self checkSumSize)
		ifFalse:
			[ | newByteArray |
			newByteArray := ByteArray new: self headerSize + numberOfBytes + self checkSumSize.
			newByteArray
				replaceFrom: 1
				to: byteArray size
				with: byteArray
				startingAt: 1.
			byteArray := newByteArray ]! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 6/5/2005 21:34'!
groupId

	^ byteArray
		maUint: 32
		at: self bufferPositionOfGroupId! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 6/5/2005 21:35'!
groupId: anInteger

	byteArray
		maUint: 32
		at: self bufferPositionOfGroupId 
		put: anInteger! !

!MaRecoveryRecord methodsFor: 'testing' stamp: 'cmm 9/21/2005 10:52'!
hasValidCheckSum

	^ self checkSumPosition > self bufferPositionOfGroupId
	and: [ self calculatedCheckSum = self checkSum ]! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 6/3/2005 15:58'!
headerSize

	^ 8! !

!MaRecoveryRecord methodsFor: 'copying' stamp: 'cmm 6/3/2005 14:33'!
independentCopy
	^ self copy
		byteArray: (byteArray copyFrom: 1 to: self physicalSize) ;
		yourself! !

!MaRecoveryRecord methodsFor: 'initialize-release' stamp: 'cmm 9/21/2005 09:54'!
initialize

	super initialize.
	byteArray := ByteArray new: self headerSize + self bodySize + self checkSumSize.
	self isFixed ifTrue: [ self physicalSize: byteArray size ].
	self recordType: self class assignedRecordType! !

!MaRecoveryRecord methodsFor: 'testing' stamp: 'cmm 6/5/2005 18:13'!
isApply
	^ false! !

!MaRecoveryRecord methodsFor: 'testing' stamp: 'cmm 6/3/2005 16:57'!
isBeginApply
	^ false! !

!MaRecoveryRecord methodsFor: 'testing' stamp: 'cmm 6/3/2005 16:58'!
isEndApply
	^ false! !

!MaRecoveryRecord methodsFor: 'testing' stamp: 'cmm 6/3/2005 15:52'!
isFixed
	^ true! !

!MaRecoveryRecord methodsFor: 'printing' stamp: 'cmm 6/5/2005 21:35'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttributes: #(physicalSize recordType groupId)
		on: aStream! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 6/3/2005 14:23'!
physicalSize
	^ byteArray
		maUint: self class sizeOfPhysicalSizeField * 8
		at: self bufferPositionOfPhysicalSize! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 6/3/2005 14:23'!
physicalSize: anInteger
	byteArray
		maUint: self class sizeOfPhysicalSizeField * 8
		at: self bufferPositionOfPhysicalSize
		put: anInteger! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 7/16/2005 18:34'!
record

	| startOfRecord |
	startOfRecord _ self headerSize+1 "because bufferPositionOfRecord is 0-based".
	^ byteArray
		copyFrom: startOfRecord
		to: startOfRecord + self recordSize - 1! !

!MaRecoveryRecord methodsFor: 'as yet unclassified' stamp: 'cmm 9/21/2005 09:54'!
recordSize

	^ self physicalSize - self headerSize - self checkSumSize! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 7/5/2005 23:28'!
recordType
	"record type indicates what kind of MaRecoveryRecord this is.  See the class-side hierarchy, #assignedRecordType methods for the values."

	^ byteArray
		maUint: 8
		at: self bufferPositionOfRecordType! !

!MaRecoveryRecord methodsFor: 'initialize-release' stamp: 'cmm 7/5/2005 23:28'!
recordType: anInteger
	"record type indicates what kind of MaRecoveryRecord this is.  See the class-side hierarchy, #assignedRecordType methods for the values."

	^ byteArray
		maUint: 8
		at: self bufferPositionOfRecordType
		put: anInteger! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 7/4/2005 22:53'!
record: aByteArray

	self
		record: aByteArray
		size: aByteArray size
		startingAt: 1! !

!MaRecoveryRecord methodsFor: 'accessing' stamp: 'cmm 9/21/2005 09:54'!
record: aByteArray size: anInteger startingAt: startPos

	self ensureCanHold: anInteger.
	byteArray
		replaceFrom: self headerSize+1
		to: self headerSize + anInteger
		with: aByteArray
		startingAt: startPos.
	self physicalSize: self headerSize + anInteger + self checkSumSize! !

!MaRecoveryRecord methodsFor: 'private' stamp: 'cmm 6/10/2005 10:08'!
resetChecksum
	"Calculate my checksum which is used during recovery to ensure my byteArray was written completely and correctly."

	self checkSum: self calculatedCheckSum.
	MagmaServerPreferences debugRecovery ifTrue: [ self hasValidCheckSum ifFalse: [ self halt: 'checksum not correct!!' ] ]! !

!MaRecoveryRecord methodsFor: 'file' stamp: 'cmm 6/6/2005 10:37'!
writeTo: applyFile

	self resetChecksum.
	applyFile
		next: self physicalSize
		putAll: byteArray
		startingAt: 1! !

MaObject subclass: #MaTransactionalFileStream
	instanceVariableNames: 'filename fileStream guard uncommittedSize position writers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-recovery'!

!MaTransactionalFileStream commentStamp: 'cmm 7/7/2005 12:11' prior: 0!
This class emulates a StandardFileStream except doesn't actually write contents to disk until you send #maCommit.  Instead, it caches the written contents to a collection of MaTransactionalFileWriters.!

!MaTransactionalFileStream class methodsFor: 'create' stamp: 'cmm 7/11/2005 17:32'!
fileNamed: filenameString

	^ (FileDirectory on: filenameString) exists
		ifTrue:
			[ self fileStream: (FileStream fileNamed: filenameString) ]
		ifFalse:
			[ self new
				filename: filenameString ;
				yourself ]! !

!MaTransactionalFileStream class methodsFor: 'create' stamp: 'cmm 8/17/2005 23:14'!
fileStream: aFileStream

	aFileStream ifNil: [ MaUserError signal: 'fileStream required' ].
	^ self new
		setFileStream: aFileStream ;
		yourself! !

!MaTransactionalFileStream methodsFor: 'accessing' stamp: 'cmm 7/11/2005 22:07'!
bePhysical

	self isPhysical ifFalse:
		[ fileStream _ (FileStream fileNamed: filename) binary "only binary files supported by this" ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/11/2005 22:07'!
binary
	self isPhysical ifTrue: [ fileStream binary ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/12/2005 14:09'!
close

	self isPhysical 
		ifTrue:
			[ self maCommit.
			fileStream close ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/11/2005 22:05'!
closed
	^ self isPhysical and: [ fileStream closed ]! !

!MaTransactionalFileStream methodsFor: 'accessing' stamp: 'cmm 7/11/2005 22:09'!
committedSize

	^ self isPhysical
		ifTrue: [ fileStream size ]
		ifFalse: [ 0 ]! !

!MaTransactionalFileStream methodsFor: 'accessing' stamp: 'cmm 5/24/2006 22:17'!
copyToDirectory: targetFileDirectory 
	| shouldOpen dir |
	shouldOpen _ self closed not.
	self close.
	[ dir _ self directory.
	dir
		maCopyFileNamed: (dir localNameFor: self filename)
		toDirectory: targetFileDirectory ] ensure: [ shouldOpen ifTrue: [ self open ] ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/11/2005 22:22'!
directory

	^ FileDirectory forFileName: filename! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 5/24/2006 21:50'!
filename

	^ filename! !

!MaTransactionalFileStream methodsFor: 'initialize-release' stamp: 'cmm 7/11/2005 22:28'!
filename: aString

	filename _ aString! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/7/2005 22:27'!
flush

	self maCommit.
	fileStream flush! !

!MaTransactionalFileStream methodsFor: 'initialize-release' stamp: 'cmm 7/4/2005 21:53'!
initialize
	super initialize.
	self initializeWriters.
	position _ 0.
	guard _ Semaphore forMutualExclusion ! !

!MaTransactionalFileStream methodsFor: 'initialize-release' stamp: 'cmm 7/13/2005 15:04'!
initializeWriters

	writers _ BTree new.
	uncommittedSize _ 0! !

!MaTransactionalFileStream methodsFor: 'testing' stamp: 'cmm 7/11/2005 22:04'!
isNew

	^ self isPhysical not! !

!MaTransactionalFileStream methodsFor: 'testing' stamp: 'cmm 7/11/2005 22:04'!
isPhysical

	^ fileStream notNil! !

!MaTransactionalFileStream methodsFor: 'commit' stamp: 'cmm 7/4/2005 17:47'!
maCommit

	self maCommit: false! !

!MaTransactionalFileStream methodsFor: 'commit' stamp: 'cmm 7/13/2005 15:28'!
maCommit: shouldFlush
	"writers, write!!"

	| needsFlush |
	guard critical:
		[ self bePhysical.
		needsFlush _ false.
		self writersDo: 
			[ : each | 
			each write.
			needsFlush _ true ].
		self initializeWriters.
		(shouldFlush and: [ needsFlush ]) ifTrue: [ fileStream flush ] ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/11/2005 22:25'!
maRead: someNumber bytesFromPosition: bufferPosition of: aByteArray atFilePosition: filePosition

	| writer numberOfBytesRead |
	^ guard critical:
		[ (writer _ self writerAt: filePosition)
			ifNil:
				[ self bePhysical.
				numberOfBytesRead _ 
					fileStream
						maRead: someNumber
						bytesFromPosition: bufferPosition
						of: aByteArray
						atFilePosition: filePosition.
				position _ fileStream position.
				numberOfBytesRead ]
			ifNotNil:
				[ numberOfBytesRead _ someNumber min: writer byteArray size.
				aByteArray
					replaceFrom: bufferPosition
					to: bufferPosition + numberOfBytesRead - 1
					with: writer byteArray
					startingAt: 1.
				position _ filePosition + numberOfBytesRead.
				numberOfBytesRead ] ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/13/2005 15:04'!
maWrite: numberOfBytes bytesFromPosition: bufferPosition of: byteArray atFilePosition: filePosition

	| writer |
	writer _ 
		MaTransactionalFileWriter
			file: self
			filePos: filePosition
			byteArray: 
				(byteArray 
					copyFrom: bufferPosition 
					to: bufferPosition + numberOfBytes - 1).
	guard critical:
		[ writers
			at: writer endFilePos
			put: writer.
		uncommittedSize _ uncommittedSize max: filePosition + numberOfBytes.
		position _ filePosition + numberOfBytes ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 5/24/2006 21:51'!
name
self maMarked: 'delete'.
	^ filename! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/11/2005 22:25'!
next: n into: aByteArray startingAt: startIndex
	"This method is only called when logRecoveryRecords is turned on AND the initial read of an object did not fit within the #trackSize AND we are reading a part of the file has not yet been written to disk (still in my 'writers').  This happens when the server must refresh its session in the middle of a commit because new classes or LargeCollections have been added.  This is all so we can minimize flushing to disk, so we can have tolerable performance on normal hardware with logRecoveryRecords turned on.  Sheesh."

	| writer |
	guard critical:
		[ (writer _ self writerAt: position)
			ifNil:
				[ self bePhysical.
				fileStream
					next: n
					into: aByteArray
					startingAt: startIndex.
				position _ fileStream position ]
			ifNotNil:
				[ aByteArray
					replaceFrom: startIndex
					to: startIndex + (n min: writer byteArray size) - 1
					with: writer byteArray
					startingAt: position - writer filePos + 1.
				position _ position + n ] ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/7/2005 22:17'!
next: numberOfBytes putAll: aByteArray startingAt: startPos

	"This isn't needed for Magma, and I don't feel like implementing it right now.  Better to just give an explicit error than get it wrong."

	self error: 'not supported'! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/11/2005 22:07'!
open

	self isPhysical ifTrue: [ fileStream open ]! !

!MaTransactionalFileStream methodsFor: 'accessing' stamp: 'cmm 7/11/2005 22:03'!
physicalStream

	^ fileStream ifNil:
		[ fileStream _ FileStream fileNamed: filename ]! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/11/2005 22:06'!
position: anInteger

	self isPhysical ifTrue: [ fileStream position: anInteger ].
	position _ anInteger! !

!MaTransactionalFileStream methodsFor: 'initialize-release' stamp: 'cmm 7/11/2005 22:29'!
setFileStream: aFileStream

	fileStream _ aFileStream.
	self filename: aFileStream name! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/7/2005 12:51'!
size

	^ self committedSize max: uncommittedSize! !

!MaTransactionalFileStream methodsFor: 'filestream api' stamp: 'cmm 7/11/2005 22:18'!
truncate: anInteger

	| toBeRemoved |
	self isPhysical ifTrue: [ fileStream truncate: anInteger ].
	uncommittedSize _ uncommittedSize min: anInteger.
	toBeRemoved _ OrderedCollection new. "Not sure if I can remove from a BTree while enumerating it.."
	writers
		from: anInteger
		to: 999999999999999999999
		do: [ : each | (each coversFilePosition: anInteger) ifTrue: [ toBeRemoved add: each ] ].
	toBeRemoved do: [ : each | writers removeKey: each endFilePos ]! !

!MaTransactionalFileStream methodsFor: 'private' stamp: 'cmm 6/16/2005 09:23'!
writerAt: filePosition

	writers
		from: filePosition
		to: 999999999999999999999
		do: [ : each | ^ (each coversFilePosition: filePosition) ifTrue: [ each ] ].
	^ nil! !

!MaTransactionalFileStream methodsFor: 'accessing' stamp: 'cmm 7/13/2005 15:02'!
writersDo: aBlock

	writers do: aBlock! !

MaObject subclass: #MaTransactionalFileWriter
	instanceVariableNames: 'file filePos byteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-recovery'!

!MaTransactionalFileWriter class methodsFor: 'as yet unclassified' stamp: 'cmm 7/4/2005 22:01'!
file: aStandardFileStream filePos: anInteger byteArray: aByteArray

	^ self new
		setFile: aStandardFileStream
		filePos: anInteger
		byteArray: aByteArray! !

!MaTransactionalFileWriter methodsFor: 'accessing' stamp: 'cmm 6/15/2005 10:27'!
byteArray
	^ byteArray! !

!MaTransactionalFileWriter methodsFor: 'testing' stamp: 'cmm 6/15/2005 17:11'!
coversFilePosition: filePosition

	^ filePosition
		between: filePos
		and: filePos + byteArray size - 1! !

!MaTransactionalFileWriter methodsFor: 'accessing' stamp: 'cmm 7/11/2005 22:13'!
currentRecord

	| answer |
	answer _ ByteArray new: byteArray size.
	file physicalStream
		maRead: byteArray size
		bytesFromPosition: 1
		of: answer
		atFilePosition: filePos.
	^ answer! !

!MaTransactionalFileWriter methodsFor: 'accessing' stamp: 'cmm 6/15/2005 22:18'!
endFilePos

	^ filePos + byteArray size - 1! !

!MaTransactionalFileWriter methodsFor: 'accessing' stamp: 'cmm 6/15/2005 17:27'!
filePos

	^ filePos! !

!MaTransactionalFileWriter methodsFor: 'initialize-release' stamp: 'cmm 7/11/2005 22:13'!
setFile: aMaTransactionalWriter filePos: anInteger byteArray: aByteArray

	file _ aMaTransactionalWriter.
	filePos _ anInteger.
	byteArray _ aByteArray! !

!MaTransactionalFileWriter methodsFor: 'testing' stamp: 'cmm 7/12/2005 22:20'!
willCauseGrowth

	^ filePos >= file committedSize! !

!MaTransactionalFileWriter methodsFor: 'actions' stamp: 'cmm 7/11/2005 22:12'!
write

	file physicalStream
		maWrite: byteArray size
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: filePos! !

MaObject subclass: #MaTransactionLog
	instanceVariableNames: 'entries specialOids nextId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaTransactionLog commentStamp: '<historical>' prior: 0!
This class resides on the server.
!

!MaTransactionLog methodsFor: 'actions' stamp: 'cmm 1/18/2005 22:43'!
abortTransactionEntryFor: sessionIdInteger repository: aMaObjectRepository

	^(self
		renewEntryFor: sessionIdInteger
		beginAnother: false
		for: aMaObjectRepository) result! !

!MaTransactionLog methodsFor: 'private' stamp: 'cmm 7/11/2005 15:08'!
challengeEntriesWith: aMaCommitLogEntry
	"We record all objects that were committed to all the entries in the receiver.  Some of the entries are in transaction, some are not.  The ones that are will use aMaCommitLogEntry to verify their commit has no conflicts with this entry.  The ones that are not will use the result of the receiver to know which objects need refreshed."

	| entriesToRemove |
	entriesToRemove _ nil.
	self entriesDo:
		[ :each |
		(each isForSameSessionAs: aMaCommitLogEntry)
			ifFalse:
				[ each addChallengingEntry: aMaCommitLogEntry.
				each
					recordChangesToSpecialObjectsIn: aMaCommitLogEntry
					using: self.
				each hasExcessiveNumberOfChallengers
					ifTrue:
						[ self maMarked: 'dev'.
						"here is where we manage the health of the server.  Our current strategy is that your session 'times out' if you stay idle and get too far out of sync w/ the db.  Further work can be done here.  We should look into just marking this LogEntry 'bad' then, later, when they finally refresh, force it to refresh this sessions entire readSet..  something like that.."
						entriesToRemove ifNil: [ entriesToRemove _ OrderedCollection new ].
						entriesToRemove add: each.
						each needsToRefresh: true ] ] ].
	entriesToRemove ifNotNil:
		[ entriesToRemove 
			do:
				[ :each |
				self
					removeEntryForSessionId: each sessionId
					ifAbsent: [ "shouldn't happen" ] ] ]! !

!MaTransactionLog methodsFor: 'actions' stamp: 'cmm 7/11/2005 15:07'!
entriesDo: aBlock

	entries do: aBlock! !

!MaTransactionLog methodsFor: 'accessing' stamp: 'cmm 7/15/2005 11:50'!
entryFor: sessionId

	^entries
		detect: [ :each | each sessionId = sessionId ]
		ifNone: [ MagmaSessionLost ]! !

!MaTransactionLog methodsFor: 'private' stamp: 'cmm 5/14/2005 17:44'!
getNextId

	^ nextId _ nextId + 1! !

!MaTransactionLog methodsFor: 'private' stamp: 'cmm 5/14/2005 17:43'!
initialize

	super initialize.
	"An OrderedCollection of MaCommitLogEntrys and MaTransactionLogEntrys.."
	entries _ OrderedCollection new.
	specialOids _ Dictionary new.
	nextId _ 0! !

!MaTransactionLog methodsFor: 'testing' stamp: 'cmm 12/31/2002 12:31'!
isFirstEntryFor: sessionId

	^entries notEmpty and: [ entries first connection sessionId = sessionId ]
! !

!MaTransactionLog methodsFor: 'building' stamp: 'cmm 5/14/2005 17:48'!
newSessionFor: userIdString numberOfChallengers: anInteger

	^ (entries add: (
		MaTransactionLogEntry
			id: self getNextId
			connection: (
				MagmaClientConnection
					userId: userIdString
					sessionId: self nextAvailableSessionId
					maximumNumberOfChallengers: anInteger))) connection! !

!MaTransactionLog methodsFor: 'building' stamp: 'cmm 1/28/2005 00:04'!
newTransactionFor: sessionIdInteger repository: aMaObjectRepository

	^ (self
		renewEntryFor: sessionIdInteger
		beginAnother: true
		for: aMaObjectRepository) result! !

!MaTransactionLog methodsFor: 'creation' stamp: ''!
nextAvailableSessionId

	^(entries
		inject: 0
		into: [ :highest :each | highest max: each sessionId ]) + 1
! !

!MaTransactionLog methodsFor: 'special oids' stamp: 'cmm 5/19/2004 22:24'!
onChangeOf: anInteger clientsShould: aSymbol

	specialOids
		at: anInteger
		put: aSymbol! !

!MaTransactionLog methodsFor: 'building' stamp: 'cmm 6/12/2006 23:50'!
removeEntryForSessionId: sessionId ifAbsent: aBlock 
	^ entries 
		maDetect: [ : each | each sessionId = sessionId ]
		ifFound: [ : foundTransactionLogEntry | entries remove: foundTransactionLogEntry ]
		ifNone: aBlock! !

!MaTransactionLog methodsFor: 'actions' stamp: 'cmm 7/15/2005 11:50'!
renewEntryFor: sessionIdInteger beginAnother: aBoolean for: aMaObjectRepository
	"Gives the session identified by sessionIdInteger a new TranslactionLogEntry, where its challengers will be accumulated.  The entry prior to replacement is answered."

	| entry |
	entry _ self
		renewEntryFor: sessionIdInteger
		withNew: (aBoolean ifTrue: [ MaCommitLogEntry ] ifFalse: [ MaTransactionLogEntry ])
		ifAbsent: [ MagmaSessionLost signal ].
	aMaObjectRepository
		renewServerNotificationsIn: entry result
		for: sessionIdInteger
		from: entry.
	^ entry! !

!MaTransactionLog methodsFor: 'private' stamp: 'cmm 5/14/2005 17:49'!
renewEntryFor: sessionIdInteger withNew: aClass ifAbsent: aBlock
	"aClass should be either MaTransactionLogEntry or MaCommitLogEntry"

	| entry |
	entry _
		(self
			removeEntryForSessionId: sessionIdInteger
			ifAbsent: [ ^ aBlock value ]).
	entry recordAllChangedObjects.
	entries add: 
		(aClass
			id: self getNextId
			connection: entry result connection).
	^ entry! !

!MaTransactionLog methodsFor: 'special oids' stamp: 'cmm 5/19/2004 00:10'!
specialOidsDo: twoArgBlock

	specialOids keysAndValuesDo: twoArgBlock! !

MaObject subclass: #MaTransactionLogEntry
	instanceVariableNames: 'id result challengingEntries needsToRefresh serverNotifications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

MaTransactionLogEntry subclass: #MaCommitLogEntry
	instanceVariableNames: 'commitPackage committed didCommitSpecialOid magmaArrayCommits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 5/9/2005 22:48'!
applyTo: aMaObjectRepository

	| new |
	new _ result newObjectBuffers.
	commitPackage objectsDo:
		[ : eachBuffer |
		aMaObjectRepository filer
			write: eachBuffer
			index: (new includesKey: eachBuffer oid) ]! !

!MaCommitLogEntry methodsFor: 'accessing' stamp: 'cmm 5/9/2005 21:24'!
commitPackage
	^ commitPackage! !

!MaCommitLogEntry methodsFor: 'accessing' stamp: 'cmm 5/9/2005 21:24'!
commitPackage: aMaCommitPackage
	commitPackage _ aMaCommitPackage! !

!MaCommitLogEntry methodsFor: 'private' stamp: ''!
committed

	^committed! !

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 10/15/2004 16:57'!
determineResultFor: aMaCommitPackage using: lcManagersDictionary

	self
		recordLargeCollectionConflictsWith: aMaCommitPackage
			using: lcManagersDictionary;
		recordObjectConflictsIn: aMaCommitPackage.
	^ result! !

!MaCommitLogEntry methodsFor: 'testing' stamp: 'cmm 5/20/2004 21:39'!
didCommitSpecialOid

	^ didCommitSpecialOid! !

!MaCommitLogEntry methodsFor: 'private' stamp: 'cmm 10/15/2004 16:57'!
failResultWith: aMagmaClientConnection on: oidInteger

	result _
		result asFailedResult
			recordObjectConflictWith: aMagmaClientConnection
			on: oidInteger! !

!MaCommitLogEntry methodsFor: 'testing' stamp: 'cmm 3/22/2005 16:27'!
hasAnyCommitted

	^ committed notEmpty or: [ magmaArrayCommits notNil ]! !

!MaCommitLogEntry methodsFor: 'magmaArray support' stamp: 'cmm 3/20/2005 21:12'!
hasChangesToMagmaArray: oidInteger

	^ magmaArrayCommits notNil and:
	[ self magmaArrayCommits includesKey: oidInteger ]! !

!MaCommitLogEntry methodsFor: 'testing' stamp: 'cmm 10/15/2004 16:52'!
hasCommitted: oidInteger

	^ committed includesKey: oidInteger
! !

!MaCommitLogEntry methodsFor: 'initializing' stamp: 'cmm 5/20/2004 21:36'!
initialize

	super initialize.
	committed _ Dictionary new.
	didCommitSpecialOid _ false! !

!MaCommitLogEntry methodsFor: 'initializing' stamp: ''!
initializeResult

	result _ MaCommitResult new
! !

!MaCommitLogEntry methodsFor: 'testing' stamp: ''!
isCommitEntry

	^true
! !

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 5/9/2005 22:15'!
link

	| oidMap |
	oidMap _ result permanentOids.
	commitPackage objectsDo:
		[ : eachBuffer |
		eachBuffer isPointers
			ifTrue:
				[ eachBuffer instVarsDoWithIndex:
					[ : oid : index |
					(MaOidCalculator isOidForNewObject: oid)
						ifTrue:
							[ "replace the temp oid with the permanent one."
							eachBuffer
								maInstVarAt: index
								put:
									(oidMap 
										at: oid
										ifAbsent: [ MagmaUserError signal: 'Invalid reference, an object may not change during serialization.' ]) ] ] ] ]! !

!MaCommitLogEntry methodsFor: 'magmaArray support' stamp: 'cmm 3/20/2005 21:23'!
magmaArrayAdditionsAt: oidInteger

	^ self magmaArrayCommits
		at: oidInteger
		ifAbsentPut: [ Dictionary new ]! !

!MaCommitLogEntry methodsFor: 'magmaArray support' stamp: 'cmm 3/20/2005 21:08'!
magmaArrayCommits
	"A Dictionary, keyed by the oid of the MagmaArray that was changed; value is another Dictionary of the index->oids put into that array."

	^ magmaArrayCommits ifNil:
		[ magmaArrayCommits _ Dictionary new ]! !

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 5/20/2004 21:38'!
noteDidCommitSpecialOid

	didCommitSpecialOid _ true! !

!MaCommitLogEntry methodsFor: 'recovery' stamp: 'cmm 7/8/2005 16:08'!
postTrimmedCopy
	"We do this for performance.  We no longer need these fields, and we're about to serialize the receiver."

	super postTrimmedCopy.
	committed _ nil.
	magmaArrayCommits _ nil! !

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 6/12/2006 23:47'!
record
	"Record my successful commit in the places that need to know."

	commitPackage objectsDo:
		[ : eachBuffer |
		(result newObjectBuffers includesKey: eachBuffer oid)
			ifFalse:
				[ self connection removeTransientMagmaCollection: eachBuffer oid.
				committed
					at: eachBuffer oid
					put: eachBuffer copyWithSameBuffer ] ].
	result changedObjectBuffers: committed.
	"Note the MagmaArray changes to faciliate future concurrency checking."
	commitPackage allLargeCollectionChangesDo:
		[ : eachChanges |
		eachChanges isForMagmaArray
			ifTrue:
				[ eachChanges additionsDo:
					[ : eachIndex : eachOid |
					(self magmaArrayAdditionsAt: eachChanges collectionOid)
						at: eachIndex
						put: eachOid ] ] ]! !

!MaCommitLogEntry methodsFor: 'private' stamp: 'cmm 3/16/2005 21:21'!
recordLargeCollectionConflictsWith: aMaCommitPackage using: lcManagersDictionary

	aMaCommitPackage allLargeCollectionChangesDo:
		[ : eachChanges |
		eachChanges isNewCollection ifFalse:
			[ | collectionManager |
			collectionManager _ lcManagersDictionary at: eachChanges collectionOid.
			collectionManager
				recordGeneralConflictsWith: eachChanges
				in: self.
			challengingEntries do:
				[ : eachEntry |
				collectionManager
					recordConflictsBetween: eachChanges
					and: eachEntry
					in: self ] ] ]! !

!MaCommitLogEntry methodsFor: 'private' stamp: 'cmm 10/15/2004 16:56'!
recordObjectConflictsIn: aMaCommitPackage
	"Go through everyone who has challenged me.  Determine if they have a same changed
	oid that I have.  Also fail if a new instance of a class is being added and shouldn't be."

	aMaCommitPackage persistentObjectsDo:
		[ :eachObjectBuffer |
		challengingEntries do:
			[ :eachEntry |
			(eachEntry hasCommitted: eachObjectBuffer oid)
				ifTrue:
					[ self
						failResultWith: eachEntry connection
						on: eachObjectBuffer oid ] ] ]! !

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 5/30/2005 22:19'!
registerUsing: aMaObjectRepository
	"Register all new objects by assigning them their permanentOids."

	| map |
	map _ Dictionary new: 100.
	commitPackage newObjectsDo:
		[ : eachBuffer |
		eachBuffer oid: 
			(map
				at: eachBuffer oid
				put: aMaObjectRepository getNextOid).
		result recordNewObjectBuffer: eachBuffer copyWithSameBuffer ].
	result permanentOids: map! !

!MaCommitLogEntry methodsFor: 'testing' stamp: 'cmm 6/18/2004 15:52'!
shouldServerRefresh

	^ self didCommitSpecialOid! !

!MaCommitLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:57'!
stopTime

	^ result stopTime
! !

!MaTransactionLogEntry class methodsFor: 'creation' stamp: 'cmm 5/14/2005 17:48'!
id: anInteger connection: aMagmaClientConnection

	^ self new 
		id: anInteger ;
		connection: aMagmaClientConnection ;
		yourself! !

!MaTransactionLogEntry methodsFor: 'building' stamp: 'cmm 10/15/2004 16:56'!
addChallengingEntry: aMaCommitLogEntry

	challengingEntries add: aMaCommitLogEntry! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:58'!
connection

	^ result connection
! !

!MaTransactionLogEntry methodsFor: 'private' stamp: 'cmm 10/15/2004 16:58'!
connection: aMagmaClientConnection

	result connection: aMagmaClientConnection
! !

!MaTransactionLogEntry methodsFor: 'private' stamp: 'cmm 7/11/2005 15:40'!
ensureWillCall: specialOidsName at: oidInteger

	(serverNotifications
		at: specialOidsName  "see MaObjectRepository>>#initializeSpecialOidsList"
		ifAbsentPut: [ Set new ]) add: oidInteger! !

!MaTransactionLogEntry methodsFor: 'testing' stamp: 'cmm 10/15/2004 16:56'!
hasExcessiveNumberOfChallengers

	^ challengingEntries size > self connection maximumNumberOfChallengers
! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 5/14/2005 17:46'!
id
	^ id! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 5/14/2005 17:46'!
id: anInteger
	id _ anInteger! !

!MaTransactionLogEntry methodsFor: 'private' stamp: 'cmm 3/20/2005 20:20'!
initialize
	"of MaTransactionLogEntries or MaCommitLogEntries that challenge me."

	super initialize.
	challengingEntries _ OrderedCollection new.
	self initializeResult.
	needsToRefresh _ false.
	self initializeServerNotifications! !

!MaTransactionLogEntry methodsFor: 'private' stamp: ''!
initializeResult

	result _ MaRefreshViewResult new
! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 5/19/2004 00:20'!
initializeServerNotifications

	serverNotifications _ Dictionary new! !

!MaTransactionLogEntry methodsFor: 'testing' stamp: ''!
isCommitEntry

	^false
! !

!MaTransactionLogEntry methodsFor: 'testing' stamp: 'cmm 3/3/2002 19:00'!
isForSameSessionAs: aMaTransactionLogEntry

	^self connection == aMaTransactionLogEntry connection
! !

!MaTransactionLogEntry methodsFor: 'printing' stamp: 'cmm 6/20/2004 12:06'!
maPrintAbbreviatedOn: aStream

	aStream
		maPrint: '(' ;
		maPrint: self sessionId ;
		maPrint: ') ' ;
		maPrint: result userId! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 12/16/2002 23:28'!
needsToRefresh: aBoolean

	needsToRefresh _ aBoolean! !

!MaTransactionLogEntry methodsFor: 'recovery' stamp: 'cmm 7/15/2005 14:22'!
postTrimmedCopy
	"We do this for performance.  We no longer need these fields, and we're about to serialize the receiver."

	challengingEntries _ nil.
	serverNotifications _ nil.
	result _ result trimmedCopy! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:56'!
recordAllChangedObjects
	"Record all of the objects that the client will need to refresh."

	challengingEntries do: [ :each | result addToBeRefreshed: each committed ]
! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 7/11/2005 15:40'!
recordChangesToSpecialObjectsIn: aMaCommitLogEntry using: aMaTransactionLog

	aMaTransactionLog specialOidsDo:
		[ : eachOid : eachKey |
		(aMaCommitLogEntry hasCommitted: eachOid)
			ifTrue:
				[ aMaCommitLogEntry noteDidCommitSpecialOid.
				self
					ensureWillCall: eachKey
					at: eachOid ] ]! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 12/25/2002 12:48'!
renewRefreshFlag

	| answer |
	answer _ needsToRefresh & self isCommitEntry not.
	self needsToRefresh: false.
	^answer! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 5/19/2004 22:43'!
renewServerNotifications

	| answer |
	answer _ serverNotifications.
	serverNotifications notEmpty ifTrue: [ self initializeServerNotifications ].
	^ answer! !

!MaTransactionLogEntry methodsFor: 'private' stamp: ''!
result

	^result! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:58'!
sessionId

	^ result sessionId
! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:58'!
startTime

	^ result startTime
! !

!MaTransactionLogEntry methodsFor: 'recovery' stamp: 'cmm 7/8/2005 16:10'!
trimmedCopy
	"Make a copy without things needed merely to applyToCache: so that serialization to the commitPackages recovery file will be quicker."

	^ self copy postTrimmedCopy! !

MagmaWarning subclass: #MagmaRecoveryNeeded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaFixedObjectBuffer methodsFor: '*magma server' stamp: 'cmm 5/2/2005 12:05'!
graphDo: oneArgBlock using: aMaReadStrategy for: aMagmaFileTraverser inDefinition: aBoolean

	aMagmaFileTraverser
		graphFromPointers: self
		do: oneArgBlock
		using: aMaReadStrategy.
	(aBoolean not and: [ aMagmaFileTraverser isOidForLargeCollection: self oid ])
		ifTrue:
			[ aMagmaFileTraverser
				graphFromLargeCollection: self oid
				do: oneArgBlock
				using: aMaReadStrategy ]! !

!MaByteObjectBuffer methodsFor: '*magma server' stamp: 'cmm 1/25/2005 14:07'!
appendGraphUsing: aMaReadStrategy into: aMaSerializedGraphBuffer currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	"Nothing to do for a byte-object."
! !

!MaByteObjectBuffer methodsFor: '*magma server' stamp: 'cmm 5/1/2005 23:05'!
graphDo: oneArgBlock using: aMaReadStrategy for: aMagmaFileTraverser inDefinition: aBoolean

	"nothing to do for a Byte-object buffer."! !

!MaLoadProgressRequest methodsFor: '*magma server' stamp: 'cmm 7/26/2006 20:26'!
process
	^ self repository fractionLoaded: collectionOid! !

!MagmaLargeCollectionChanges methodsFor: '*magma server' stamp: 'cmm 3/16/2005 15:13'!
requiresServerRefresh

	^ self isNewCollection! !

!MagmaSession class methodsFor: '*magma server-private' stamp: 'cmm 2/8/2005 21:44'!
newLocalLinkFor: aMagmaRepositoryController

	^ MaLocalServerLink localRequestServer: (MaLocalRequestServer processor: aMagmaRepositoryController)! !

!MagmaSession class methodsFor: '*magma server' stamp: 'kph 10/4/2006 13:15'!
openLocal: location

	^ self repositoryController: (MagmaRepositoryController openedOn: location)! !

!MagmaSession class methodsFor: '*magma server' stamp: 'cmm 12/26/2004 23:21'!
repositoryController: aMagmaRepositoryController
	"Use this constructor only for *additional* local connections, i.e., two or more sessions connected to the same local repository.  Use the same MagmaRepositoryController you used to create the original."

	^ self link: (self newLocalLinkFor: aMagmaRepositoryController)! !

!MagmaSession methodsFor: '*magma server' stamp: 'cmm 2/15/2005 10:51'!
ensureOpen

	self isLocal ifFalse: [ MagmaUserError signal: 'Only available for local connections.' ].
	self isOpen ifFalse:
		[ self link: (self class newLocalLinkFor: (MagmaRepositoryController openedOn: self pathName)) ]! !

!MagmaSession methodsFor: '*magma server' stamp: 'cmm 1/13/2005 18:01'!
isOpen
	^ self isRemote 
	or: [ "local" self repositoryController isOpen ]! !

!MagmaSession methodsFor: '*magma server' stamp: 'cmm 1/13/2005 18:01'!
repositoryController

	^ link localRequestServer processor! !

!MaStorageObjectBuffer methodsFor: '*magma server' stamp: 'cmm 5/2/2005 13:49'!
graphDo: oneArgBlock using: aMaReadStrategy for: aMagmaFileTraverser inDefinition: aBoolean
	"Though I am an object stored in a different representation, that representation is fully part of the repository, so enumerate the buffers my MaSerializedGraphBuffers buffers."

	oneArgBlock value: self.
	self buffersDo:
		[ : eachBuffer |
		"The buffers of a storage-object are never assigned permanent oids.  But if already-persistent objects are referenced from the storage-object, they will be and should be traversed normally."
		(MaOidCalculator isOidForUserObject: eachBuffer oid)
			ifTrue:
				[ eachBuffer
					graphDo: oneArgBlock
					using: aMaReadStrategy
					for: aMagmaFileTraverser
					inDefinition: aBoolean ]
			ifFalse:
				[ oneArgBlock value: eachBuffer ] ]! !

!MagmaLargeCollectionSegment methodsFor: '*magma server-private' stamp: 'cmm 4/12/2006 21:15'!
collectBuffers: sessionId from: aMaObjectRepository using: aMaReadStrategy 
	| readStrategy |
	readStrategy _ aMaObjectRepository 
		ensureReadStrategy: aMaReadStrategy
		forSession: sessionId.
	self objects: 
		(self objects collect: 
			[ : each | 
			aMaObjectRepository 
				byteArrayAt: each
				using: readStrategy ])! !

!MaLoadFromReaderRequest methodsFor: '*magma server' stamp: 'cmm 7/3/2006 13:00'!
process
	^ self repository 
		load: collection
		using: expression
		from: sourceCollectionOid
		forSession: sessionId
		distinct: distinct! !

PackageInfo subclass: #MagmaServerPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Info'!

!MagmaServerPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 10/31/2004 23:42'!
changesText

	^'
1.0gamma8
	- removed "allowNewClasses" feature.  This will be handled with real security later.
	- all administration functions are now either remote requests or no longer needed.
	- support for first-class MagmaRepositoryCodeBase.

1.0gamma7
	- Compatible with Squeak 3.7.
	- Better support for Symbols (thanks to Brent Pinkney!!).
	- fix for storing Exceptions in the repository (to accommodate changes in Squeak 3.6).
	- New Date index type for MagmaCollections.
	- New Float index type for MagmaCollections.
	- MagmaSessions cleaned from MethodContext receivers, allowing full garbage collection (thanks to Giovanni!!).
	- Critical bugs with MagmaCollections fixed and now pass the new, extra-stringent tests in the Tester package.
	
1.0gamma6
	- works with Squeak 3.6.  Doesn''t work with versions before 3.6.
	- fixed issue with servers that were running when the image was saved (functionality implemented in 1.0gamma5).  Fixed similar bug for saving with open local repository connections.
	- disconnect now cleans up the proxies for that session.  Please be patient, this can take a while if you have a lot.  Also now cleaning dynamic largeCollection attributes when disconnecting a session.
	- fixed bug with creating repository using an unqualified file name.
	- fixed an unnoticed reference to platform-specific code (ByteArray>>unsignedByteAt: uses FFI primitives).
	- improved the internal system-read-strategy.


1.0gamma5
	- Servers and clients can now survive image restarts.
	- added a new session preference (see MagmaPreferences), "signalProxyMaterialization" so you can capture MagmaNotifications and fine-tune your read strategies.
	- Another performance improvement!!  ReadStrategies are now cached on the server, instead of in your MagmaSession, improving read-efficiency when using read strategies because the strategy-object no longer needs to be serialized and transported for every proxy materialization.  Additionally, ReadStrategies for classes that don''t exist in the repository are no longer dropped.  Instead, they are remembered until you put those classes into the repository.
	- commit conflicts no longer provide the entire MagmaClientConnection object who conflicted with your session, just the userId.  This is due to the aforementioned cached readStrategy, no need to be sending that down on a commit conflict.
	- Since we have eradicated the "root trap" we can make replacing the root consistent with other Magma changes.  A transaction is now required.
	- several bug fixes.
'! !

!MagmaServerPackageInfo methodsFor: 'accessing' stamp: 'cmm 4/8/2004 21:30'!
prerequisitePackages
	^ #( 'Magma client' 'Ma time objects' )! !

!MagmaServerPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 2/4/2003 18:12'!
readmeText

	^'This package is used to host a Magma repository.  For more information visit http://minnow.cc.gatech.edu/squeak/2665.'! !

!ReadWriteStream methodsFor: '*magma server' stamp: 'cmm 5/31/2005 17:53'!
maRead: someNumber bytesFromPosition: bufferPosition of: aByteArray atFilePosition: filePosition

	^ self
		position: filePosition ;
		readInto: aByteArray
		startingAt: bufferPosition
		count: someNumber! !

!ReadWriteStream methodsFor: '*magma server' stamp: 'cmm 5/7/2005 22:55'!
maWrite: numberOfBytes bytesFromPosition: bufferPosition of: byteArray atFilePosition: filePosition

	self position: filePosition.
	self
		next: numberOfBytes
		putAll: byteArray
		startingAt: bufferPosition! !

!ReadWriteStream methodsFor: '*magma server' stamp: 'cmm 6/15/2005 15:15'!
readInto: aByteArray startingAt: startIndex count: numberOfBytes
	"Read n objects into the given collection.  Return the number of bytes read."

	| count |
	count _ 0.
	[ count < numberOfBytes ]
		whileTrue:
			[ | byte |
			byte _ self next.
			byte
				ifNil: [ ^ count ]
				ifNotNil:
					[ aByteArray
						at: startIndex+count
						put: byte ].
			count _ count + 1 ].
	^ count! !

!MaClause methodsFor: '*magma server-private' stamp: 'cmm 6/3/2006 14:47'!
addMinimumEnumerationsTo: aMaQueryTrunk using: aMagmaLargeCollectionManager 
	aMaQueryTrunk addClause: 
		(self asTrunkClause
			lastKnownSize:
				((aMagmaLargeCollectionManager oidsIndexForAttribute: attribute) 
					numberOfEntriesFrom: lowKey
					to: highKey))! !

!MaClause methodsFor: '*magma server-private' stamp: 'cmm 4/13/2006 17:05'!
minimumSearchSpaceSizeUsing: aMagmaCollectionManager 
	^ (aMagmaCollectionManager oidsIndexForAttribute: attribute) 
		numberOfEntriesFrom: lowKey
		to: highKey! !

!MaClause methodsFor: '*magma server-private' stamp: 'cmm 4/13/2006 17:13'!
shouldInclude: oid using: aMagmaCollectionManager 
	"in the keys indexes, the oid is the key, the key is the value."
	(aMagmaCollectionManager keysIndexForAttribute: attribute) 
		entriesFrom: oid
		do: 
			[ : eachRecord : bax : level | 
			((eachRecord valueAtByteArrayIndex: bax) "key"
				between: lowKey
				and: highKey) ifTrue: [ ^ true ] ]
		until: 
			[ : eachRecord : bax : level | 
			(eachRecord keyAtByteArrayIndex: bax) > oid ].
	^ false! !

!MagmaLargeCollection methodsFor: '*magma server' stamp: 'cmm 3/16/2005 12:53'!
newManagerUsing: aMagmaSession

	self subclassResponsibility! !

!MagmaArray methodsFor: '*magma server' stamp: 'cmm 7/12/2005 12:52'!
implementationClass

	^ MaLargeArrayOfNumbers! !

!MagmaArray methodsFor: '*magma server' stamp: 'cmm 3/17/2005 21:33'!
newManagerUsing: aMaObjectRepository

	^ MagmaArrayManager
		collection: self
		repository: aMaObjectRepository! !

!MaFileRecordBroker methodsFor: '*magma server-recovery' stamp: 'cmm 6/3/2005 17:28'!
fileSize
	^ file size! !

!MaFileRecordBroker methodsFor: '*magma server-recovery' stamp: 'cmm 7/6/2005 22:52'!
filesDo: oneArgBlock

	oneArgBlock value: file! !

!MaFileRecordBroker methodsFor: '*magma server-recovery' stamp: 'cmm 6/1/2005 13:19'!
recoverUsing: aMaBeforeImageRecord

	file
		maWrite: aMaBeforeImageRecord recordSize
		bytesFromPosition: 1
		of: aMaBeforeImageRecord record
		atFilePosition: aMaBeforeImageRecord location! !

!MaFileRecordBroker methodsFor: '*magma server-recovery' stamp: 'cmm 7/12/2005 22:45'!
unapplyUsing: aMaApplyRecord

	aMaApplyRecord unapplySelf: file physicalStream! !

!MaRecordBroker methodsFor: '*magma server-recovery' stamp: 'cmm 7/5/2005 22:29'!
filesDo: aBlock
	"nothing to do by default."! !

MagmaNotification subclass: #MagmaRecoveryNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Recovery'!

!MaCommitPackage methodsFor: '*magma server' stamp: 'cmm 4/5/2005 21:34'!
shouldServerRefresh
	"Anytime a largeCollection domain object changes, the server should
	refresh so we process all of the new large collections or their new
	indexes."

	^ allLargeCollectionChanges notNil
	and: [ allLargeCollectionChanges anySatisfy: [ :each | each requiresServerRefresh ] ]! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 1/25/2005 14:58'!
appendGraphNode: oid into: aMaSerializedGraphBuffer using: aMaReadStrategy currentDepth: anInteger minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	| buffer |

	(alreadyAppendedSet includes: oid) ifTrue: [ ^self ].
	alreadyAppendedSet add: oid.
	buffer _ aMaObjectFiler
		appendObject: oid
		into: aMaSerializedGraphBuffer.
	buffer
		appendGraphUsing: aMaReadStrategy
		into: aMaSerializedGraphBuffer
		currentDepth: anInteger + 1
		minDepth: minDepth
		with: alreadyAppendedSet
		filer: aMaObjectFiler! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 1/25/2005 14:01'!
appendGraphUsing: aMaReadStrategy into: aMaSerializedGraphBuffer currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	1
		to: self objectInstSize
		do:
			[ :varIndex | | oid |
			(MaOidCalculator isOidForOptimizedObject: (oid _ self maInstVarAt: varIndex))
				ifFalse:
					[ | newMinDepth |
					currentDepth < (
						newMinDepth _
							(aMaReadStrategy
								depthOfAttribute: varIndex
								onClassWithId: self classId
								version: self classVersion) + currentDepth
									max: minDepth)
										ifTrue:
											[ self
												appendGraphNode: oid
												into: aMaSerializedGraphBuffer
												using: aMaReadStrategy
												currentDepth: currentDepth
												minDepth: newMinDepth
												with: alreadyAppendedSet
												filer: aMaObjectFiler ] ] ]
! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 3/28/2005 21:53'!
asSentientBuffer
	"Answer the newwwwwww meeee!!  That's right!!  I've been injected
	with the ByteArray-of-truth and now know what kind of buffer
	I always wondered I was going to grow up to be."

	^self species
		createFromByteArray: byteArray
		startPos: startPos! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 5/24/2005 17:20'!
bufferPositionOfBytesToStore
	"Default 1-based position of the byte within each byteArray that we start storing to disk at."

	^ 7! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 5/1/2005 22:57'!
graphDo: oneArgBlock using: aMaReadStrategy for: aMagmaFileTraverser inDefinition: aBoolean

	self subclassResponsibility! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 11/24/2004 13:35'!
numberOfBytesToStore
	"Answer the number of bytes that should be stored for this buffer.  This is used by Magma, which doesn't need to store the oid since that is kept in the oid table."

	^self physicalSize - self bufferPositionOfBytesToStore + 1! !

!MaReadStrategy methodsFor: '*magma server' stamp: 'cmm 1/26/2005 12:22'!
depthOfAttribute: attributeIndex onClassWithId: classId version: versionNumber
	"Answer the depth that the attribute at attributeIndex should be traversed into *from the current depth*."

	^depths
		maAt: { classId. versionNumber }
		ifPresent:
			[ :depth |
			depth isInteger
				ifTrue: [ depth ]
				ifFalse: [ depth at: attributeIndex ifAbsent: [ 0 ] ] ]
		ifAbsent: [ 0 ]! !

!MaLargeArrayOfNumbers methodsFor: '*magma server' stamp: 'cmm 3/22/2005 18:07'!
do: aBlock for: aMagmaFileTraverser using: aMaReadStrategy

	1 to: self size do:
		[ : x |  | oid |
		(oid _ self at: x) ~= 0
			ifTrue:
				[ aMagmaFileTraverser
					graphFrom: oid
					do: aBlock
					using: aMaReadStrategy ] ]! !

!MaVariableBuffer methodsFor: '*magma server' stamp: 'cmm 5/2/2005 12:04'!
graphDo: oneArgBlock using: aMaReadStrategy for: aMagmaFileTraverser inDefinition: aBoolean

	aMagmaFileTraverser
		graphFromPointers: self
		do: oneArgBlock
		using: aMaReadStrategy! !

MaRequestServerConsole subclass: #MagmaServerConsole
	instanceVariableNames: 'server controller statistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-API'!

!MagmaServerConsole methodsFor: 'accessing' stamp: 'cmm 12/18/2002 21:52'!
controller

	^controller! !

!MagmaServerConsole methodsFor: 'initializing' stamp: 'cmm 12/24/2002 15:50'!
initialize
	super initialize.
	statistics := MagmaServerStatistics new! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/5/2003 22:56'!
noteProcessingRequest: yourRequestObject

	statistics startRequestTimer! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/5/2003 22:53'!
noteRequestDequeued: requestByteArray for: aSocket
	"Indicates aSocket has delivered a ByteArray request that is about to be processed by my server."

	statistics decrementRequestsQueued! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 2/4/2003 12:36'!
noteRequestProcessed: requestObject

	statistics stopRequestTimer! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/5/2003 22:44'!
noteRequestQueued: aByteArray for: aSocket
	"Indicates aSocket has delivered aByteArray as a request that it wants processed and the response returned."

	statistics
		incrementRequestsQueued;
		recordRequestSize: aByteArray size! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 2/4/2003 13:09'!
noteResponseSent: aByteArray to: aSocket
	"Successfully sent the aByteArray to aSocket."

	statistics recordResponseSize: aByteArray size! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 4/30/2003 17:44'!
noteServerShutdown

	controller close.
	statistics stopTime: MaCalendarTime now.
	self note: controller printString, ' closed.'! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/5/2003 18:19'!
noteSocketDequeued: aSocket

	statistics decrementSocketsQueued! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 10/7/2002 22:06'!
noteSocketQueued: aSocket

	statistics incrementSocketsQueued! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/4/2003 17:17'!
note: stringMessage

	Transcript cr; show: stringMessage! !

!MagmaServerConsole methodsFor: 'start / stop' stamp: 'kph 10/4/2006 13:36'!
open: pathNameOrLocation

	controller _ MagmaRepositoryController open: (MagmaLocalLocation path: pathNameOrLocation)! !

!MagmaServerConsole methodsFor: 'deprecated' stamp: 'cmm 6/13/2005 17:27'!
open: filename processOn: port
self deprecated: 'Use #open: followed by #processOn:  separately.'.
	self
		open: filename ;	
		processOn: port! !

!MagmaServerConsole methodsFor: 'start / stop' stamp: 'cmm 6/13/2005 14:10'!
processOn: portInteger

	server _ (MaTcpRequestServer protocol: controller protocol) console: self.
	statistics startTime: MaCalendarTime now.
	server 
		processOn: portInteger
		using: [ :eachRequest | controller processRequest: eachRequest ].
	^ self! !

!MagmaServerConsole methodsFor: 'accessing' stamp: 'cmm 3/3/2005 10:10'!
server

	^ server! !

!MagmaServerConsole methodsFor: 'start / stop' stamp: 'cmm 10/7/2002 00:42'!
shutdown

	server shutdown! !

!MagmaServerConsole methodsFor: 'accessing' stamp: 'cmm 1/27/2004 15:55'!
statistics

	^statistics! !

!MaReaderTrunkRequest methodsFor: '*magma server' stamp: 'cmm 8/6/2006 18:29'!
process
	^ self repository 
		getTrunkFor: collectionOid
		expression: expression! !

!MaBasicReadStrategy methodsFor: '*magma server' stamp: 'cmm 1/26/2005 17:28'!
depthOfAttribute: attributeIndex onClassWithId: classId version: versionNumber
	"Answer the delta-depth from the current depth to read.  This is distinct from my minimumDepth, which was used at the start of this graph-read."

	^ 0! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 6/8/2005 17:07'!
indexPositionForOid: anInteger

	^ anInteger - self firstUserObjectOid + 1! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 8/13/2002 23:57'!
isOidForOptimizedObject: oidInteger
	"Answer whether oidInteger is an oid for anObject which will never require its own buffer.  These include optimized Integers, nil, true, false, and all Characters."

	^(self isOidForNewObject: oidInteger) not
		and: [ (self isOidForUserObject: oidInteger) not ]! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 11/13/2002 23:05'!
isOidForUserObject: anInteger
	"A 'user' object is a persistent object stored in a Magma database that does not have a special oid, such as SmallIntegers, Floats, Booleans, etc. have."

	^anInteger
		between: self firstUserObjectOid
		and: self lastUserObjectOid! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 4/21/2005 15:41'!
lastUserObjectOid

	^ 281468533259712   "self oidForSmallestFloat - 1"! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 12/2/2004 13:32'!
oidForFilePositionIndexPosition: anInteger

	^ self firstUserObjectOid + anInteger! !

!MaExpression methodsFor: '*magma server-private' stamp: 'cmm 5/31/2006 20:23'!
addMinimumEnumerationsTo: aMaQueryTrunk using: aMagmaLargeCollectionManager 
	"For each OR'd condition, we must add a new range to aMaQueryTrunk.  Within each OR, we select the shortest ANDed condition to add to aMaQueryTrunk."
	self isConjunction 
		ifTrue: 
			[ | smallest smallestSize |
			smallest _ smallestSize _ nil.
			self terms do: 
				[ : each | 
				| eachSize |
				eachSize _ each minimumSearchSpaceSizeUsing: aMagmaLargeCollectionManager.
				(smallest isNil or: [ eachSize < smallestSize ]) ifTrue: 
					[ smallest _ each.
					smallestSize _ eachSize ] ].
			smallest 
				addMinimumEnumerationsTo: aMaQueryTrunk
				using: aMagmaLargeCollectionManager ]
		ifFalse: 
			[ self terms do: 
				[ : each | 
				each 
					addMinimumEnumerationsTo: aMaQueryTrunk
					using: aMagmaLargeCollectionManager ] ]! !

!MaExpression methodsFor: '*magma server-private' stamp: 'cmm 4/12/2006 16:26'!
minimumSearchSpaceSizeUsing: aMaLargeCollectionManager 
	| calculateSizeBlock |
	calculateSizeBlock _ 
	[ : each | 
	each minimumSearchSpaceSizeUsing: aMaLargeCollectionManager ].
	^ self isConjunction 
		ifTrue: [ self terms detectMin: calculateSizeBlock ]
		ifFalse: [ self terms detectSum: calculateSizeBlock ]! !

!MaExpression methodsFor: '*magma server-private' stamp: 'cmm 4/12/2006 00:22'!
shouldInclude: oid using: aMagmaCollectionManager 
	^ self isConjunction 
		ifTrue: 
			[ self terms allSatisfy: 
				[ : each | 
				each 
					shouldInclude: oid
					using: aMagmaCollectionManager ] ]
		ifFalse: 
			[ self terms anySatisfy: 
				[ : each | 
				each 
					shouldInclude: oid
					using: aMagmaCollectionManager ] ]! !
MagmaRepositoryController initialize!
MagmaServerPreferences initialize!
MaObjectRepository initialize!
MaRecoveryRecord initialize!
